-- dynamicke nahravanie z M+ Database
-- prekopat aury, je to strasny bordel
-- spark size, alpha
-- preco do config not L.isSelfTank ?
-- link v chate "add spell ..." otvori M+ Database na danom spelle
-- moznost v spellCD vynut precombat timer ?

--[[flag
	0x01	-- normal
	0x02	-- Heroic
	0x04	-- M0
	0x08	-- M+
	0x10	-- no instance
	0x20	-- noInteruptible
	0x40	-- casting
	0x80	-- channeling
	0x100	-- sucedded instant
	0x200	-- CL instant
	0x400	-- refectable
]]--

local _, L = ...
local mediaFolder = "Interface\\AddOns\\".._.."\\Media\\"

local LCG = LibStub('LibCustomGlow-2.0')
local RCH = LibStub("LibRangeCheck-2.0")
local LSM = LibStub('LibSharedMedia-3.0')
local LGI = LibStub("LibGroupInSpecT-1.1")

local _G = _G
local tostring = tostring
local tonumber = tonumber
local select = select
local unpack = unpack
local pairs = pairs
local ipairs = ipairs
local print = print
local table_insert = table.insert
local table_sort = table.sort
local table_remove = table.remove
local table_concat = table.concat
local string_char = string.char
local string_byte = string.byte
local string_len = string.len
local string_gsub = string.gsub
local string_match = string.match
local string_gmatch = string.gmatch
local string_format = string.format
local string_find = string.find
local math_fmod = math.fmod
local math_floor = math.floor
local math_ceil = math.ceil
local math_max = math.max
local Lerp = Lerp

local SetCVar = SetCVar
local GetCVar = GetCVar
local WorldFrame = WorldFrame
local CreateFrame = CreateFrame
local SetFrameLevel = SetFrameLevel
local ClearAllPoints = ClearAllPoints
local CreateFontString = CreateFontString
local CreateTexture = CreateTexture
local GetStringHeight = GetStringHeight
local SetShadowColor = SetShadowColor
local SetShadowOffset = SetShadowOffset
local SetVertexColor = SetVertexColor
local SetTexture = SetTexture
local PlaySoundFile = PlaySoundFile
local CombatLogGetCurrentEventInfo = CombatLogGetCurrentEventInfo
local C_NamePlate_GetNamePlateForUnit = C_NamePlate.GetNamePlateForUnit
local C_NamePlate_GetNamePlates = C_NamePlate.GetNamePlates
local C_NamePlate_SetNamePlateEnemyClickThrough = C_NamePlate.SetNamePlateEnemyClickThrough
local C_NamePlate_SetNamePlateEnemySize = C_NamePlate.SetNamePlateEnemySize
local C_NamePlate_SetNamePlateEnemyPreferredClickInsets = C_NamePlate.SetNamePlateEnemyPreferredClickInsets
local C_NamePlate_SetNamePlateFriendlyClickThrough = C_NamePlate.SetNamePlateFriendlyClickThrough
local C_NamePlate_SetNamePlateFriendlySize = C_NamePlate.SetNamePlateFriendlySize
local C_NamePlate_SetNamePlateFriendlyPreferredClickInsets = C_NamePlate.SetNamePlateFriendlyPreferredClickInsets
local C_NamePlate_SetNamePlateSelfClickThrough = C_NamePlate.SetNamePlateSelfClickThrough
local C_NamePlate_SetNamePlateSelfSize = C_NamePlate.SetNamePlateSelfSize
local C_NamePlate_SetNamePlateSelfPreferredClickInsets = C_NamePlate.SetNamePlateSelfPreferredClickInsets
local C_Timer_NewTimer = C_Timer.NewTimer
local C_Timer_After = C_Timer.After
local hooksecurefunc = hooksecurefunc
local IsInInstance = IsInInstance
local UnitAffectingCombat = UnitAffectingCombat
local UnitCanAttack = UnitCanAttack
local UnitExists = UnitExists
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local UnitHasVehicleUI = UnitHasVehicleUI
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitIsPlayer = UnitIsPlayer
local UnitIsUnit = UnitIsUnit
local UnitIsFriend = UnitIsFriend
local UnitName = UnitName
local GetUnitName = GetUnitName
local UnitIsDeadOrGhost = UnitIsDeadOrGhost
local GetSpellInfo = GetSpellInfo
local GetSpellCooldown = GetSpellCooldown
local UnitWidgetSet = UnitWidgetSet
local UnitNameplateShowsWidgetsOnly = UnitNameplateShowsWidgetsOnly
local UnitPowerType = UnitPowerType
local GetPlayerInfoByGUID = GetPlayerInfoByGUID
local UnitGUID = UnitGUID
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local GetContainerNumSlots = GetContainerNumSlots or C_Container.GetContainerNumSlots
local GetContainerItemID = GetContainerItemID or C_Container.GetContainerItemID
local GetContainerItemLink = GetContainerItemLink or C_Container.GetContainerItemLink
local GetContainerNumFreeSlots = GetContainerNumFreeSlots or C_Container.GetContainerNumFreeSlots
local GetContainerItemInfo = GetContainerItemInfo or C_Container.GetContainerItemInfo
local PickupContainerItem = PickupContainerItem or C_Container.PickupContainerItem
local C_QuestLog_IsOnQuest = C_QuestLog.IsOnQuest
local C_QuestLog_GetNumQuestLogEntries = C_QuestLog.GetNumQuestLogEntries
local C_QuestLog_GetTitleForLogIndex = C_QuestLog.GetTitleForLogIndex
local C_QuestLog_GetQuestIDForLogIndex = C_QuestLog.GetQuestIDForLogIndex
local C_QuestLog_GetQuestObjectives = C_QuestLog.GetQuestObjectives
local C_QuestLog_IsComplete = C_QuestLog.IsComplete
local C_Scenario_GetCriteriaInfo = C_Scenario.GetCriteriaInfo
local C_Scenario_GetStepInfo = C_Scenario.GetStepInfo

local QuestPlateTooltip = CreateFrame('GameTooltip', 'QuestPlateTooltip', nil, 'GameTooltipTemplate')
local HEALERS_TABLE = {}
local NPC_TABLE = {}
local hasMouseover, hasReflect = false, false
local tQuantity
local USED_RAID_MARKS = {}

namePlateMixin = {}
namePlateMixin.PARTY_TABLE = {}

--[[ Pomocne funkcie ]]--
function namePlateMixin:MultiCheck(check, ...)
	for i = 1, select("#", ...) do
		if check == select(i, ...) then return true end  
	end  
	return false  
end

function namePlateMixin:GetTextColorByGUID(unitGUID, text)
	local _, englishClass = GetPlayerInfoByGUID(unitGUID)
	if (englishClass) then
		local classColor = RAID_CLASS_COLORS[englishClass]
		if (classColor) then
			return "|c" .. classColor.colorStr .. text .. "|r"
		end
	else
		return "|cffff0000" .. text .. "|r"
	end
end
 
function namePlateMixin:CreateMyText(self, font, fontsize, outline, layer, align, justifyH, shadow)
	local text = self:CreateFontString(nil, layer or "OVERLAY", nil, 7)
		text:SetFont(LSM:Fetch(LSM.MediaType.FONT, font) or STANDARD_TEXT_FONT, fontsize or 14, outline or "OUTLINE")
		text:SetPoint(align or "CENTER")
		text:SetJustifyH(justifyH or "CENTER")
		text:SetText(nil)
		text:SetMaxLines(1)
		text:SetHeight(text:GetStringHeight())
		if shadow then
			text:SetShadowColor(0, 0, 0, .6)
			text:SetShadowOffset(1, -1)
		end	
	return text
end	

function namePlateMixin:SetMyBorderColor(frame, r, g, b, a)
	frame.top:SetVertexColor(r or 0, g or 0, b or 0, a or 1)
	frame.bottom:SetVertexColor(r or 0, g or 0, b or 0, a or 1)
	frame.left:SetVertexColor(r or 0, g or 0, b or 0, a or 1)
	frame.right:SetVertexColor(r or 0, g or 0, b or 0, a or 1)
end

function namePlateMixin:SetMyBorderColorByUnit(frame)
	local parentFrame = frame:GetParent():GetParent()
	local r, g, b, a = UnitSelectionColor(parentFrame.unit, true)
	if L.config.healthbar_border_top[parentFrame.unitType] then
		frame.top:SetVertexColor(r, g, b, a)
	else
		frame.top:SetVertexColor(0, 0, 0, 1)
	end
	if L.config.healthbar_border_bottom[parentFrame.unitType] then
		frame.bottom:SetVertexColor(r, g, b, a)
	else
		frame.bottom:SetVertexColor(0, 0, 0, 1)
	end
	if L.config.healthbar_border_left[parentFrame.unitType] then
		frame.left:SetVertexColor(r, g, b, a)
	else
		frame.left:SetVertexColor(0, 0, 0, 1)
	end
	if L.config.healthbar_border_right[parentFrame.unitType] then
		frame.right:SetVertexColor(r, g, b, a)
	else
		frame.right:SetVertexColor(0, 0, 0, 1)
	end
end

function namePlateMixin:SetMyBorderSize(frame, size)
	PixelUtil.SetHeight(frame.top, size, 1)
	PixelUtil.SetHeight(frame.bottom, size, 1)
	PixelUtil.SetWidth(frame.left, size, 1)
	PixelUtil.SetWidth(frame.right, size, 1)	
end

function namePlateMixin:CreateMyBackdrop(parent, pixelSize, r_br, g_br, b_br, a_br, bgTexture, r_bg, g_bg, b_bg, a_bg, shadow_offset, r_s, g_s, b_s, a_s)
	local frame = CreateFrame("Frame", nil, parent)
		frame:SetFrameLevel(parent:GetFrameLevel()-1)
		frame:ClearAllPoints()
		frame:SetAllPoints(parent)
				
		frame.top = frame:CreateTexture(nil, "OVERLAY")
		frame.top:ClearAllPoints()
		PixelUtil.SetPoint(frame.top, "BOTTOMLEFT", frame, "TOPLEFT", 0, 0)
		PixelUtil.SetPoint(frame.top, "BOTTOMRIGHT", frame, "TOPRIGHT", 0, 0)
		frame.top:SetTexture("Interface\\Buttons\\WHITE8x8")
		frame.top:Show()
		
		frame.bottom = frame:CreateTexture(nil, "OVERLAY")
		frame.bottom:ClearAllPoints()
		PixelUtil.SetPoint(frame.bottom, "TOPLEFT", frame, "BOTTOMLEFT", 0, 0)
		PixelUtil.SetPoint(frame.bottom, "TOPRIGHT", frame, "BOTTOMRIGHT", 0, 0)
		frame.bottom:SetTexture("Interface\\Buttons\\WHITE8x8")
		frame.bottom:Show()
		
		frame.left = frame:CreateTexture(nil, "OVERLAY")
		frame.left:ClearAllPoints()
		PixelUtil.SetPoint(frame.left, "TOPRIGHT", frame, "TOPLEFT", 0, pixelSize, 0, 1)
		PixelUtil.SetPoint(frame.left, "BOTTOMRIGHT", frame, "BOTTOMLEFT", 0, -pixelSize, 0, -1)
		frame.left:SetTexture("Interface\\Buttons\\WHITE8x8")
		frame.left:Show()
		
		frame.right = frame:CreateTexture(nil, "OVERLAY")
		frame.right:ClearAllPoints()
		PixelUtil.SetPoint(frame.right, "TOPLEFT", frame, "TOPRIGHT", 0, pixelSize, 0, 1)
		PixelUtil.SetPoint(frame.right, "BOTTOMLEFT", frame, "BOTTOMRIGHT", 0, -pixelSize, 0, -1)
		frame.right:SetTexture("Interface\\Buttons\\WHITE8x8")
		frame.right:Show()
		
		self:SetMyBorderColor(frame, r_br, g_br, b_br, a_br)
		self:SetMyBorderSize(frame, pixelSize)
		
		if bgTexture then
			frame.bg = frame:CreateTexture(nil, "BACKGROUND")
			frame.bg:ClearAllPoints()
			PixelUtil.SetPoint(frame.bg, "TOPLEFT", frame, "TOPLEFT", -1, 1)
			PixelUtil.SetPoint(frame.bg, "BOTTOMRIGHT", frame, "BOTTOMRIGHT", 1, -1)
			frame.bg:SetTexture(bgTexture)
			frame.bg:SetVertexColor(r_bg / 3 or 0, g_bg / 3 or 0, b_bg / 3 or 0, a_bg or 0)
		end
		
		if shadow_offset then
			frame.shadow = CreateFrame("Frame", nil, frame, "BackdropTemplate, BackdropFlashTemplate")
			frame.shadow:SetFrameLevel(parent:GetFrameLevel()-1)
			frame.shadow:ClearAllPoints()
			PixelUtil.SetPoint(frame.shadow, "TOPLEFT", frame, "TOPLEFT", - shadow_offset, shadow_offset)
			PixelUtil.SetPoint(frame.shadow, "BOTTOMRIGHT", frame, "BOTTOMRIGHT", shadow_offset, - shadow_offset)
			frame.shadow:SetBackdrop({bgFile = nil, edgeFile = mediaFolder.."glowTex", edgeSize = shadow_offset, tile = false, tileSize = 0, insets = 1})
			frame.shadow:SetBackdropBorderColor(r_s, g_s, b_s, a_s)
			frame.shadow:Hide()
		end
		
	return frame
end

local function round(number, precision)
	local fmtStr = string.format('%%0.%sf',precision)
	return tonumber(string.format(fmtStr,number))
end

function namePlateMixin:FormatTime(s)
	if s >= 86400 then
		return string_format("%dd", math_ceil(s / 86400)) 
	elseif s >= 3600 then
		return string_format("%dh", math_ceil(s / 3600))
	elseif s >= 60 then
		return string_format("%dm", math_ceil(s / 60))
	end
	return string_format("%d", s)
end

-- AbbreviateNumbers
function namePlateMixin:FormatHealthPoint(n)
    if not n then
		return
	elseif n < 1000 then
        return math_floor(n)
	elseif n < 1000000 then
		return string_format('%.1fk', n/1000)
	elseif n < 1000000000 then
		return string_format('%.2fM', n/1000000)
	else
		return string_format('%.3fG', n/1000000000)
    end
end

local cyr_to_lat = {["А"]="A",["а"]="a",["Б"]="B",["б"]="b",["В"]="V",["в"]="v",["Г"]="G",["г"]="g",["Д"]="D",["д"]="d",["Е"]="E",["е"]="e",["Ё"]="e",["ё"]="e",["Ж"]="Zh",["ж"]="zh",["З"]="Z",["з"]="z",["И"]="I",["и"]="i",["Й"]="Y",["й"]="y",["К"]="K",["к"]="k",["Л"]="L",["л"]="l",["М"]="M",["м"]="m",["Н"]="N",["н"]="n",["О"]="O",["о"]="o",["П"]="P",["п"]="p",["Р"]="R",["р"]="r",["С"]="S",["с"]="s",["Т"]="T",["т"]="t",["У"]="U",["у"]="u",["Ф"]="F",["ф"]="f",["Х"]="Kh",["х"]="kh",["Ц"]="Ts",["ц"]="ts",["Ч"]="Ch",["ч"]="ch",["Ш"]="Sh",["ш"]="sh",["Щ"]="Shch",["щ"]="shch",["Ъ"]="",["ъ"]="",["Ы"]="Y",["ы"]="y",["Ь"]="",["ь"]="",["Э"]="E",["э"]="e",["Ю"]="Yu",["ю"]="yu",["Я"]="Ya",["я"]="ya"}
function namePlateMixin:Translate(str)
	if not str then	return "" end
	if (str:sub(1, 1)) == "!" then return str end
	local tstr = ""
	local isTranslit = false
	local i = 1
	
	while i <= string_len(str) do
		local c = str:sub(i,i)
		local b = string_byte(c)
		if b == 208 or b == 209 then
			c = str:sub(i+1, i+1)
			tstr = tstr .. (cyr_to_lat[string_char(b, string_byte(c))] or string_char(b, string_byte(c)))
			i = i + 2
			isTranslit = true
		else
			tstr = tstr .. c
			i = i + 1
		end
	end
	
	return isTranslit and "!" .. tstr or tstr
end

function namePlateMixin:IsPartyName(sourceName)
	if sourceName == UnitName("player") then
		return 1
	else
		for i = 1, MAX_PARTY_MEMBERS do --for i = 1, GetNumSubgroupMembers() do
			if ( UnitExists("party"..i) ) then
				if sourceName == UnitName("party"..i) then
					return i+1
				end
			end
		end
	end
	return nil
end

function namePlateMixin:IsPartyGUID(sourceGUID)
	if sourceGUID == UnitGUID("player") then
		return 1
	else
		for i = 1, MAX_PARTY_MEMBERS do
			if ( UnitExists("party"..i) ) then
				if sourceGUID == UnitGUID("party"..i) then
					return i+1
				end
			end
		end
	end
	return nil
end

function namePlateMixin:IsUnitTank(unit)
	local assignedRole = UnitGroupRolesAssigned(unit);
	if ( assignedRole == "NONE" and UnitIsUnit("player", unit) ) then
		local spec = GetSpecialization()
		return spec and GetSpecializationRole(spec) == "TANK"
	end
	return assignedRole == "TANK"
end

function namePlateMixin:IsSpellReady(spellID)
	local _, duration = GetSpellCooldown(spellID)
	-- ignore GCD
	if ( duration < 1.5 ) then
		return true
	else
		return false
	end
end	

function namePlateMixin:InstanceOrParty()
	return (IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and "INSTANCE_CHAT") or (IsInRaid() and "RAID") or (IsInGroup(LE_PARTY_CATEGORY_HOME) and "PARTY")
end

function namePlateMixin:DebugLog(str, timeShow, playSound, saveToDebugLogData)
	if str then
		print("|cffff0000namePlateM+ :|r "..str)
	
		if timeShow then
			textPanelMixin:ShowText(str, timeShow)
		end
	
		if playSound then
			PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.config.quest_sound), L.config.sound_channel)
		end
		
		if saveToDebugLogData then
			DebugLogData = DebugLogData or {}
			table_insert(DebugLogData, str)
		end
	end
end

function namePlateMixin:AddSpellToDatabase(mapID, npcID, spellID, notInterruptible)
	L.MythicNPCData[mapID][npcID][spellID] = {}
	L.MythicNPCData[mapID][npcID][spellID].flag = notInterruptible and 0x20 or 0x00
		
	self:DebugLog("Add spell "..GetSpellLink(spellID).." to database for |cff00bbff"..L.MythicNPCData[mapID][npcID].destName.."|r.")

	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		if namePlate.UnitFrame.mapID == mapID and namePlate.UnitFrame.npcID == npcID then
			self:UpdateAllSpellCD(namePlate.UnitFrame, false)
		end
	end
end

local function CreateFlashFrame()
	local flashFrame = CreateFrame("Frame", "myFlashFrame", UIParent)
		flashFrame:SetAllPoints()
		flashFrame.bg = flashFrame:CreateTexture(nil, "BACKGROUND")
		flashFrame.bg:SetAllPoints()
		flashFrame.bg:SetTexture("Interface\\Buttons\\WHITE8X8")  --Interface\\Buttons\\WHITE8x8
--[[	Interface\\FullScreenTextures\\LowHealth
		Interface\\FrameGeneral\\UI-Background-Marble
		Interface\\FullScreenTextures\\OutOfControl
		Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal
		Interface\\AchievementFrame\\UI-GuildAchievement-Parchment-Horizontal
		Interface\\FrameGeneral\\UI-Background-Rock
		Interface\\TabardFrame\\TabardFrameBackground
		Interface\\Buttons\\WHITE8X8]]--
		flashFrame.bg:SetBlendMode("ADD")
	flashFrame:Hide()
end

-------------------------------------------
-- Aura funkcie
-- definicia vzhladu icony a aurach
local function CreateAura(parent, x, y)
	local aura = CreateFrame("Frame", nil, parent)
		aura:SetSize(x, y)
		aura.border = namePlateMixin:CreateMyBackdrop(aura, 1, 0, 0, 0, 1, nil, 0, 0, 0, 1)
		
		aura.icon = aura:CreateTexture(nil, "OVERLAY")
		aura.icon:SetAllPoints()
		aura.icon:SetTexCoord(.08, .92, 0.08, 0.92)
				
		aura.cd = CreateFrame("Cooldown", "$parentCooldown", aura, "CooldownFrameTemplate")
		aura.cd:SetAllPoints()
		
		aura.bar = CreateFrame("StatusBar", nil, aura)
		aura.bar:ClearAllPoints()
		PixelUtil.SetSize(aura.bar, x, L.config.aura_bar_debuff_height, 0, 0)
		PixelUtil.SetPoint(aura.bar, "TOP", aura, "TOP", 0, 0)
		aura.bar:SetMinMaxValues(0, 1)
		aura.bar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.player_resource_texture))
		aura.bar.border = namePlateMixin:CreateMyBackdrop(aura.bar, 1, 0, 0, 0, 1, LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.player_resource_texture), 0, 0, 0, 1)
		
		aura.timer1 = namePlateMixin:CreateMyText(aura, L.config.name_font_npc, y / 1.6, "OUTLINE", "OVERLAY", "CENTER", "LEFT", false)
		aura.timer1:SetPoint("TOPLEFT", aura, "TOPLEFT", 0, 0)
		aura.timer1:SetTextColor(1, 1, 0)
		aura.timer1:Hide()
		
		aura.timer2 = namePlateMixin:CreateMyText(aura.bar, L.config.name_font_npc, L.config.aura_bar_debuff_height, "OUTLINE", "OVERLAY", "CENTER", "LEFT", false)
		aura.timer2:SetPoint("LEFT", aura.bar, "LEFT", 0, 0)
		aura.timer2:SetTextColor(1, 1, 0)
		aura.timer2:Hide()
		
		aura.count1 = namePlateMixin:CreateMyText(aura, L.config.name_font_npc, y / 1.6, "OUTLINE", "OVERLAY", "CENTER", "RIGHT", false)
		aura.count1:SetPoint("TOPRIGHT", aura, "TOPRIGHT", 0, 0)
		aura.count1:SetTextColor(.6, .8, 1)
		
		aura.count2 = namePlateMixin:CreateMyText(aura.bar, L.config.name_font_npc, L.config.aura_bar_debuff_height, "OUTLINE", "OVERLAY", "CENTER", "RIGHT", false)
		aura.count2:SetPoint("RIGHT", aura.bar, "RIGHT", 0, 0)
		aura.count2:SetTextColor(.6, .8, 1)
		
		aura:SetMouseClickEnabled(false)
	return aura
end

-- update aura icony pri neakej zmene
local function UpdateAura(aura, name, icon, count, debuffType, duration, expirationTime, isStealable, spellID, showGlow, showAsBar)
	aura.icon:SetTexture(icon)
	aura.duration = duration
	aura.expirationTime = expirationTime
	aura.spellID = spellID
	aura.name = name
	aura.showAsBar = showAsBar
	aura.count = count
	
	-- zobraz ako iconu
	if not aura.showAsBar or L.AurasList["Control"][name] or isStealable then
		aura.bar:Hide()
		aura.cd:Show()
		aura.icon:Show()
		aura.border:Show()
		aura.timer2:Hide()
		aura.count1:Show()
		aura.count2:Hide()
		
		if L.config.aura_show_timer_icon then
			aura.timer1:Show()
		else
			aura.timer1:Hide()
		end
		
		if count and count > 1 then
			aura.count1:SetText(count)
		else
			aura.count1:SetText(nil)
		end
			
		if isStealable then
			namePlateMixin:SetMyBorderColor(aura.border, 0.2, 0.8, 1, 1)
			aura:SetSize(L.config.aura_icon_buff_width * L.config.aura_icon_buff_dispelable_size, L.config.aura_icon_buff_height * L.config.aura_icon_buff_dispelable_size)
		elseif L.AurasList["Control"][name] then -- showGlow or
			namePlateMixin:SetMyBorderColor(aura.border, unpack(L.AurasList["Control"][name]))
		else
			namePlateMixin:SetMyBorderColor(aura.border, 0, 0, 0, 1) 
		end
	-- zobraz ako bar
	else
		aura.bar:Show()
		aura.cd:Hide()
		aura.icon:Hide()
		aura.border:Hide()
		aura.timer1:Hide()
		aura.count2:Show()
		aura.count1:Hide()
		
		if L.config.aura_show_timer_bar then
			aura.timer2:Show()
		else
			aura.timer2:Hide()
		end
		
		if count and count > 1 then
			aura.count2:SetText(count)
		else
			aura.count2:SetText(nil)
		end
		
		local r, g, b, a = unpack(L.AurasTable[name].color)
		aura.bar:SetStatusBarColor(r, g, b, a)
		aura.bar.border.bg:SetVertexColor(r / 3, g / 3 , b / 3, a or 1)
	end
	
	aura:SetScript("OnUpdate", function(self, elapsed)
		--if not self.duration or self.duration <= 0 then return end
		self.elapsed = (self.elapsed or 0) + elapsed
		if self.elapsed < .1 then return end
		self.elapsed = 0

		local timeLeft = self.expirationTime - GetTime()
		if timeLeft >= 0 then
			if L.config.aura_show_timer_icon then
				self.timer1:SetText(namePlateMixin:FormatTime(timeLeft))
			else
				self.timer1:SetText(nil)
			end
			if L.config.aura_show_timer_bar then
				self.timer2:SetText(namePlateMixin:FormatTime(timeLeft))
			else
				self.timer2:SetText(nil)
			end
				
			if self.showAsBar then
				PixelUtil.SetStatusBarValue(self.bar, timeLeft/self.duration)
				self.cd:Hide()
			elseif L.config.aura_show_cd and (showGlow or isStealable) then 
				self.cd:SetCooldown(self.expirationTime - self.duration, self.duration)
				self.cd:Show()
			else
				self.cd:Hide()
			end
		else
			self:SetScript("OnUpdate", nil)
			self.timer1:SetText(nil)
			self.timer2:SetText(nil)
			self.cd:Hide()
		end
	end)

	aura:Show()
end

local function UpdateAurasPosition(unitFrame)
	unitFrame.buffAuras[1]:ClearAllPoints()
	if unitFrame.healthBar:IsShown() then
		unitFrame.buffAuras[1]:SetPoint("BOTTOM", unitFrame.healthBar, "TOP", unitFrame.buffAuras.xOffset, L.config.aura_buff_Y + (unitFrame.powerBar:IsShown() and L.config.powerbar_height or 0))
	else
		unitFrame.buffAuras[1]:SetPoint("BOTTOM", unitFrame.nameText, "TOP", unitFrame.buffAuras.xOffset, L.config.aura_buff_Y)
	end
end

function ShouldSkipAuraUpdate(isFullUpdate, updatedAuraInfos)
	if isFullUpdate == nil then
		isFullUpdate = true;
	end
	
	local skipUpdate = false;
	if not isFullUpdate and updatedAuraInfos ~= nil then
		skipUpdate = true;
		for _, auraInfo in ipairs(updatedAuraInfos) do
			if (not auraInfo.shouldNeverShow) then
				skipUpdate = false;
				break;
			end
		end
	end
	return skipUpdate;
end

local function UpdateAllAuras(unitFrame, isFullUpdate, updateAuraInfos)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	if not unit or ShouldSkipAuraUpdate(isFullUpdate, updatedAuraInfos) then
		return
	end
		
	-- moje aury na enemy
	if unitFrame.unitType == "self" then
		for i = 1, #unitFrame.debuffAuras do 
			unitFrame.debuffAuras[i]:Hide()
			unitFrame.debuffAuras[i] = nil
		end
	else
		local debuffIndex = 1
		for index = 1, DEBUFF_MAX_DISPLAY do
			local name, icon, count, debuffType, duration, expirationTime, caster, isStealable, _, spellID = UnitAura(unit, index, 'HELPFUL|HARMFUL')
		
			if name then
				if caster == "player" and not L.AurasList["Control"][name] and not L.AurasTable[name] then
					L.AurasTable[name] = {}
					L.AurasTable[name].enable = false
					L.AurasTable[name].color = {1, 1, 1, 1}
					if L.config.aura_info then
						namePlateMixin:DebugLog("New aura learned |cffffff00"..name.."|r", 3, true, false)
					end
				end
				
				if debuffIndex <= L.config.aura_icon_debuff_max then
					-- CC aura
					if L.config.aura_stun_show and L.AurasList["Control"][name] then
						if (not unitFrame.debuffAuras[debuffIndex]) then
							unitFrame.debuffAuras[debuffIndex] = unitFrame.debuffAuras[debuffIndex] or CreateAura(unitFrame, L.config.aura_stun_size_width, L.config.aura_stun_size_height)
						else
							unitFrame.debuffAuras[debuffIndex]:SetSize(L.config.aura_stun_size_width, L.config.aura_stun_size_height)
						end
						UpdateAura(unitFrame.debuffAuras[debuffIndex], name, icon, count, debuffType, duration, expirationTime, isStealable, spellID, true, false)
						if debuffIndex > 1 then
							unitFrame.debuffAuras[debuffIndex]:SetPoint("TOPLEFT", unitFrame.debuffAuras[debuffIndex-1], "TOPRIGHT", L.config.aura_space_X, 0)
						end
						debuffIndex = debuffIndex + 1
					-- player aura
					elseif L.config.aura_debuff_show and not L.AurasList["Control"][name] and caster == "player" and L.AurasTable[name].enable  then
						if (not unitFrame.debuffAuras[debuffIndex]) then
							unitFrame.debuffAuras[debuffIndex] = unitFrame.debuffAuras[debuffIndex] or CreateAura(unitFrame, L.config.aura_icon_debuff_width, L.config.aura_icon_debuff_height)
						else
							if L.config.aura_bar_show then
								unitFrame.debuffAuras[debuffIndex].bar:SetSize(L.config.aura_icon_debuff_width, L.config.aura_bar_debuff_height)
							else
								unitFrame.debuffAuras[debuffIndex]:SetSize(L.config.aura_icon_debuff_width, L.config.aura_icon_debuff_height)
							end
						end
						UpdateAura(unitFrame.debuffAuras[debuffIndex], name, icon, count, debuffType, duration, expirationTime, isStealable, spellID, false, L.config.aura_bar_show and true or false)
						
						if debuffIndex > 1 then
							unitFrame.debuffAuras[debuffIndex]:SetPoint("TOPLEFT", unitFrame.debuffAuras[debuffIndex-1], "TOPRIGHT", L.config.aura_space_X, 0)
						end
						debuffIndex = debuffIndex + 1
					end
				end
			end
		end
		
		if debuffIndex > 1 then
			unitFrame.debuffAuras[1]:SetPoint("TOP", unitFrame.healthBar, "BOTTOM", -(((L.config.aura_icon_debuff_width + L.config.aura_space_X) * (debuffIndex-1)) / 2) + math_floor((L.config.aura_icon_debuff_width + L.config.aura_space_X) / 2), L.config.aura_bar_debuff_Y)
		end
		for i = debuffIndex, #unitFrame.debuffAuras do
			unitFrame.debuffAuras[i]:Hide()
			unitFrame.debuffAuras[i] = nil
		end
	end
	
	
	-- local n = select("#", unitFrame.buffAuras)
	if L.config.aura_buff_show and unitFrame.unitType ~= "self" then
		local buffIndex = 1
		for i = 1, #unitFrame.buffAuras do
			unitFrame.buffAuras[i]:Hide()
			unitFrame.buffAuras[i].name = nil
			unitFrame.buffAuras[i].count = nil
		end
		for index = 1, BUFF_MAX_DISPLAY do
			if buffIndex <= L.config.aura_icon_buff_max then
				local name, icon, count, debuffType, duration, expirationTime, caster, isStealable, _, spellID = UnitAura(unit, index, 'HELPFUL')
				
				if name and ((unitFrame.isPlayer and L.AurasList["EnemyPlayer"][name]) or (not unitFrame.isPlayer and not L.AurasList["NPCBlackList"][name])) then
					local stackExist = false
					if L.config.aura_stack then
						for i = 1, #unitFrame.buffAuras	do
							if unitFrame.buffAuras[i].name == name then
								if unitFrame.buffAuras[i].count == 0 then unitFrame.buffAuras[i].count = 1 end
								UpdateAura(unitFrame.buffAuras[i], name, icon, unitFrame.buffAuras[i].count + 1, debuffType, duration, expirationTime, isStealable, spellID, false, false)
								stackExist = true
								break
							end
						end
					end
												
					if not stackExist then
						unitFrame.buffAuras[buffIndex] = unitFrame.buffAuras[buffIndex] or CreateAura(unitFrame, L.config.aura_icon_buff_width, L.config.aura_icon_buff_height)
						unitFrame.buffAuras[buffIndex]:SetSize(L.config.aura_icon_buff_width, L.config.aura_icon_buff_height)
						
						UpdateAura(unitFrame.buffAuras[buffIndex], name, icon, count, debuffType, duration, expirationTime, isStealable, spellID, false, false)
						if buffIndex > 1 then
							unitFrame.buffAuras[buffIndex]:SetPoint("BOTTOMLEFT", unitFrame.buffAuras[buffIndex-1], "BOTTOMRIGHT", L.config.aura_space_X, 0)
						end
				
						buffIndex = buffIndex + 1
					end				
				end
			end
		end
		
		if buffIndex > 1 then
			unitFrame.buffAuras.xOffset = -(((L.config.aura_icon_buff_width + L.config.aura_space_X) * (buffIndex - 1)) / 2) + math_floor((L.config.aura_icon_buff_width + L.config.aura_space_X) / 2)
			UpdateAurasPosition(unitFrame)
		end
		
		for i = buffIndex, #unitFrame.buffAuras do
			unitFrame.buffAuras[i]:Hide()
			unitFrame.buffAuras[i] = nil
		end
	end
	
	
	if L.config.aura_self_show and unitFrame.unitType == "self" then
		local buffIndex = 1
		
		for index = 1, BUFF_MAX_DISPLAY do
			if buffIndex <= L.config.aura_icon_self_max then
				local name, icon, count, debuffType, duration, expirationTime, caster, isStealable, hm, spellID = UnitAura(unit, index,  'HELPFUL|PLAYER|INCLUDE_NAME_PLATE_ONLY')
				
				if name then
					if (caster == "player" and L.AurasSelfPlayerList[name]) then
						
						if not unitFrame.buffAuras[buffIndex] then
							unitFrame.buffAuras[buffIndex] = unitFrame.buffAuras[buffIndex] or CreateAura(unitFrame, L.config.aura_icon_self_width, L.config.aura_icon_self_height)
						else
							unitFrame.buffAuras[buffIndex]:SetSize(L.config.aura_icon_self_width, L.config.aura_icon_self_height)
						end
						
						UpdateAura(unitFrame.buffAuras[buffIndex], name, icon, count, debuffType, duration, expirationTime, isStealable, spellID, false, false)
						if buffIndex > 1 then
							unitFrame.buffAuras[buffIndex]:SetPoint("BOTTOMLEFT", unitFrame.buffAuras[buffIndex-1], "BOTTOMRIGHT", L.config.aura_space_X, 0)
						end
						buffIndex = buffIndex + 1
					end
				end
			end
		end

		if buffIndex > 1 then
			unitFrame.buffAuras[1]:ClearAllPoints()
			unitFrame.buffAuras.xOffset = -(((L.config.aura_icon_self_width + L.config.aura_space_X) * (buffIndex-1)) / 2) + math_floor((L.config.aura_icon_self_width + L.config.aura_space_X) / 2)
			if unitFrame.healthBar:IsShown() then
				unitFrame.buffAuras[1]:SetPoint("BOTTOM", unitFrame.healthBar, "TOP", unitFrame.buffAuras.xOffset, L.config.aura_self_Y + 2)
			end
		end
		
		for i = buffIndex, #unitFrame.buffAuras do
			unitFrame.buffAuras[i]:Hide()
			unitFrame.buffAuras[i] = nil
		end
	end
	
	if not (L.config.aura_buff_show and unitFrame.unitType ~= "self") and not (L.config.aura_self_show and unitFrame.unitType == "self") then
		for i = 1, #unitFrame.buffAuras do
			unitFrame.buffAuras[i]:Hide()
			unitFrame.buffAuras[i] = nil
		end
	end
end

--[[ Update funkcie ]]--
local function IsTapDenied(unitFrame)
	return UnitIsTapDenied(unitFrame.unit) and not UnitPlayerControlled(unitFrame.unit)
end

local function GetThreatColor(unit, threatStatus)
	local unitTarget = unit.."target"
		
	if ( not threatStatus ) then
		return L.config.threat_color_noaggro
	elseif ( threatStatus >= 3 ) then
		local perc = UnitHealth(unit) / UnitHealthMax(unit)
		if (perc >= L.config.threat_execute_value) then -- tu dostat TODeath
			return L.config.threat_color_4
		else
			return L.config.threat_color_execute
		end
	elseif ( UnitExists(unitTarget) and not UnitIsUnit("player", unitTarget) ) and ( namePlateMixin:IsUnitTank(unitTarget) or not UnitIsPlayer(unitTarget) ) then return L.config.threat_color_offtank
	elseif ( threatStatus == 2 ) then return L.config.threat_color_3
	elseif ( threatStatus == 1 ) then return L.config.threat_color_2
	elseif ( threatStatus == 0 ) then return L.config.threat_color_1
	end
end

local function ConvertNumToIconsString(unitFrame, value)
	local index = GetRaidTargetIndex(unitFrame.unit)
	if ( index and index < 9 ) then
		return nil
	else
		if tonumber(value) then
			local text = ""
			for i = 1, string_len(value) do
				local c = tonumber(value:sub(i,i))
				if c and (c >= 1 and c <= 8) then
					text = text .. "|T" ..  mediaFolder.."marks\\".. c ..":18:18|t"
					--text = text .. ICON_LIST[tonumber(c)] .."20:20|t "
				end
			end
			return text
		else
			return value
		end
	end
end

local function UpdateUnitFrameAlpha(unitFrame)
	if (unitFrame.isFocus and L.config.focus_enable)
		or unitFrame.isPlayerTarget
		or (not unitFrame.isTanking and L.isSelfTank and L.config.playersInfo.isInCombat)
		or unitFrame.isPlayer
	--	or unitFrame.isColoredName
		or (L.config.mark_alpha and unitFrame.raidTargetIndex)
		or (unitFrame.raidTargetIndex and unitFrame.raidTargetIndex == L.config.mythic_kicker_mark[namePlateMixin.PARTY_TABLE[UnitGUID("player")].mark]) 
		or (L.config.quest_max_alpha and unitFrame.isQuest)
		or unitFrame.isMouseover
		or not unitFrame.healthBar:IsShown()
		or L.MythicNPCData[0][unitFrame.npcID]
		or unitFrame.maxAlpha then

		unitFrame:SetAlpha(1)
	else
		unitFrame:SetAlpha(L.config.nameplate_alpha)
	end
end

local function UpdateHealthBarTexture(unitFrame)
	if L.config.target_healthbar and unitFrame.isPlayerTarget then
		unitFrame.healthBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.target_healthbar_texture))
		unitFrame.healthBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.target_healthbar_texture))
	elseif L.config.focus_enable and L.config.focus_healthbar and unitFrame.isFocus then
		unitFrame.healthBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.focus_healthbar_texture))
		unitFrame.healthBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.focus_healthbar_texture))
	else
		unitFrame.healthBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.healthbar_texture[unitFrame.unitType]))
		unitFrame.healthBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.healthbar_bg_texture[unitFrame.unitType]))
	end
end

local function UpdateHealthBar(unitFrame, show, who)
	if unitFrame.unitType == "self" then return end
	
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local unitHealth, unitHealthMax = UnitHealth(unit), UnitHealthMax(unit)
	local perc = unitHealth / unitHealthMax
	
	if show 
		or perc ~= 1
		or unitFrame.threatStatus
		or (unitFrame.isPlayerTarget and L.config.healthbar_target_show[unitFrame.unitType])
		or L.config.healthbar_show[unitFrame.unitType]
		or (not unitFrame.widgetsOnly and unitFrame.widgetSet) 
		or (unitFrame.isFocus and L.config.focus_enable)
		or unitFrame.raidTargetIndex 
		or (unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].hb) then
		
		local newColor, newScaleX, newScaleY, newShadowColor = 0, 1, 1, {0, 0, 0, 1}
				
		if not unitFrame.healthBar:IsShown() then
			unitFrame.healthBar:Show()
			unitFrame.nameText:ClearAllPoints()
			PixelUtil.SetPoint(unitFrame.nameText, L.config.name_point, unitFrame.healthBar, L.config.name_relativePoint, L.config.name_posun_X, L.config.name_posun_Y)
			unitFrame.descText:ClearAllPoints()
			unitFrame.descText:SetPoint(L.config.desc_text_point, unitFrame.healthBar, L.config.desc_text_relativePoint, L.config.desc_text_posun_X, L.config.desc_text_posun_Y)
			unitFrame.helpText:ClearAllPoints()
			unitFrame.helpText:SetPoint(L.config.mythic_help_point, unitFrame.healthBar, L.config.mythic_help_relativePoint, L.config.mythic_help_posun_X, L.config.mythic_help_posun_Y)
			unitFrame.creatureIconFrame:ClearAllPoints()
			unitFrame.creatureIconFrame:SetPoint(L.config.creature_icon_hb_point , unitFrame.healthBar, L.config.creature_icon_hb_relativePoint, L.config.creature_icon_hb_posun_X, L.config.creature_icon_hb_posun_Y)
						
			if unitFrame.buffAuras[1] then
				UpdateAurasPosition(unitFrame)
			end
		end
		
		-- urcenie farby
		if unitFrame.isMouseover and unitFrame.isPlayerTarget then
			newColor = newColor + L.config.mouseover_highlight
		elseif unitFrame.isMouseover and unitFrame.isFocus then
			newColor = newColor + L.config.mouseover_highlight
		elseif unitFrame.isMouseover then
			newColor = newColor + L.config.mouseover_highlight
		elseif unitFrame.isPlayerTarget then
			newColor = newColor + L.config.target_highlight
		elseif unitFrame.isFocus and L.config.focus_enable then
			newColor = newColor
		end
			
		--urcenie borderu HB
		if (unitFrame.isMouseover and L.config.mouseover_shadow) or (unitFrame.isPlayerTarget and L.config.target_shadow) or (unitFrame.isFocus and L.config.focus_shadow and L.config.focus_enable) then
			if unitFrame.isMouseover and L.config.mouseover_shadow then
				newShadowColor = L.config.mouseover_shadow_color
			elseif unitFrame.isPlayerTarget and L.config.target_shadow then
				newShadowColor = L.config.target_shadow_color	
			elseif unitFrame.isFocus and L.config.focus_shadow and L.config.focus_enable then
				newShadowColor = L.config.focus_shadow_color
			end
			unitFrame.healthBar.border.shadow:SetBackdropBorderColor(unpack(newShadowColor))
			unitFrame.healthBar.border.shadow:Show()
		else
			unitFrame.healthBar.border.shadow:SetBackdropBorderColor(unpack(L.config.healthbar_shadow_color[unitFrame.unitType]))
			if (L.config.healthbar_shadow["enemy"] and unitFrame.unitType == "enemy") or (L.config.healthbar_shadow["friendly"] and unitFrame.unitType == "friendly") then
				unitFrame.healthBar.border.shadow:Show()
			else
				unitFrame.healthBar.border.shadow:Hide()
			end
		end
		
		if unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] then
			newScaleX = newScaleX + ((L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].scale or 1) - 1)
			newScaleY = newScaleY + ((L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].scale or 1) - 1)
		end
		
		if who ~= "OnUpdate" or  who ~= "OnUpdateMouseoverUnit" then
			if unitFrame.isColoredName or unitFrame.isQuest then
				unitFrame.nameText:SetAlpha(1)
			else
				unitFrame.nameText:SetAlpha(L.config.name_text_alpha_hb)
			end
			
			unitFrame.descText:SetAlpha(L.config.desc_text_alpha_hb)
					
			if unitFrame.threatStatus and IsInGroup() and ((not L.isSelfTank and unitFrame.threatStatus > 2) or (L.isSelfTank and unitFrame.threatStatus < 3)) then
				--print(IsInGroup)
			elseif unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].hb then
				unitFrame.healthBar.color = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].hb_color
			elseif unitFrame.raidTargetIndex and L.config.mark_healthbar then
				unitFrame.healthBar.color = L.config.mark_color[unitFrame.raidTargetIndex]
			end
			
			if unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].br then
				namePlateMixin:SetMyBorderColor(unitFrame.healthBar.border, unpack(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].br_color))
			elseif not (unitFrame.raidTargetIndex and L.config.mark_border) then
				namePlateMixin:SetMyBorderColorByUnit(unitFrame.healthBar.border)
			end
			
			if unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].gl then
				LCG.PixelGlow_Start(unitFrame.healthBar.border, L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].gl_color, 12, nil, 6, 1, 2, 2, false, "", 0)
			else
				LCG.PixelGlow_Stop(unitFrame.healthBar.border)
			end
		end
				
		-- aplikuj co bolo nastavene
		unitFrame.healthBar:SetStatusBarColor(unitFrame.healthBar.color[1] + newColor, unitFrame.healthBar.color[2] + newColor, unitFrame.healthBar.color[3] + newColor, unitFrame.healthBar.color[4])
		
		if unitFrame.raidTargetIndex and L.config.mark_healthbar_bg then
			local r, g, b = unpack(L.config.mark_color[unitFrame.raidTargetIndex])
			unitFrame.healthBar.border.bg:SetVertexColor(r/2, g/2, b/2, L.config.healthbar_bg_alpha[unitFrame.unitType])
		else
			unitFrame.healthBar.border.bg:SetVertexColor((unitFrame.healthBar.color[1] + newColor) / L.config.healthbar_div_bg[unitFrame.unitType], (unitFrame.healthBar.color[2] + newColor) / L.config.healthbar_div_bg[unitFrame.unitType], (unitFrame.healthBar.color[3] + newColor) / L.config.healthbar_div_bg[unitFrame.unitType], L.config.healthbar_bg_alpha[unitFrame.unitType])
		end
		
		if L.config.hp_font_color_from_healthBar then
			unitFrame.healthText:SetTextColor(unitFrame.healthBar:GetStatusBarColor())
		else
			unitFrame.healthText:SetTextColor(unpack(L.config.hp_font_color))
		end
		
		unitFrame.healthBar.spark:SetVertexColor(unitFrame.healthBar.color[1] + .2, unitFrame.healthBar.color[2] + .2, unitFrame.healthBar.color[3] + .2, unitFrame.healthBar.color[4])
		unitFrame.healthBar.spark:SetSize(16, unitFrame.healthBar:GetHeight() * 2)
		
		if unitFrame.nameText:GetAlpha() > 0 and (L.config.name_bg_show_hb or (L.config.name_bg_show_target and unitFrame.isPlayerTarget))  then --L.config.name_text_alpha_hb ~= 0 then
			unitFrame.nameTextBGTexture:Show()
		else
			unitFrame.nameTextBGTexture:Hide()
		end
		
		newScaleX = newScaleX + (unitFrame.isPlayerTarget and (L.config.target_healthbar_scale_X - 1) or 0) + (unitFrame.isMouseover and (L.config.mouseover_healthbar_scale - 1) or 0) + (unitFrame.isFocus and (L.config.focus_healthbar_scale - 1) or 0)
		newScaleY = newScaleY + (unitFrame.isPlayerTarget and (L.config.target_healthbar_scale_Y - 1) or 0) + (unitFrame.isMouseover and (L.config.mouseover_healthbar_scale - 1) or 0) + (unitFrame.isFocus and (L.config.focus_healthbar_scale - 1) or 0)
		
		PixelUtil.SetSize(unitFrame.healthBar, L.config.healthbar_width[unitFrame.unitType] * newScaleX, L.config.healthbar_height[unitFrame.unitType] * newScaleY)
		PixelUtil.SetPoint(unitFrame.powerBar, "TOPLEFT", unitFrame.healthBar, "TOPLEFT", 20, (L.config.powerbar_height + L.config.powerbar_Y) * newScaleY)
		PixelUtil.SetPoint(unitFrame.powerBar, "BOTTOMRIGHT", unitFrame.healthBar, "TOPRIGHT", -20, L.config.powerbar_Y * newScaleY)
		PixelUtil.SetPoint(unitFrame.diminishBar, "TOPLEFT", unitFrame.healthBar, "TOPLEFT", 2, (L.config.powerbar_height + L.config.powerbar_Y) * newScaleY)
		PixelUtil.SetPoint(unitFrame.diminishBar, "BOTTOMRIGHT", unitFrame.healthBar, "TOPLEFT", 18, L.config.powerbar_Y * newScaleY)
		PixelUtil.SetPoint(unitFrame.threatBar, "TOPLEFT", unitFrame.healthBar, "TOPRIGHT", -18, (L.config.powerbar_height + L.config.powerbar_Y) * newScaleY)
		PixelUtil.SetPoint(unitFrame.threatBar, "BOTTOMRIGHT", unitFrame.healthBar, "TOPRIGHT", -2, L.config.powerbar_Y * newScaleY)
	else
		--if unitFrame.healthBar:IsShown() then
			unitFrame.healthBar:Hide()
			
			unitFrame.nameText:ClearAllPoints()
			PixelUtil.SetPoint(unitFrame.nameText, "TOP", unitFrame, "TOP", 0, - (L.config.healthbar_height[unitFrame.unitType]))
			--unitFrame.nameText:SetPoint("TOP", unitFrame, "TOP", 0, - (L.config.healthbar_height[unitFrame.unitType]))
			unitFrame.descText:ClearAllPoints()
			unitFrame.descText:SetPoint("TOP", unitFrame.nameText, "BOTTOM", 0, 1)
			unitFrame.helpText:ClearAllPoints()
			unitFrame.helpText:SetPoint("BOTTOM", unitFrame.nameText, "TOP", 0, 0)
			unitFrame.creatureIconFrame:ClearAllPoints()
			unitFrame.creatureIconFrame:SetPoint(L.config.creature_icon_nohb_point , unitFrame.nameText, L.config.creature_icon_nohb_relativePoint, L.config.creature_icon_nohb_posun_X, L.config.creature_icon_nohb_posun_Y)
									
			if unitFrame.buffAuras[1] then
				UpdateAurasPosition(unitFrame)
			end
		--end
				
		if unitFrame.isMouseover or unitFrame.isColoredName or unitFrame.isQuest then
			unitFrame.nameText:SetAlpha(1)
			unitFrame.descText:SetAlpha(1)
		else
			unitFrame.nameText:SetAlpha(L.config.name_text_alpha_nohb)
			unitFrame.descText:SetAlpha(L.config.desc_text_alpha_nohb)
		end
		
		if L.config.name_bg_show_nohb or (L.config.name_bg_show_target and unitFrame.isPlayerTarget) then
			unitFrame.nameTextBGTexture:Show()
		else
			unitFrame.nameTextBGTexture:Hide()
		end
	end
		
	UpdateUnitFrameAlpha(unitFrame)
end


local function UpdateName(unitFrame, who)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	if not unit then	return end
		
	if unitFrame.unitType == "self" then
		unitFrame.nameText:Hide()
		unitFrame.creatureIconFrame:Hide()
		unitFrame.pvpIcon:Hide()
		unitFrame.nameTextBGTexture:Hide()
	else
		-- ak nemam zistene meno opakujem kym to z blizzardu nevymlatim
		if unitFrame.unitName == UNKNOWN then
			unitFrame.unitName = UnitName(unitFrame.unit) or UNKNOWN
			C_Timer_After(.2, function() UpdateName(unitFrame) end)
			return
		end
	
		local unitLevel = UnitLevel(unit)
		local selfLevel = UnitEffectiveLevel("player") --UnitLevel("player")
		local name = unitFrame.unitName
					
		-- nastav name z M+ Database ak som v M+
		if unitFrame.mapID then
			if L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].destName then 
				if L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].destName == UNKNOWN then
					L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].destName = unitFrame.unitName
					name = unitFrame.unitName
				else
					name = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].destName
				end
			end
		end
		
		if L.config.name_translate and unitFrame.isPlayer then
			name = namePlateMixin:Translate(name)
		end
		
		if L.config.name_short and not unitFrame.isPlayer and (string_len(name) > L.config.name_short_lenght) then
			if L.config.name_format == 0 then
				name =  string_gsub(name, "%s?(.[\128-\191]*)%S+%s", "%1. ")
			elseif L.config.name_format == 1 then
				name = string_gsub(name, "%s?(.[\128-\191]*)%S+%s", "%1.")
			elseif L.config.name_format == 2 then
				name =  string_gsub(name, "%s(%a)%a*", " %1.")
			elseif L.config.name_format == 3 then
				name =  string_gsub(name, "%s(%a)%a*", "%1.")
				--name = string_gsub(name, "(%S+)%s+(%S)%S*%s+(%S)%S*", "%1 %2. %3.")
				--name = string_gsub(name, "%f[%S](.[\128-\191]*)%S+", "%1.")
			elseif L.config.name_format == 4 then
				for n in string_gmatch(name, '%S+') do
					name = n
					break
				end
			elseif L.config.name_format == 5 then
				for n in string_gmatch(name, '%S+') do
					name = n
				end
			end
		end
			
		
		if not ((unitFrame.classification == "worldboss" or UnitLevel(unit) == -1) or (unitLevel == selfLevel)) then
			local levelColor = GetRelativeDifficultyColor(selfLevel, unitLevel) or {r = 1, g = 1, b = 1}
			name = "|c"..format("ff%.2x%.2x%.2x", levelColor.r * 255, levelColor.g * 255, levelColor.b * 255)..""..unitLevel.."|r " .. name
		end
				
		-- set color
		if ( not UnitIsConnected(unit) ) then
			unitFrame.nameText:SetTextColor(0.7, 0.7, 0.7, 1)
			unitFrame.isColoredName = true
		
		elseif ( IsTapDenied(unitFrame) ) then
			unitFrame.nameText:SetTextColor(0.3, 0.3, 0.3, 1)
			unitFrame.isColoredName = true
					
		elseif ( unitFrame.mapID and L.config.mythic_colored and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].colored ) then
			unitFrame.nameText:SetTextColor(unpack(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].color))
			unitFrame.isColoredName = true
			
		elseif unitFrame.isPlayer and ((L.config.class_color_friendly and unitFrame.unitType == "friendly") or (L.config.class_color_enemy and unitFrame.unitType ~= "friendly")) then
			local classColor = RAID_CLASS_COLORS[unitFrame.englishClass]
			unitFrame.nameText:SetTextColor(classColor.r, classColor.g, classColor.b, 1)
			unitFrame.isColoredName = true
		
		elseif ( unitFrame.isQuest ) then
			if L.config.quest_color then
				unitFrame.nameText:SetTextColor(unpack(L.config.quest_name_color))
			else
				unitFrame.nameText:SetTextColor(UnitSelectionColor(unit, true))
			end
			
			if unitFrame.questValue then
				name = name .." "..unitFrame.questValue
			end
			unitFrame.nameText:SetAlpha(1)
			
		else
			unitFrame.nameText:SetTextColor(UnitSelectionColor(unit, true))
			if unitFrame.healthBar:IsShown() then
				unitFrame.nameText:SetAlpha(L.config.name_text_alpha_hb)
			else
				unitFrame.nameText:SetAlpha(L.config.name_text_alpha_nohb)
			end
			unitFrame.isColoredName = false
		end
				
		-- set font
		if unitFrame.isPlayer then 
			unitFrame.nameText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.name_font_players), L.config.name_fontsize_players, L.config.name_font_flag_players)
		elseif unitFrame.isQuest then
			unitFrame.nameText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.quest_font), L.config.quest_fontsize, L.config.quest_font_flag)
		elseif unitFrame.isPlayerTarget then
			unitFrame.nameText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.name_font_target), L.config.name_fontsize_target, L.config.name_font_flag_target)
		else
			unitFrame.nameText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.name_font_npc), L.config.name_fontsize_npc, L.config.name_font_flag_npc)
		end
		
		-- zobrazit honor level
		if L.config.show_honor_level then
			if ( unitFrame.faction and unitFrame.faction ~= 'Neutral' and UnitIsPVP(unit)) then
				local honorLevel = UnitHonorLevel(unit)
				local honorRewardInfo = C_PvP.GetHonorRewardInfo(honorLevel);
				if honorRewardInfo then
					unitFrame.pvpIcon:SetTexture(honorRewardInfo.badgeFileDataID);
					unitFrame.pvpIcon:Show()
				end
			else
				unitFrame.pvpIcon:Hide()
			end
		end
		
		unitFrame.nameText:SetText(name)
		unitFrame.nameText:Show()
		unitFrame.nameTextBGTexture:SetSize(unitFrame.nameText:GetStringWidth() + 5, unitFrame.nameText:GetStringHeight() + 3)
		
		UpdateUnitFrameAlpha(unitFrame)
	end
end

local function SetFrameScale(frame, width, height, scale)
	if (frame.currentScale ~= scale) then
		if (frame.scale:IsPlaying()) then
			frame.scale:Stop()
		end
		frame.scale.width:SetChange(width * scale)
		frame.scale.height:SetChange(height * scale)
		frame.scale:Play()
		frame.currentScale = scale
	end
end

local function UpdateHealthBarColor(unitFrame)


end

local function UpdateHealth(unitFrame)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local unitHealth, unitMaxHealth = UnitHealth(unit), UnitHealthMax(unit)
	local perc = unitHealth/unitMaxHealth
	local oldColor = unitFrame.healthBar.color
	
	-- nastav sposob ubudania HP v healthBare
	if L.config.healthbar_smooth then
		if ( unitFrame.newUnit ) then
			unitFrame.healthBar:ResetSmoothedValue(perc)
			unitFrame.newUnit = false
		else
			unitFrame.healthBar:SetSmoothedValue(perc)
		end
	else
		PixelUtil.SetStatusBarValue(unitFrame.healthBar, perc)
	end
	
	-- nastav farbu healthBaru a formatu cisla HP
	if unitFrame.unitType == "self" then
		if (perc < L.config.self_unitframe_warning) and L.config.self_unitframe_warning > 0 then
			if unitFrame.healthBar.currentScale == 1 then
				SetFrameScale(unitFrame.healthBar, L.config.healthbar_width["self"], L.config.healthbar_height["self"], L.config.self_unitframe_scale)
				SetFrameScale(unitFrame.powerBar, L.config.self_powerbar_width, L.config.self_powerbar_height, L.config.self_unitframe_scale)
				if L.config.self_unitframe_flash and not unitFrame.AnimFlash:IsPlaying() then
					unitFrame.AnimFlash:Play()
				end
			end
		elseif (perc > (L.config.self_unitframe_warning + 0.02) and unitFrame.healthBar.currentScale ~= 1) then
			SetFrameScale(unitFrame.healthBar, L.config.healthbar_width["self"], L.config.healthbar_height["self"], 1)
			SetFrameScale(unitFrame.powerBar, L.config.self_powerbar_width, L.config.self_powerbar_height, 1)
			if unitFrame.AnimFlash:IsPlaying() then
				unitFrame.AnimFlash:Stop()
			end
		end
		
	else
		if L.config.hp_enable or (L.config.hp_target_enable and unitFrame.isPlayerTarget) then
			if L.config.hp_format == 0 then
				unitFrame.healthText:SetText(string_format("%d", math_floor(perc * 100)))
			elseif L.config.hp_format == 1 then
				unitFrame.healthText:SetText(namePlateMixin:FormatHealthPoint(unitHealth).." - "..FormatPercentage(perc, false))
			elseif L.config.hp_format == 2 then
				unitFrame.healthText:SetText(namePlateMixin:FormatHealthPoint(unitHealth))
			elseif L.config.hp_format == 3 then
				unitFrame.healthText:SetText(namePlateMixin:FormatHealthPoint(unitHealth).." / "..namePlateMixin:FormatHealthPoint(unitMaxHealth))
			end
			unitFrame.healthText:Show()
		else
			unitFrame.healthText:Hide()
		end
		
		if not unitFrame.isPlayer then
			if L.config.classSpell_ToD
				and L.selfClass == 'MONK'
				and unitFrame.unitType == "enemy"
				and L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.ready
				and (unitHealth < UnitHealthMax("player") or perc <= 0.15) then
				
				unitFrame.healthBar.color = L.config.classSpell_ToD_color
				if NPC_TABLE[unitFrame.unitGUID] and not NPC_TABLE[unitFrame.unitGUID].playedsound then
					--PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, "np_resource_sound"), L.config.sound_channel)
					NPC_TABLE[unitFrame.unitGUID].playedsound = true
					--unitFrame.ShakeAnim:Play()
				end
				
			elseif not L.isSelfTank then
				if not unitFrame.threatStatus then
					unitFrame.healthBar.color = L.config.threat_color_noaggro
				else
					if unitFrame.threatStatus > 1 and IsInGroup() then
						unitFrame.healthBar.color = L.config.healthbar_dps_color_4
					elseif perc < L.config.dps_value_color_1 then
						unitFrame.healthBar.color = L.config.healthbar_dps_color_1
					elseif perc >= L.config.dps_value_color_1 and perc <= L.config.dps_value_color_2 then
						unitFrame.healthBar.color = L.config.healthbar_dps_color_2
					else
						unitFrame.healthBar.color = L.config.healthbar_dps_color_3
					end
				end
			elseif L.config.threat_execute_value > 0 then
				unitFrame.healthBar.color = GetThreatColor(unit, unitFrame.threatStatus)
			end
		end
		
		if perc ~= 1 or L.config.healthbar_show[unitFrame.unitType] then
			if not unitFrame.healthBar:IsShown() or (oldColor[1] ~= unitFrame.healthBar.color[1] or oldColor[2] ~= unitFrame.healthBar.color[2] or oldColor[3] ~= unitFrame.healthBar.color[3] or oldColor[4] ~= unitFrame.healthBar.color[4]) then
				UpdateHealthBar(unitFrame, true, "UpdateHealth")
			end
		elseif unitFrame.healthBar:IsShown() then
			UpdateHealthBar(unitFrame, false, "UpdateHealth")
		end
	end
	
	-- zobraz nabeznu hranu healthBaru
	if unitFrame.healthBar:IsShown() and L.config.healthbar_spark[unitFrame.unitType] and (unitHealth < unitMaxHealth and unitHealth > 1) then
		unitFrame.healthBar.spark:SetPoint("CENTER", unitFrame.healthBar:GetStatusBarTexture(), "RIGHT", 0, 0)
		unitFrame.healthBar.spark:SetSize(16, unitFrame.healthBar:GetHeight() * 2)
		unitFrame.healthBar.spark:Show()
	else
		unitFrame.healthBar.spark:Hide()
	end
end

local function UpdateAbsorb(unitFrame)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local absorb = UnitGetTotalAbsorbs(unit) or 0
	local unitHealth, unitMaxHealth = UnitHealth(unit), UnitHealthMax(unit)
	local previousTexture = unitFrame.healthBar:GetStatusBarTexture()
	local totalWidth = unitFrame.healthBar:GetSize()
	
	if (unitHealth + absorb > unitMaxHealth) then
		unitFrame.overAbsorbGlow:Show()
		absorb = max(0, unitMaxHealth - unitHealth)
	else
		unitFrame.overAbsorbGlow:Hide()
	end
		
	if ( absorb > 0 ) then
		unitFrame.totalAbsorb:SetPoint("TOPLEFT", previousTexture, "TOPRIGHT", 0, 0)
		unitFrame.totalAbsorb:SetPoint("BOTTOMLEFT", previousTexture, "BOTTOMRIGHT", 0, 0)
		unitFrame.totalAbsorb:SetWidth((absorb / unitMaxHealth) * totalWidth)
		unitFrame.totalAbsorb:Show()
		unitFrame.totalAbsorbOverlay:Show()
	else
		unitFrame.totalAbsorb:Hide()
		unitFrame.totalAbsorbOverlay:Hide()
	end
end

local function UpdateMaxPower(unitFrame)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	if L.config.powerbar_smooth then
		unitFrame.powerBar:SetMinMaxSmoothedValue(0, UnitPowerMax(unit))
	else
		unitFrame.powerBar:SetMinMaxValues(0, UnitPowerMax(unit))
	end
end

local function UpdatePower(unitFrame)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local unitLevel = UnitLevel(unit)
	local selfLevel = UnitLevel("player")
	local unitPower = UnitPower(unit)
	local unitPowerMax = UnitPowerMax(unit)
				
	if unitFrame.unitType == "self" 
		or L.config.powerbar_alltime 
		or ( (unitPower > 0 and unitPower < unitPowerMax) and (unitLevel > (selfLevel + 1) or unitLevel == -1) )
		or ( unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].powerbar ) then
		
		if L.config.powerbar_smooth then
			unitFrame.powerBar:SetSmoothedValue(unitPower)
		else
			PixelUtil.SetStatusBarValue(unitFrame.powerBar, unitPower)
		end
		
		unitFrame.powerBar:Show()
	else
		unitFrame.powerBar:Hide()
	end
end

-------------------------------------------
-- THREAT FUNCTIONS
local function UpdateThreat(unitFrame, refresh)
	if unitFrame.isPlayer then return end
		
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local isTanking, threatStatus, percentage, rawPercentage = UnitDetailedThreatSituation("player", unit)
	
	-- small threat bar or number
	if L.config.threat_show and percentage and percentage > L.config.threat_show_perc and ((L.config.threat_show_onlyingroup and IsInGroup()) or not L.config.threat_show_onlyingroup) then
		if (unitFrame.threatPercent ~= percentage or refresh) then
			unitFrame.threatPercent = percentage
			if L.config.threat_show_as_bar then
				unitFrame.threatBar:SetStatusBarColor(percentage / 100 , 1 -  (percentage / 100), 0, 1)
				unitFrame.threatBar:Show()
				unitFrame.threatText:Hide()
			else
				unitFrame.threatText:SetTextColor(percentage / 100 , 1 -  (percentage / 100), 0)
				unitFrame.threatText:SetText(math_floor(percentage))
				unitFrame.threatBar:Hide()
				unitFrame.threatText:Show()
			end
		end
		
	else
		unitFrame.threatText:Hide()
		unitFrame.threatBar:Hide()
	end
	
	--threat healthBar color
	if (unitFrame.isTanking ~= isTanking or unitFrame.threatStatus ~= threatStatus or refresh) then
		unitFrame.threatStatus = threatStatus
		--UpdateName(unitFrame)	-- koli IsTapDenied
		if IsTapDenied(unitFrame) then
			unitFrame.nameText:SetTextColor(0.3, 0.3, 0.3, 1)
			unitFrame.isColoredName = true
		end
		
		if L.isSelfTank then		
			if ( unitFrame.isTanking ~= isTanking and L.config.threat_flash ) then
				if ( unitFrame.isTanking and not isTanking and not unitFrame.AnimFlash:IsPlaying()) then
					unitFrame.AnimFlash:SetLooping("NONE")
					unitFrame.AnimFlash:Play()
				end
			end
			unitFrame.healthBar.color = GetThreatColor(unit, threatStatus)
		else
			UpdateHealth(unitFrame)	--na zistenie farby
		end
		
		unitFrame.isTanking = isTanking
		if threatStatus then
			UpdateHealthBar(unitFrame, true, "UpdateThreatAggroTrue")
		elseif unitFrame.healthBar:IsShown() then
			UpdateHealthBar(unitFrame, false, "UpdateThreatAggroFalse")
		end
	else
		unitFrame.isTanking = isTanking
		unitFrame.threatStatus = threatStatus
	end
	
	--predikcia preSpellCD
	if unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] then
		if not UnitAffectingCombat(unit) then	-- UnitAffectingCombat(unit) je update strasne neskoro az ked sa mob vrati na povodnu poziciu unitFrame.threatStatus
			if unitFrame.isInCombat then
				unitFrame.isInCombat = false
				namePlateMixin:UpdateAllSpellCD(unitFrame, false)
			end
		elseif not unitFrame.isInCombat then
			if next(unitFrame.spellCD) then
				for spellID in pairs(unitFrame.spellCD) do
					namePlateMixin:UpdateSpellCD(unitFrame, spellID, true)
				end
			end
			unitFrame.isInCombat = true
		end
	end
end

-------------------------------------------
-- CASTBAR FUNCTIONS
local function MyCastingBarFrame_OnShow(self)
	if ( self.unit ) then
		if ( self.casting ) then
			local _, _, _, startTime = UnitCastingInfo(self.unit)
			if ( startTime ) then
				self.value = (GetTime() - (startTime / 1000))
			end
		else
			local _, _, _, _, endTime = UnitChannelInfo(self.unit)
			if ( endTime ) then
				self.value = ((endTime / 1000) - GetTime())
			end
		end
		if not L.config.cb_show_spellName then
			self.Text:SetText(nil)
		end
	end
end

local function MyCastingBarFrame_FinishSpell(self)
	if not L.config.cb_finishedColorSameAsStart then
		local r, g, b = unpack(L.config.cb_finishedCastColor)
		self:SetStatusBarColor(r, g, b, L.config.cb_sb_alpha[L.config.cb_type])
	end
	if ( self.Spark ) then
		self.Spark:Hide()
	end
	if ( self.Flash ) then
		self.Flash:SetAlpha(0)
		self.Flash:Show()
	end
	self.flash = true
	self.fadeOut = true
	self.casting = nil
	self.channeling = nil
	if self:GetParent().maxAlpha then
		self:GetParent().maxAlpha = false
		UpdateUnitFrameAlpha(self:GetParent())
	end
end

local function MyCastingBarFrame_GetEffectiveStartColor(self, isChannel, notInterruptible)
	if notInterruptible then
		return L.config.cb_nonInterruptibleColor
	end	
	return isChannel and L.config.cb_startChannelColor or L.config.cb_startCastColor
end

function MyCastingBarFrame_UpdateInterruptibleState(self, notInterruptible)
	if ( self.casting or self.channeling ) then
		local r, g, b = unpack(MyCastingBarFrame_GetEffectiveStartColor(self, self.channeling, notInterruptible))
		local a = L.config.cb_sb_alpha[L.config.cb_type]
		self:SetStatusBarColor(r, g, b, a)

		if self.flashColorSameAsStart then
			self.Flash:SetVertexColor(r, g, b, a)
		end

		if ( self.BorderShield ) then
			if ( self.showShield and notInterruptible ) then
				self.BorderShield:Show()
				if ( self.BarBorder ) then
					self.BarBorder:Hide()
				end
			else
				self.BorderShield:Hide()
				if ( self.BarBorder ) then
					self.BarBorder:Show()
				end
			end
		end

		if ( self.Icon and self.iconWhenNoninterruptible ) then
			self.Icon:SetShown(not notInterruptible)
		end
	end
end

local function MyCastingBarFrame_ApplyAlpha(self, alpha)
	self:SetAlpha(alpha)
	if self.additionalFadeWidgets then
		for widget in pairs(self.additionalFadeWidgets) do
			widget:SetAlpha(alpha)
		end
	end
end

local function UpdateWarningCastToTarget(unitFrame)
	
	unitFrame.castBar.isPlayerTargetForCast = UnitIsUnit(unitFrame.unit.."target", "player")
	
	if L.config.mythic_target_show_all and unitFrame.castBar:IsShown() then
		if (L.isSelfTank and not unitFrame.castBar.isPlayerTargetForCast and UnitIsPlayer(unitFrame.unit.."target"))
			or (not L.isSelfTank and UnitIsPlayer(unitFrame.unit.."target")) then 
							
			--unitFrame.castBar.targetNameText:SetText(namePlateMixin:GetTextColorByGUID(UnitGUID(unitFrame.unit.."target"), GetUnitName(unitFrame.unit.."target", false)))
			unitFrame.castBar.targetNameText:SetText(GetClassColoredTextForUnit(unitFrame.unit.."target", GetUnitName(unitFrame.unit.."target", false)))
			unitFrame.castBar.targetNameBGTexture:SetSize(unitFrame.castBar.targetNameText:GetStringWidth() + 6, L.config.cb_kicker_fontsize + 2)
			unitFrame.castBar.targetNameBGTexture:Show()
		end
	end
										
	if L.config.mythic_target_warning 
		and unitFrame.castBar.isPlayerTargetForCast 
		and not L.isSelfTank
		and unitFrame.mapID
		and unitFrame.npcID
		and (unitFrame.castBar:IsShown() and unitFrame.castBar.spellID) then
		
		if unitFrame.castBar.spellID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][unitFrame.castBar.spellID].targetme ~= nil then
			
			if L.config.mythic_target_maxAlpha then
				unitFrame.maxAlpha = true
				UpdateUnitFrameAlpha(unitFrame)
			end
			
			if L.config.mythic_target_cast_sound then
				PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.config.mythic_target_cast_sound_file), L.config.sound_channel)
			end
			
			if L.config.mythic_target_cast_mark then 
				if GetRaidTargetIndex("player") ~= 8 then
					SetRaidTarget("player", 8)
					C_Timer_After(4, function()
						SetRaidTarget("player", 0)
					end)
				end
			end
			
			if L.config.mythic_target_say then
				SendChatMessage(L.config.mythic_target_text, "SAY")
			end
			
			if L.config.mythic_target_flash then
				myFlashFrame.bg:SetVertexColor(unpack(L.config.mythic_target_flash_color))
				UIFrameFlash(myFlashFrame, L.config.mythic_target_flash_speed, L.config.mythic_target_flash_speed, 4 * L.config.mythic_target_flash_speed, false)
			end
			
			if L.config.mythic_target_cb_border then
				LCG.AutoCastGlow_Start(unitFrame.castBar.border, L.config.mythic_target_cb_border_color, 12, nil, 1, 0, 0, "", 0)
			end
		end
		
		-- warrior spell reflect
		if FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][unitFrame.castBar.spellID].flag, 0x400) then
			if L.selfClass == "WARRIOR"
				and L.config.classSpell_SR
				and L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.ready then
			
				PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.config.classSpell_SR_sound_file), L.config.sound_channel)
			end
		end
	else
		LCG.AutoCastGlow_Stop(unitFrame.castBar.border)
	end
end

local function UpdateCastBarSize(unitFrame)
	if unitFrame.castBar:IsShown() then
		local mSize = 1
		if L.config.mythic_plus_enable
			and unitFrame.mapID
			and unitFrame.npcID
			and unitFrame.castBar.spellID
			and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][unitFrame.castBar.spellID] then
			
			mSize = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][unitFrame.castBar.spellID].size or 1
		end
		
		if L.config.cb_type == 1 then
			unitFrame.castBar:SetSize(L.config.cb_1_size_X * mSize * (unitFrame.isPlayerTarget and L.config.cb_target_scale or 1), L.config.cb_1_size_Y * mSize * (unitFrame.isPlayerTarget and L.config.cb_target_scale or 1))
			unitFrame.castBar.iconFrame.border.shadow:Hide()
		elseif L.config.cb_type == 2 then
			local r, g, b = unpack(MyCastingBarFrame_GetEffectiveStartColor(unitFrame.castBar, unitFrame.castBar.channeling, unitFrame.castBar.notInterruptible))
			unitFrame.castBar.iconFrame.border.shadow:SetBackdropBorderColor(r, g, b, L.config.cb_sb_alpha[L.config.cb_type])
			unitFrame.castBar.iconFrame.border.shadow:Show()
			unitFrame.castBar.iconFrame:SetSize(L.config.cb_2_icon_size_X * mSize * (unitFrame.isPlayerTarget and L.config.cb_target_scale or 1), L.config.cb_2_icon_size_Y * mSize * (unitFrame.isPlayerTarget and L.config.cb_target_scale or 1))
		elseif L.config.cb_type == 3 then
			unitFrame.castBar:SetSize(unitFrame.healthBar:GetWidth(), L.config.cb_3_size_Y)
			unitFrame.castBar.iconFrame:SetSize((unitFrame.healthBar:GetHeight() + L.config.cb_3_size_Y + 1) * 1.4, unitFrame.healthBar:GetHeight() + L.config.cb_3_size_Y + 1)
			unitFrame.castBar.iconFrame.border.shadow:Hide()
		elseif L.config.cb_type == 4 then
			unitFrame.castBar:SetSize(L.config.cb_4_size_X * mSize * (unitFrame.isPlayerTarget and L.config.cb_target_scale or 1), L.config.cb_4_size_Y * mSize * (unitFrame.isPlayerTarget and L.config.cb_target_scale or 1))
			unitFrame.castBar.iconFrame.border.shadow:Hide()
		end
	end
end

local function MyCastingBarFrame_ChallengeUpdate(unitFrame, spellID, notInterruptible, event)
	if unitFrame.mapID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] then --not unitFrame.isPlayer and
		
		if not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID] then
			namePlateMixin:AddSpellToDatabase(unitFrame.mapID, unitFrame.npcID, spellID, notInterruptible)
		end

		-- v akom instanceType bol prevedeny
		if not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag then
			L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag = L.instanceFLAG
		elseif not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, L.instanceFLAG) then
			L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag + L.instanceFLAG
		end
		
		if notInterruptible and not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x20) then
			L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag + 0x20
		elseif not notInterruptible and FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x20) then
			L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag - 0x20
		end
				
		-- kontrola vzdy ci je to cast alebo channeling
		if unitFrame.castBar:IsShown() then -- and unitFrame.castBar.spellID == spellID 
			if unitFrame.castBar.casting then
				if not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x40) then
					L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag + 0x40
				end
			else
				if not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x80) then
					L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag + 0x80
				end
			end
		end
		
		-- ak spell je instant, ma casting cast alebo iba channeling cast bez casting casti
		if L.config.spellCD and (FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x100) or unitFrame.castBar.casting or (unitFrame.castBar.channeling and not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x40))) then
			namePlateMixin:UpdateSpellCD(unitFrame, spellID, false)
		end
		
		if L.config.mythic_plus_enable then
			local spellName = GetSpellInfo(spellID)
			--update infoPanel ak je zapnuty na pridanie castu
			if L.config.mythic_NPC_infoPanel and unitFrame.isPlayerTarget then
				npcInfoPanelMixin:ShowNPCInfoPanel(unitFrame.npcID, unitFrame.mapID)
			end
			
			if unitFrame.castBar:IsShown() then
				UpdateCastBarSize(unitFrame)
			end
							
			if L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].textPanel then
				textPanelMixin:ShowText(spellName, 2, nil, 30)
			end
										
			-- zahraj sound file ak je nastaveny
			if L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].sound then --and unitFrame.threatStatus then
				if (not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].tanksound and not L.isSelfTank) 
					or (L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].tanksound and L.isSelfTank) 
					or L.isSelfTank then
					
					--namePlateMixin:DebugLog(spellID.." "..event, nil, nil, true)
					PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].sound), L.config.sound_channel)			
				end
			end
			
			if (L.config.cb_speak_int and not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x20))
				or (L.config.cb_speak_noInt and FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x20))
				or (L.config.cb_speak_mythic and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].speak) then
				
				C_VoiceChat.SpeakText(L.config.cb_speak_voiceID, spellName, Enum.VoiceTtsDestination.LocalPlayback, L.config.cb_speak_rate, L.config.cb_speak_volume)
			end
			
			-- focus cast warning
			if L.config.mythic_focus_warning then
				if unitFrame.isFocus and not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, 0x20) then
					if L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].sound then
						PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.config.mythic_focus_sound_file), L.config.sound_channel)
					
						if L.config.mythic_focus_flash then
							myFlashFrame.bg:SetVertexColor(unpack(L.config.mythic_focus_flash_color))
							UIFrameFlash(myFlashFrame, L.config.mythic_focus_flash_speed, L.config.mythic_focus_flash_speed, 4 * L.config.mythic_focus_flash_speed, false)
						end
					end
				end
			end

			UpdateWarningCastToTarget(unitFrame)					
		end
	end
end

-- obsluha eventov urcenych pri vzniku nameplate pre castbar
local function MyCastingBarFrame_OnEvent(castBar, event, ...)
	local unit = ...
	local parentUnitFrame = castBar:GetParent()
	
	if ( event == "PLAYER_ENTERING_WORLD" and castBar.unit) then
		local nameChannel = UnitChannelInfo(castBar.unit)
		local nameSpell = UnitCastingInfo(castBar.unit)
		if ( nameChannel ) then
			event = "UNIT_SPELLCAST_CHANNEL_START"
			unit = castBar.unit
		elseif ( nameSpell ) then
			event = "UNIT_SPELLCAST_START"
			unit = castBar.unit
		else
			MyCastingBarFrame_FinishSpell(castBar)
			return
		end
	end
	
	if unit ~= castBar.unit then return end
	
	if (event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START") then
		local spellName, text, spellTexture, startTime, endTime, isTradeSkill, castID, notInterruptible, spellID = UnitCastingInfo(unit)
		local isChannel = false
		if not spellName then
			spellName, text, spellTexture, startTime, endTime, isTradeSkill, notInterruptible, spellID = UnitChannelInfo(unit)
			isChannel = true
		end
		
		if ( not spellName or (not castBar.showTradeSkills and isTradeSkill) or  L.config.cb_target_hide ) then
			castBar:Hide()
			return
		end

		parentUnitFrame.maxAlpha = false
		castBar.spellID = spellID
		
		local r, g, b = unpack(MyCastingBarFrame_GetEffectiveStartColor(castBar, isChannel, notInterruptible))
		local a = L.config.cb_sb_alpha[L.config.cb_type]
		castBar.notInterruptible = notInterruptible
		
		castBar:SetStatusBarColor(r, g, b, a)
		castBar.border.bg:SetVertexColor(r / 3, g / 3, b / 3, L.config.cb_bg_alpha[L.config.cb_type])
				
		if L.config.cb_flashColorSameAsStart then
			castBar.Flash:SetVertexColor(r, g, b, a)
		else
			castBar.Flash:SetVertexColor(1, 1, 1, 1)
		end
		if isChannel then
			castBar.value = (endTime / 1000) - GetTime()
		else
			castBar.value = (GetTime() - (startTime / 1000))
		end
		castBar.maxValue = (endTime - startTime) / 1000
		castBar:SetMinMaxValues(0, castBar.maxValue)
		castBar:SetValue(castBar.value)
		
		if ( castBar.Spark and not isChannel ) then
			castBar.Spark:SetVertexColor(r, g, b, L.config.cb_spark_show and L.config.cb_spark_alpha or 0)
			castBar.Spark:SetSize(24, castBar:GetHeight() * 2)
			castBar.Spark:Show()
		else
			castBar.Spark:Hide()
		end
		
		if ( castBar.Text ) then
			castBar.Text:SetText(L.config.cb_show_spellName and spellName or nil)
		end
		if ( castBar.Icon ) then
			castBar.Icon:SetTexture(spellTexture)
			if ( castBar.iconWhenNoninterruptible and not isChannel ) then
				castBar.Icon:SetShown(not notInterruptible)
			end
		end
		
		MyCastingBarFrame_ApplyAlpha(castBar, L.config.cb_alpha)
				
		if isChannel then
			castBar.casting = nil
			castBar.channeling = true
		else
			castBar.casting = true
			castBar.channeling = nil
			castBar.castID = castID
		end
		castBar.holdTime = 0
		castBar.fadeOut = nil

		if ( castBar.BorderShield ) then
			if ( castBar.showShield and notInterruptible ) then
				castBar.BorderShield:Show();
				if ( castBar.BarBorder ) then
					castBar.BarBorder:Hide();
				end
			else
				castBar.BorderShield:Hide();
				if ( castBar.BarBorder ) then
					castBar.BarBorder:Show();
				end
			end
		end
		
		if ( castBar.showCastbar ) then
			castBar:Show()
		end
		
		castBar.kickerNameText:SetText(nil)
		castBar.kickerNameBGTexture:Hide()
		
		castBar.targetNameText:SetText(nil)
		castBar.targetNameBGTexture:Hide()
		
		UpdateCastBarSize(parentUnitFrame)
				
		if not L.isSavedMap then
			if (L.config.cb_speak_int and not notInterruptible) or (L.config.cb_speak_noInt and notInterruptible) then
				C_VoiceChat.SpeakText(L.config.cb_speak_voiceID, spellName, Enum.VoiceTtsDestination.LocalPlayback, L.config.cb_speak_rate, L.config.cb_speak_volume)
			end
		end
			
		if castBar.casting or castBar.channeling then
			MyCastingBarFrame_ChallengeUpdate(parentUnitFrame, spellID, notInterruptible, event)
		end
				
		if not L.isSavedMap and L.config.healer_detection then
			if L.HealersSpellsList[spellName] and (not HEALERS_TABLE[parentUnitFrame.unitName]) and parentUnitFrame.isPlayer and not parentUnitFrame.unitType == "friendly" then
				HEALERS_TABLE[parentUnitFrame.unitName] = true
				parentUnitFrame.healerIcon:Show()
				PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.config.healer_detection_sound), L.config.sound_channel)
			end
		end
		
	elseif (event == "UNIT_SPELLCAST_SUCCEEDED") then
		local unit, castGUID, spellID = ...
		-- ak nieje uz v BlackListe
		if not L.MythicNPCData["BlackList"][spellID] then
			local nameplate = C_NamePlate_GetNamePlateForUnit(unit, issecure())
			
			if nameplate.UnitFrame.mapID and nameplate.UnitFrame.npcID and L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID] then
				-- ak neexistuje v databaze alebo v blacklistu
				if not L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID] then
					--test na duplicitu
					for map in pairs(L.MythicNPCData) do
						if tonumber(map) then
							for npc in pairs(L.MythicNPCData[map]) do
								if tonumber(npc) then
									for spell in pairs(L.MythicNPCData[map][npc]) do
										if tonumber(spell) and spellID == spell then
											L.MythicNPCData["BlackList"][spellID] = true
											L.MythicNPCData[map][npc][spell] = nil
										end
									end
								end
							end
						end
					end
					
					if not L.MythicNPCData["BlackList"][spellID] then
						namePlateMixin:AddSpellToDatabase(nameplate.UnitFrame.mapID, nameplate.UnitFrame.npcID, spellID, true)
						if not FlagsUtil.IsSet(L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag, 0x100) then
							L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag = L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag + 0x100
						end
					else
						return
					end
				end
				
				-- oprava ak uz bol zavedeny pred touto verziou
				--if not L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag then
				--	namePlateMixin:DebugLog("FLAG DONT EXIST "..nameplate.UnitFrame.mapID.." "..nameplate.UnitFrame.npcID.." "..spellID, nil, nil, true)
				--	L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag = 0x20
				--end
					
				-- ak to nie je casting ani channeling (tie volaju MyCastingBarFrame_ChallengeUpdate z UNIT_SPELLCAST_START) 
				if not FlagsUtil.IsSet(L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag, 0x40) and not FlagsUtil.IsSet(L.MythicNPCData[nameplate.UnitFrame.mapID][nameplate.UnitFrame.npcID][spellID].flag, 0x80) then
					MyCastingBarFrame_ChallengeUpdate(nameplate.UnitFrame, spellID, true, event)
				end
			end
		end
		
	elseif (event == "UNIT_SPELLCAST_INTERRUPTED" or event == "UNIT_SPELLCAST_FAILED") then
		local unit, castGUID, spellID = ...
		
		if ( castBar:IsShown() and castBar.casting and castGUID == castBar.castID and not castBar.fadeOut ) then
			castBar:SetValue(castBar.maxValue)
			local r, g, b = unpack(L.config.cb_failedCastColor)
			castBar:SetStatusBarColor(r, g, b, L.config.cb_sb_alpha[L.config.cb_type])
			if ( castBar.Spark ) then
				castBar.Spark:Hide()
			end
			if ( castBar.Text ) then
				if ( event == "UNIT_SPELLCAST_FAILED" ) then
					castBar.Text:SetText(FAILED)
				elseif ( event == "UNIT_SPELLCAST_INTERRUPTED" ) then 
					castBar.Text:SetText(INTERRUPTED)
				end
			end
			castBar.casting = nil
			castBar.channeling = nil
			castBar.fadeOut = true
			castBar.holdTime = GetTime() + 1 --CASTING_BAR_HOLD_TIME
			castBar.spellID = nil
		end
		
		if castBar:IsShown() then
			if ( castBar.isPlayerTargetForCast ) then
				LCG.AutoCastGlow_Stop(castBar.border)
			end
		
			if L.config.playersInfo[L.selfClass][L.selfSpec].kickSpell and L.config.cb_show_CD then
				local start, duration = GetSpellCooldown(L.config.playersInfo[L.selfClass][L.selfSpec].kickSpell)
				if start and (start > 0) and (duration > 1.5) then
					local CD = start + duration - GetTime()
					castBar.CDText:SetFormattedText('%1.0f', CD)
				else 
					castBar.CDText:SetText(nil)
				end
			else
				castBar.CDText:SetText(nil)
			end
		end
		
	elseif ((event == "UNIT_SPELLCAST_STOP") or (event == "UNIT_SPELLCAST_CHANNEL_STOP")) then
		local unit, castGUID, spellID = ...
		if ( not castBar:IsVisible() ) then
			castBar:Hide()
		end
		if ( (castBar.casting and event == "UNIT_SPELLCAST_STOP" and castGUID == castBar.castID) or (castBar.channeling and event == "UNIT_SPELLCAST_CHANNEL_STOP") ) then
			if ( castBar.Spark ) then
				castBar.Spark:Hide()
			end
			if ( castBar.Flash ) then
				castBar.Flash:SetAlpha(0)
				castBar.Flash:Show()
			end
			castBar:SetValue(castBar.maxValue)
			if ( event == "UNIT_SPELLCAST_STOP" ) then
				castBar.casting = nil
				if not L.config.cb_finishedColorSameAsStart then
					local r, g, b = unpack(L.config.cb_finishedCastColor)
					castBar:SetStatusBarColor(r, g, b, L.config.cb_sb_alpha[L.config.cb_type])
				end
			else
				castBar.channeling = nil
			end
			castBar.flash = true
			castBar.fadeOut = true
			castBar.holdTime = 0
			castBar.spellID = nil
		end
		
		if ( castBar.isPlayerTargetForCast ) then
			LCG.AutoCastGlow_Stop(castBar.border)
		end
		--[[ ak to tu nilnem nezobrazim kto to kickol :(
		if ( castBar.Text ) then
			castBar.Text:SetText(nil)
		end]]--
		if ( castBar.kickerNameText ) then
			castBar.kickerNameText:SetText(nil)
			castBar.kickerNameBGTexture:Hide()
		end
		
		if ( castBar.targetNameText ) then
			castBar.targetNameText:SetText(nil)
			castBar.targetNameBGTexture:Hide()
		end
		
	elseif ( event == "UNIT_SPELLCAST_DELAYED" ) then
		if ( castBar:IsShown() ) then
			local name, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo(unit)
			if ( not name or (not castBar.showTradeSkills and isTradeSkill)) then
				castBar:Hide()
				return;
			end
			castBar.value = (GetTime() - (startTime / 1000))
			castBar.maxValue = (endTime - startTime) / 1000
			castBar:SetMinMaxValues(0, castBar.maxValue)
			if ( not castBar.casting ) then
				local r, g, b = unpack(MyCastingBarFrame_GetEffectiveStartColor(castBar, false, notInterruptible))
				castBar:SetStatusBarColor(r, g, b, L.config.cb_sb_alpha[L.config.cb_type])
				if ( castBar.Spark ) then
					castBar.Spark:Show()
				end
				if ( castBar.Flash ) then
					castBar.Flash:SetAlpha(0)
					castBar.Flash:Hide()
				end
				castBar.casting = true
				castBar.channeling = nil
				castBar.flash = nil
				castBar.fadeOut = nil
				castBar.spellID = nil
			end
		end
		
	elseif ( event == "UNIT_SPELLCAST_CHANNEL_UPDATE" ) then
		if ( castBar:IsShown() ) then
			local name, text, texture, startTime, endTime, isTradeSkill = UnitChannelInfo(unit)
			if ( not name or (not castBar.showTradeSkills and isTradeSkill)) then
				castBar:Hide()
				return
			end
			castBar.value = ((endTime / 1000) - GetTime())
			castBar.maxValue = (endTime - startTime) / 1000
			castBar:SetMinMaxValues(0, castBar.maxValue)
			castBar:SetValue(castBar.value)
		end
	
	elseif ( event == "UNIT_SPELLCAST_INTERRUPTIBLE" or event == "UNIT_SPELLCAST_NOT_INTERRUPTIBLE" ) then
		MyCastingBarFrame_UpdateInterruptibleState(castBar, event == "UNIT_SPELLCAST_NOT_INTERRUPTIBLE");
	end
end

-- event volany pri update castBaru - moooooc krat
local function MyCastingBarFrame_OnUpdate(self, elapsed)
	if ( self.casting ) then
		self.value = self.value + elapsed
		if ( self.value >= self.maxValue ) then
			self:SetValue(self.maxValue)
			MyCastingBarFrame_FinishSpell(self, self.Spark, self.Flash)
			return;
		end
		self:SetValue(self.value)
		if ( self.Flash ) then
			self.Flash:Hide()
		end
		if ( self.Spark ) then
			local sparkPosition = (self.value / self.maxValue) * self:GetWidth();
			self.Spark:SetPoint("RIGHT", self, "LEFT", sparkPosition, self.Spark.offsetY or 2)
		end
	elseif ( self.channeling ) then
		self.value = self.value - elapsed
		if ( self.value <= 0 ) then
			MyCastingBarFrame_FinishSpell(self, self.Spark, self.Flash)
			return;
		end
		self:SetValue(self.value)
		if ( self.Flash ) then
			self.Flash:Hide()
		end
	elseif ( GetTime() < self.holdTime ) then
		return;
	elseif ( self.flash ) then
		local alpha = 0
		if ( self.Flash ) then
			alpha = self.Flash:GetAlpha() + 0.2 --CASTING_BAR_FLASH_STEP
		end
		if ( alpha < 1 ) then
			if ( self.Flash ) then
				self.Flash:SetAlpha(alpha)
			end
		else
			if ( self.Flash ) then
				self.Flash:SetAlpha(1)
			end
			self.flash = nil
		end
	elseif ( self.fadeOut ) then
		local alpha = self:GetAlpha() - 0.05 --CASTING_BAR_ALPHA_STEP
		if ( alpha > 0 ) then
			MyCastingBarFrame_ApplyAlpha(self, alpha)
		else
			self.fadeOut = nil
			self:Hide()
		end
	end
	
	-- vykonaj maximalne 5 x za sec
	self.elapsed = (self.elapsed or 0) + elapsed
	if self.elapsed < .2 then return end
	self.elapsed = 0
	
	if L.config.playersInfo[L.selfClass][L.selfSpec].kickSpell and L.config.cb_show_CD then
		local start, duration = GetSpellCooldown(L.config.playersInfo[L.selfClass][L.selfSpec].kickSpell)
		if start and (start > 0) and (duration > 1.5) then
			local CD = start + duration - GetTime()
			self.CDText:SetFormattedText('%1.0f', CD)
		else 
			self.CDText:SetText(nil)
		end
	else
		self.CDText:SetText(nil)
	end
end

local function MyCastingBarFrame_SetUnit(self, unit, showTradeSkills, showShield)
	if self.unit ~= unit then
		self.unit = unit
		self.showTradeSkills = showTradeSkills
		self.showShield = showShield

		self.casting = nil
		self.channeling = nil
		self.holdTime = 0
		self.fadeOut = nil

		if unit then
			self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
			self:RegisterEvent("UNIT_SPELLCAST_DELAYED")
			self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
			self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
			self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
			self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTIBLE")
			self:RegisterEvent("UNIT_SPELLCAST_NOT_INTERRUPTIBLE")
			self:RegisterEvent("PLAYER_ENTERING_WORLD")
			self:RegisterUnitEvent("UNIT_SPELLCAST_START", unit)
			self:RegisterUnitEvent("UNIT_SPELLCAST_STOP", unit)
			self:RegisterUnitEvent("UNIT_SPELLCAST_FAILED", unit)
			self:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", unit)
			MyCastingBarFrame_OnEvent(self, "PLAYER_ENTERING_WORLD")
		else
			self:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED")
			self:UnregisterEvent("UNIT_SPELLCAST_DELAYED")
			self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START")
			self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
			self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
			self:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTIBLE")
			self:UnregisterEvent("UNIT_SPELLCAST_NOT_INTERRUPTIBLE")
			self:UnregisterEvent("PLAYER_ENTERING_WORLD")
			self:UnregisterEvent("UNIT_SPELLCAST_START")
			self:UnregisterEvent("UNIT_SPELLCAST_STOP")
			self:UnregisterEvent("UNIT_SPELLCAST_FAILED")
			self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			self:Hide()
		end
	end
end

local function UpdateCastBar(unitFrame)
	if unitFrame.unitType == "self" then return end
	
	unitFrame.castBar:ClearAllPoints()
	unitFrame.castBar.iconFrame:ClearAllPoints()
		
	if L.config.cb_type == 1 then
		PixelUtil.SetPoint(unitFrame.castBar, "CENTER", unitFrame, "CENTER", L.config.cb_1_posun_X, L.config.cb_1_posun_Y)
		PixelUtil.SetPoint(unitFrame.castBar.iconFrame, "TOPLEFT", unitFrame.castBar, "TOPLEFT", L.config.cb_1_offset, -L.config.cb_1_offset)
		PixelUtil.SetPoint(unitFrame.castBar.iconFrame, "BOTTOMRIGHT", unitFrame.castBar, "BOTTOMRIGHT", -L.config.cb_1_offset, L.config.cb_1_offset)
		unitFrame.castBar.CDText:SetParent(unitFrame.castBar.iconFrame)
		unitFrame.castBar.iconFrame:SetFrameLevel(unitFrame.castBar:GetFrameLevel() + 1)
		unitFrame.castBar.kickerNameBGTexture:SetParent(unitFrame.castBar)
		unitFrame.castBar.targetNameBGTexture:SetParent(unitFrame.castBar)
		unitFrame.castBar.kickerNameText:SetParent(unitFrame.castBar)
		unitFrame.castBar.targetNameText:SetParent(unitFrame.castBar)
		
	elseif L.config.cb_type == 2 then
		PixelUtil.SetPoint(unitFrame.castBar, "TOPLEFT", unitFrame.healthBar, "TOPLEFT", -L.config.cb_2_offset, L.config.cb_2_offset)
		PixelUtil.SetPoint(unitFrame.castBar, "BOTTOMRIGHT", unitFrame.healthBar, "BOTTOMRIGHT", L.config.cb_2_offset, -L.config.cb_2_offset)
		PixelUtil.SetPoint(unitFrame.castBar.iconFrame, L.config.cb_2_align, unitFrame.castBar, L.config.cb_2_align, L.config.cb_2_icon_posun_X, L.config.cb_2_icon_posun_Y)
		unitFrame.castBar.CDText:SetParent(unitFrame.castBar.iconFrame)
		unitFrame.castBar.iconFrame:SetFrameLevel(unitFrame.castBar:GetFrameLevel() + 1)
		unitFrame.castBar.kickerNameBGTexture:SetParent(unitFrame.castBar.iconFrame)
		unitFrame.castBar.targetNameBGTexture:SetParent(unitFrame.castBar.iconFrame)
		unitFrame.castBar.kickerNameText:SetParent(unitFrame.castBar.iconFrame)
		unitFrame.castBar.targetNameText:SetParent(unitFrame.castBar.iconFrame)
		
	elseif L.config.cb_type == 3 then
		PixelUtil.SetPoint(unitFrame.castBar, "TOPLEFT", unitFrame.healthBar, "BOTTOMLEFT", 0, -2)
		PixelUtil.SetPoint(unitFrame.castBar, "TOPRIGHT", unitFrame.healthBar, "BOTTOMRIGHT", 0, L.config.cb_3_size_Y)
		unitFrame.castBar.iconFrame:SetSize((unitFrame.healthBar:GetHeight() + L.config.cb_3_size_Y + 2) * 1.4, unitFrame.healthBar:GetHeight() + L.config.cb_3_size_Y + 2)
		unitFrame.castBar.CDText:SetParent(unitFrame.castBar.iconFrame)
		unitFrame.castBar.iconFrame:SetFrameLevel(unitFrame.castBar:GetFrameLevel() + 1)
		if L.config.cb_3_icon_position then
			PixelUtil.SetPoint(unitFrame.castBar.iconFrame, "BOTTOMRIGHT", unitFrame.castBar, "BOTTOMLEFT", -3, 1)
		else
			PixelUtil.SetPoint(unitFrame.castBar.iconFrame, "BOTTOMLEFT", unitFrame.castBar, "BOTTOMRIGHT", 3, 1)
		end
		unitFrame.castBar.kickerNameBGTexture:SetParent(unitFrame.castBar)
		unitFrame.castBar.targetNameBGTexture:SetParent(unitFrame.castBar)
		unitFrame.castBar.kickerNameText:SetParent(unitFrame.castBar)
		unitFrame.castBar.targetNameText:SetParent(unitFrame.castBar)
		
	elseif L.config.cb_type == 4 then
		PixelUtil.SetPoint(unitFrame.castBar, "CENTER", unitFrame, "CENTER", L.config.cb_4_posun_X, L.config.cb_4_posun_Y)
		PixelUtil.SetPoint(unitFrame.castBar.iconFrame, "TOPLEFT", unitFrame.castBar, "TOPLEFT", 0, 0)
		PixelUtil.SetPoint(unitFrame.castBar.iconFrame, "BOTTOMRIGHT", unitFrame.castBar, "BOTTOMRIGHT", 0, 0)
		unitFrame.castBar.CDText:SetParent(unitFrame.castBar)
		unitFrame.castBar.iconFrame:SetFrameLevel(unitFrame.castBar:GetFrameLevel() - 1)
		unitFrame.castBar.kickerNameBGTexture:SetParent(unitFrame.castBar)
		unitFrame.castBar.targetNameBGTexture:SetParent(unitFrame.castBar)
		unitFrame.castBar.kickerNameText:SetParent(unitFrame.castBar)
		unitFrame.castBar.targetNameText:SetParent(unitFrame.castBar)
	end
	
	unitFrame.castBar.Text:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.cb_font), L.config.cb_fontsize, L.config.cb_font_flag)
	unitFrame.castBar.CDText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.cb_CD_font), L.config.cb_CD_fontsize, L.config.cb_CD_font_flag)
	
	unitFrame.castBar.kickerNameText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.cb_kicker_font), L.config.cb_kicker_fontsize, L.config.cb_kicker_font_flag)
	unitFrame.castBar.kickerNameBGTexture:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.cb_kickerNameBGTexture))
	unitFrame.castBar.kickerNameBGTexture:SetVertexColor(unpack(L.config.cb_kicker_texture_color))
	
	unitFrame.castBar.targetNameText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.cb_kicker_font), L.config.cb_kicker_fontsize, L.config.cb_kicker_font_flag)
	unitFrame.castBar.targetNameBGTexture:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.cb_kickerNameBGTexture))
	unitFrame.castBar.targetNameBGTexture:SetVertexColor(unpack(L.config.cb_kicker_texture_color))
	
	PixelUtil.SetPoint(unitFrame.castBar.border.shadow, "TOPLEFT", unitFrame.castBar.border, "TOPLEFT", - L.config.cb_shadow_offset, L.config.cb_shadow_offset)
	PixelUtil.SetPoint(unitFrame.castBar.border.shadow, "BOTTOMRIGHT", unitFrame.castBar.border, "BOTTOMRIGHT", L.config.cb_shadow_offset,  - L.config.cb_shadow_offset)
	if L.config.cb_sb_shadow[L.config.cb_type] then
		unitFrame.castBar.border.shadow:SetBackdrop({bgFile = nil, edgeFile = mediaFolder.."glowTex", edgeSize = L.config.cb_shadow_offset, tile = false, tileSize = 0, insets = 1})
		unitFrame.castBar.border.shadow:Show()
	else
		unitFrame.castBar.border.shadow:Hide()
	end
	unitFrame.castBar.border.shadow:SetBackdropBorderColor(0, 0, 0, 1)
	
	if not L.config.cb_schoolColor then 
		namePlateMixin:SetMyBorderColor(unitFrame.castBar.border, 0, 0, 0, 1)
	end
	unitFrame.castBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.cb_texture_bg[L.config.cb_type]))
	unitFrame.castBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.cb_texture[L.config.cb_type]))
	unitFrame.castBar.Flash:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.cb_texture_bg[L.config.cb_type]))
end

local function MyCastingBarFrame_OnLoad(unitFrame)
	if unitFrame.unitType == "self" or (unitFrame.isPlayer and unitFrame.unitType == "friendly" and not L.config.cb_friendly_show) then 
		MyCastingBarFrame_SetUnit(unitFrame.castBar, nil, nil, nil)
		unitFrame.castBar.showCastbar = false
		return
	end

	local unit = unitFrame.displayedUnit or unitFrame.unit
		
	if not unitFrame.castBar.additionalFadeWidgets then
		unitFrame.castBar.additionalFadeWidgets = {}
	end
	unitFrame.castBar.additionalFadeWidgets[unitFrame.castBar.Icon] = true
				
	MyCastingBarFrame_SetUnit(unitFrame.castBar, unit, false, false)
	
	unitFrame.castBar.showCastbar = true
	unitFrame.castBar:SetFrameStrata("HIGH")
	unitFrame.castBar:SetFrameLevel(unitFrame:GetFrameLevel() + 3)
end

---------------------------------------------------
-- WIDGETS
local function UpdateWidgetsOnlyMode(unitFrame)
	if not L.config.widget_show or not unitFrame.widgetSet then
		if unitFrame.WidgetContainer then
			unitFrame.WidgetContainer:Hide()
		end
		return
	end
	
	if unitFrame.widgetsOnly then
		UpdateHealthBar(unitFrame, false, "UpdateWidgetsOnlyMode")
		if unitFrame.castBar then
			MyCastingBarFrame_SetUnit(unitFrame.castBar, nil, nil, nil);
			unitFrame.castBar.showCastbar = false
		end
	else
		if unitFrame.castBar then
			MyCastingBarFrame_SetUnit(unitFrame.castBar, unitFrame.unit, false, true)
			unitFrame.castBar.showCastbar = true
		end
	end
			
	if unitFrame.WidgetContainer then
		unitFrame.WidgetContainer:ClearAllPoints()
		if unitFrame.widgetsOnly then
			PixelUtil.SetPoint(unitFrame.WidgetContainer, "BOTTOM", unitFrame, "TOP", 0, 0)
		else
			PixelUtil.SetPoint(unitFrame.WidgetContainer, "BOTTOM", unitFrame, "TOP", 0, 0)
		end
		unitFrame.WidgetContainer:SetScale(L.config.widget_scale)
		unitFrame.WidgetContainer:Show()
	end
end

local function DefaultLayoutStyle(widgetContainerFrame, sortedWidgets)
		local horizontalRowContainer = nil
		local horizontalRowHeight = 0
		local horizontalRowWidth = 0
		local totalWidth = 0
		local totalHeight = 0
	
		widgetContainerFrame.horizontalRowContainerPool:ReleaseAll()

		for index, widgetFrame in ipairs(sortedWidgets) do
			widgetFrame:ClearAllPoints()

			local widgetSetUsesVertical = widgetContainerFrame.widgetSetLayoutDirection == Enum.UIWidgetSetLayoutDirection.Vertical
			local widgetUsesVertical = widgetFrame.layoutDirection == Enum.UIWidgetLayoutDirection.Vertical

			local useOverlapLayout = widgetFrame.layoutDirection == Enum.UIWidgetLayoutDirection.Overlap
			local useVerticalLayout = widgetUsesVertical or (widgetFrame.layoutDirection == Enum.UIWidgetLayoutDirection.Default and widgetSetUsesVertical)

			if useOverlapLayout then
				if index == 1 then
					if widgetSetUsesVertical then
						widgetFrame:SetPoint(widgetContainerFrame.verticalAnchorPoint, widgetContainerFrame)
					else
						widgetFrame:SetPoint(widgetContainerFrame.horizontalAnchorPoint, widgetContainerFrame)
					end
				else
					local relative = sortedWidgets[index - 1]
					if widgetSetUsesVertical then
						widgetFrame:SetPoint(widgetContainerFrame.verticalAnchorPoint, relative, widgetContainerFrame.verticalAnchorPoint, 0, 0)
					else
						widgetFrame:SetPoint(widgetContainerFrame.horizontalAnchorPoint, relative, widgetContainerFrame.horizontalAnchorPoint, 0, 0)
					end
				end
				
				local width, height = widgetFrame:GetSize()
				if width > totalWidth then
					totalWidth = width
				end
				if height > totalHeight then
					totalHeight = height
				end

				widgetFrame:SetParent(widgetContainerFrame)
			elseif useVerticalLayout then 
				if index == 1 then
					widgetFrame:SetPoint(widgetContainerFrame.verticalAnchorPoint, widgetContainerFrame)
				else
					local relative = horizontalRowContainer or sortedWidgets[index - 1]
					widgetFrame:SetPoint(widgetContainerFrame.verticalAnchorPoint, relative, widgetContainerFrame.verticalRelativePoint, 0, widgetContainerFrame.verticalAnchorYOffset)

					if horizontalRowContainer then
						horizontalRowContainer:SetSize(horizontalRowWidth, horizontalRowHeight)
						totalWidth = totalWidth + horizontalRowWidth
						totalHeight = totalHeight + horizontalRowHeight
						horizontalRowHeight = 0
						horizontalRowWidth = 0
						horizontalRowContainer = nil
					end
					if widgetContainerFrame.verticalAnchorYOffset then
						totalHeight = totalHeight + widgetContainerFrame.verticalAnchorYOffset
					end
				end

				widgetFrame:SetParent(widgetContainerFrame)
				
				local width, height = widgetFrame:GetSize()
				if width > totalWidth then
					totalWidth = width
				end
				totalHeight = totalHeight + height
			else
				local forceNewRow = widgetFrame.layoutDirection == Enum.UIWidgetLayoutDirection.HorizontalForceNewRow
				local needNewRowContainer = not horizontalRowContainer or forceNewRow
				if needNewRowContainer then 
					if horizontalRowContainer then 
						horizontalRowContainer:SetSize(horizontalRowWidth, horizontalRowHeight)
						totalWidth = totalWidth + horizontalRowWidth
						totalHeight = totalHeight + horizontalRowHeight
						horizontalRowHeight = 0
						horizontalRowWidth = 0
					end

					local newHorizontalRowContainer = widgetContainerFrame.horizontalRowContainerPool:Acquire()
					newHorizontalRowContainer:Show()
					if index == 1 then
						newHorizontalRowContainer:SetPoint(widgetContainerFrame.verticalAnchorPoint, widgetContainerFrame, widgetContainerFrame.verticalAnchorPoint)
					else 
						local relative = horizontalRowContainer or sortedWidgets[index - 1]
						newHorizontalRowContainer:SetPoint(widgetContainerFrame.verticalAnchorPoint, relative, widgetContainerFrame.verticalRelativePoint, 0, widgetContainerFrame.verticalAnchorYOffset)
						if widgetContainerFrame.verticalAnchorYOffset then
							totalHeight = totalHeight + widgetContainerFrame.verticalAnchorYOffset
						end
					end
					widgetFrame:SetPoint("BOTTOM", newHorizontalRowContainer)
					widgetFrame:SetParent(newHorizontalRowContainer)
					horizontalRowWidth = horizontalRowWidth + widgetFrame:GetWidth()
					horizontalRowContainer = newHorizontalRowContainer
				else
					local relative = sortedWidgets[index - 1]
					widgetFrame:SetParent(horizontalRowContainer)
					widgetFrame:SetPoint(widgetContainerFrame.horizontalAnchorPoint, relative, widgetContainerFrame.horizontalRelativePoint, widgetContainerFrame.horizontalAnchorXOffset, 0)
					if widgetContainerFrame.horizontalAnchorXOffset then
						horizontalRowWidth = horizontalRowWidth + widgetFrame:GetWidth() + widgetContainerFrame.horizontalAnchorXOffset
					else
						horizontalRowWidth = horizontalRowWidth + widgetFrame:GetWidth()
					end
				end
				
				local widgetHeight = widgetFrame:GetHeight()
				if widgetHeight > horizontalRowHeight then
					horizontalRowHeight = widgetHeight
				end
			end
					
			
		end
			
		if horizontalRowContainer then 
			horizontalRowContainer:SetSize(horizontalRowWidth, horizontalRowHeight)
			totalWidth = totalWidth + horizontalRowWidth
			totalHeight = totalHeight + horizontalRowHeight
			horizontalRowHeight = 0
			horizontalRowWidth = 0
		end 
		
	widgetContainerFrame:SetSize(totalWidth, totalHeight)
end

local function ClearWidgetSet(unitFrame)
	if unitFrame.WidgetContainer then
		unitFrame.WidgetContainer:UnregisterForWidgetSet()
	end
end


local function UpdateWidgetSet(unitFrame)
	if unitFrame.WidgetContainer and L.config.widget_show then
		unitFrame.WidgetContainer:RegisterForWidgetSet(unitFrame.widgetSet, DefaultLayoutStyle, nil, unitFrame.unit)
	end
end

---------------------------------------------------
-- RAID MARKS
function namePlateMixin:SetAllRaidMarks(combatAutoMark)
	local namePlatesSorted = {}
	wipe(USED_RAID_MARKS)
	
	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		SetRaidTarget(namePlate.UnitFrame.displayedUnit, 0)
		if namePlate.UnitFrame.mapID and namePlate.UnitFrame.npcID and tonumber(L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc) then --namePlate.UnitFrame.unitType ~= "player"
			-- ak je v markovanej grp autoMark NPC omarkuj ho az ako posledne
			if L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].autoMark then
				namePlate.UnitFrame.distance = L.config.auto_mark_maxDistance
			else
				namePlate.UnitFrame.distance = RCH:GetRange(namePlate.UnitFrame.unit)
			end
			table_insert(namePlatesSorted, namePlate)
			if L.config.mythic_desc then
			--	namePlate.UnitFrame.helpText:SetText(ConvertNumToIconsString(namePlate.UnitFrame, L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc))
			--	namePlate.UnitFrame.helpText:Show()
			end
		elseif L.config.mark_target and namePlate.UnitFrame.isPlayerTarget and not combatAutoMark then
			SetRaidTarget(namePlate.UnitFrame.displayedUnit, 8)
			USED_RAID_MARKS[8] = true
		end
	end
	
	table_sort(namePlatesSorted, function(a, b) return a.UnitFrame.distance < b.UnitFrame.distance end)
		
	for _, namePlate in pairs(namePlatesSorted) do
		for i = 1, string_len(L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc) do
			local c = tonumber(L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc:sub(i,i))
			if c and (c >= 1 and c <= 8) and not USED_RAID_MARKS[c] and namePlate.UnitFrame.distance <= L.config.auto_mark_maxDistance then
				SetRaidTarget(namePlate.UnitFrame.displayedUnit, c)
				USED_RAID_MARKS[c] = true
				break
			end
		end
	end
	
	wipe(namePlatesSorted)
end

function namePlateMixin:ClearAllRaidMarks()
	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		SetRaidTarget(namePlate.UnitFrame.displayedUnit, 0)
		if L.config.mythic_desc and namePlate.UnitFrame.mapID and L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc then
			namePlate.UnitFrame.helpText:SetText(ConvertNumToIconsString(namePlate.UnitFrame, L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc))
			namePlate.UnitFrame.helpText:Show()
		end
	end
end
			
local function UpdateRaidTargetUnit(unitFrame)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local index = GetRaidTargetIndex(unit)
	
	if unitFrame.unitType == "self" then
		unitFrame.raidTargetIndex = nil
		namePlateMixin:SetMyBorderColor(unitFrame.healthBar.border, 0, 0, 0, 1)
		LCG.AutoCastGlow_Stop(unitFrame.healthBar.border)
		unitFrame.RaidTargetFrame.RaidTargetIcon:Hide()
	
	elseif ( index and index < 9 ) then
		unitFrame.raidTargetIndex = index
		USED_RAID_MARKS[index] = true
		if L.config.mark_show then
			if  L.config.mark_type == "type_2" then
				unitFrame.RaidTargetFrame.RaidTargetIcon:SetTexCoord(0, 1, 0, 1)
				unitFrame.RaidTargetFrame.RaidTargetIcon:SetTexture(mediaFolder.."marks\\"..index)
			elseif L.config.mark_type == "type_1" then
				unitFrame.RaidTargetFrame.RaidTargetIcon:SetTexture(mediaFolder.."marks\\raidicons")
				SetRaidTargetIconTexture(unitFrame.RaidTargetFrame.RaidTargetIcon, index)
			else
				unitFrame.RaidTargetFrame.RaidTargetIcon:SetTexture([[Interface\TargetingFrame\UI-RaidTargetingIcons]])
				SetRaidTargetIconTexture(unitFrame.RaidTargetFrame.RaidTargetIcon, index)
			end
			unitFrame.RaidTargetFrame:ClearAllPoints()
			unitFrame.RaidTargetFrame:SetPoint(L.config.mark_point,unitFrame.healthBar, L.config.mark_relativePoint, L.config.mark_posun_X, L.config.mark_posun_Y)
			unitFrame.RaidTargetFrame:SetSize(L.config.mark_size, L.config.mark_size)
			unitFrame.RaidTargetFrame.RaidTargetIcon:Show()
		else
			unitFrame.RaidTargetFrame.RaidTargetIcon:Hide()
		end
			
		
		if L.config.mark_border then
			namePlateMixin:SetMyBorderColor(unitFrame.healthBar.border, unpack(L.config.mark_color[index]))
		elseif L.config.healthbar_show[unitFrame.unitType] then
			namePlateMixin:SetMyBorderColorByUnit(unitFrame.healthBar.border)
		end
		
		if L.config.mark_animation then
			LCG.AutoCastGlow_Start(unitFrame.healthBar.border, L.config.mark_color[index], 12, nil, 1, 0, 0, "", 0)
		else
			LCG.AutoCastGlow_Stop(unitFrame.healthBar.border)
		end
		
		if L.config.mark_healthbar then
			unitFrame.healthBar.color = L.config.mark_color[unitFrame.raidTargetIndex]
		else
			if L.isSelfTank then
				UpdateThreat(unitFrame, true)
			else
				UpdateHealth(unitFrame)
			end
		end			
				
		--UpdateHealthBar(unitFrame, true, "UpdateRaidTargetUnit")
	
	elseif unitFrame.raidTargetIndex then
		USED_RAID_MARKS[unitFrame.raidTargetIndex] = false
		unitFrame.raidTargetIndex = nil
				
		if L.config.healthbar_show[unitFrame.unitType]  then
			namePlateMixin:SetMyBorderColorByUnit(unitFrame.healthBar.border)
		end
		
		LCG.AutoCastGlow_Stop(unitFrame.healthBar.border)
		unitFrame.RaidTargetFrame.RaidTargetIcon:Hide()
		
		if L.isSelfTank and not unitFrame.isPlayer then
			UpdateThreat(unitFrame, true)
		else
			UpdateHealth(unitFrame)
		end

		--UpdateHealthBar(unitFrame, false, "UpdateRaidTargetUnit")
	else
		--UpdateHealthBar(unitFrame, false, "UpdateRaidTargetUnit")
	end
	
	UpdateHealthBar(unitFrame)
	
	if L.config.mythic_desc and unitFrame.mapID and unitFrame.npcID and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].desc then
		unitFrame.helpText:SetText(ConvertNumToIconsString(unitFrame, L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].desc))
		unitFrame.helpText:Show()
	elseif unitFrame.isQuest and L.config.quest_text then
		unitFrame.helpText:Show()
	else
		unitFrame.helpText:Hide()
	end
end

--------------------------------------------
-- PARTY table functions
function namePlateMixin:BestKickerFromPartyTable()
	local shortestCD = 100
	local bestPrio = L.config.mythic_kicker_no_long_CD and 48 or 50
	local bestKickerGUID = nil
	local nowTime = GetTime()
	
	for guid in pairs(namePlateMixin.PARTY_TABLE) do
		if namePlateMixin.PARTY_TABLE[guid] and namePlateMixin.PARTY_TABLE[guid].prio < bestPrio and not USED_RAID_MARKS[L.config.mythic_kicker_mark[namePlateMixin.PARTY_TABLE[guid].mark]] then
			if ( nowTime > namePlateMixin.PARTY_TABLE[guid].expirationTime ) then
				shortestCD = 0
				bestKickerGUID = guid
				bestPrio = namePlateMixin.PARTY_TABLE[guid].prio
			elseif ( shortestCD > (namePlateMixin.PARTY_TABLE[guid].expirationTime - nowTime)) then
				bestKickerGUID = guid
				shortestCD = namePlateMixin.PARTY_TABLE[guid].expirationTime - nowTime
			end
		end
	end
	
	return bestKickerGUID or nil
end

function namePlateMixin:UpdatePartyTable()
	for guid in pairs(namePlateMixin.PARTY_TABLE) do
		namePlateMixin.PARTY_TABLE[guid].prio = L.config.playersInfo[namePlateMixin.PARTY_TABLE[guid].class][namePlateMixin.PARTY_TABLE[guid].spec].prio or 0
		namePlateMixin.PARTY_TABLE[guid].kickSpell = L.config.playersInfo[namePlateMixin.PARTY_TABLE[guid].class][namePlateMixin.PARTY_TABLE[guid].spec].kickSpell
	end
end

function namePlateMixin:SortPartyTableMark()
	local sortedTable = {}

	for guid in pairs(namePlateMixin.PARTY_TABLE) do
		table_insert(sortedTable, {namePlateMixin.PARTY_TABLE[guid].prio, namePlateMixin.PARTY_TABLE[guid]})
	end

	table_sort(sortedTable, function(a, b) return a[1] < b[1] end)

	for i=1, #sortedTable do
		namePlateMixin.PARTY_TABLE[sortedTable[i][2].guid].mark = i
	end
	
	wipe(sortedTable)
end

function namePlateMixin:SortPartyTable(sortType)
	local sortedTable = {}
	for guid in pairs(namePlateMixin.PARTY_TABLE) do
		if sortType	== "prio" then
			table_insert(sortedTable, {namePlateMixin.PARTY_TABLE[guid].prio, namePlateMixin.PARTY_TABLE[guid]})
		elseif sortType	== "time" then
			table_insert(sortedTable, {namePlateMixin.PARTY_TABLE[guid].expirationTime, namePlateMixin.PARTY_TABLE[guid]})
		elseif sortType	== "party" then
			namePlateMixin.PARTY_TABLE[guid].index = self:IsPartyGUID(guid)
			table_insert(sortedTable, {namePlateMixin.PARTY_TABLE[guid].index, namePlateMixin.PARTY_TABLE[guid]})
		end
	end
	
	table_sort(sortedTable, function(a, b) return a[1] < b[1] end)
				
	for i=1, #sortedTable do
		namePlateMixin.PARTY_TABLE[sortedTable[i][2].guid].index = i
	end
	
	if L.config.player_resource_type == 2 or L.config.player_resource_type == 3 then
		for guid in pairs(namePlateMixin.PARTY_TABLE) do
			if L.config.player_resource_type == 2 then
				classBarMixin:ClassBarUpdateHB("GROUP_ROSTER_UPDATE", namePlateMixin.PARTY_TABLE[guid].unit, guid)
			elseif L.config.player_resource_type == 3 then
				classBarMixin:ClassBarUpdateKick(guid)
			end
		end
	end
	
	wipe(sortedTable)
	namePlateMixin:SortPartyTableMark()
end

function namePlateMixin:AddToPartyTable(event, guid, unit, info)
	local grpIndex = self:IsPartyGUID(guid)
	if (not namePlateMixin.PARTY_TABLE[guid] or namePlateMixin.PARTY_TABLE[guid].spec ~= info.spec_index) and info.spec_index and info.class and grpIndex then 
		namePlateMixin.PARTY_TABLE[guid] = namePlateMixin.PARTY_TABLE[guid] or {}
		namePlateMixin.PARTY_TABLE[guid].guid = guid
		namePlateMixin.PARTY_TABLE[guid].unit = unit
		namePlateMixin.PARTY_TABLE[guid].name = info.name
		namePlateMixin.PARTY_TABLE[guid].class = info.class
		namePlateMixin.PARTY_TABLE[guid].spec = info.spec_index
		namePlateMixin.PARTY_TABLE[guid].classColor = RAID_CLASS_COLORS[info.class]
		namePlateMixin.PARTY_TABLE[guid].prio = L.config.playersInfo[info.class][info.spec_index].prio or 0
		namePlateMixin.PARTY_TABLE[guid].kickSpell = L.config.playersInfo[info.class][info.spec_index].kickSpell
		namePlateMixin.PARTY_TABLE[guid].kickCount = 0
		namePlateMixin.PARTY_TABLE[guid].kickCountSucced = 0
		
		if not namePlateMixin.PARTY_TABLE[guid].kickSpell then
			namePlateMixin.PARTY_TABLE[guid].expirationTime = 10000000
		else
			namePlateMixin.PARTY_TABLE[guid].expirationTime = namePlateMixin.PARTY_TABLE[guid].expirationTime or GetTime()
		end
		namePlateMixin.PARTY_TABLE[guid].index = grpIndex
				
		namePlateMixin:SortPartyTable(L.config.party_kick_sort)
	end
end

function namePlateMixin:RemoveFromPartyTable(event, guid)
	if namePlateMixin.PARTY_TABLE[guid] then
		for tguid in pairs(namePlateMixin.PARTY_TABLE) do
			if L.config.player_resource_type == 2 or L.config.player_resource_type == 3 then
				if tguid == guid and L.config.player_resource_type == 3 then
					myClassBar[namePlateMixin.PARTY_TABLE[tguid].index]:SetScript("OnUpdate", nil)
				end
				myClassBar[namePlateMixin.PARTY_TABLE[tguid].index]:Hide()
			end
		end
		namePlateMixin.PARTY_TABLE[guid] = nil
		namePlateMixin:SortPartyTable(L.config.party_kick_sort)		
	end
end

---------------------------------------------------
-- ZISENIE A OBSLUHA GUILD DESCRIPTION
local function UpdateUnitDecription(unitFrame)
	if L.config.desc_text_show and not L.isChallengeMapActive and unitFrame.unitType ~= "self" and not unitFrame.isPet then
		local unit = unitFrame.displayedUnit or unitFrame.unit
		unitFrame.descText:Hide()
		
		if not unitFrame.healthBar:IsShown() then
			unitFrame.descText:SetAlpha(L.config.desc_text_alpha_nohb)
		else
			unitFrame.descText:SetAlpha(L.config.desc_text_alpha_hb)
		end
			
		if unitFrame.isPlayer then
			unitFrame.descText:SetText(GetGuildInfo(unit))
			unitFrame.descText:SetTextColor(unpack(L.config.desc_text_color_guild))
			unitFrame.descText:Show()
		else
			QuestPlateTooltip:SetOwner(_G.UIParent, 'ANCHOR_NONE')
			QuestPlateTooltip:SetUnit(unit)
			QuestPlateTooltip:Show()
	
			local tooltipLine = _G['QuestPlateTooltipTextLeft2']
			local tooltipLineStr = tooltipLine and tooltipLine:GetText()
			-- som na konci tooltipu ?
			if tooltipLineStr then
				local text = string_match(tooltipLineStr, "^"..TOOLTIP_UNIT_LEVEL:gsub("%%.%$?s?",".+").."$")
				if not text then
					unitFrame.descText:SetText(tooltipLineStr)
					unitFrame.descText:SetTextColor(unpack(L.config.desc_text_color))
					unitFrame.descText:Show()
				end
			end
			QuestPlateTooltip:Hide()
		end
	else
		unitFrame.descText:Hide()
	end
end

---------------------------------------------------
-- ZISENIE A OBSLUHA QUEST
local function UpdateQuest(unitFrame)
	--local scenarioName, currentStage, numStages, flags, hasBonusStep, isBonusStepComplete, _, xp, money, scenarioType, areaName, textureKit = C_Scenario.GetInfo()
	--local ScenarioInformation = C_ScenarioInfo.GetScenarioInfo() ScenarioInformation.name, currentStage, numStages, flags, isComplete, xp, money, type, area, uiTextureKit
	--local stageName, stageDescription, numCriteria, _, _, _, _, numSpells, spellInfo, weightedProgress, _, widgetSetID = C_Scenario.GetStepInfo()
	--local criteriaString, criteriaType, completed, quantity, totalQuantity, flags, assetID, quantityString, criteriaID, duration, elapsed, criteriaFailed, isWeightedProgress = C_Scenario.GetCriteriaInfo(select(3, C_Scenario.GetStepInfo()))
	
	unitFrame.questIcon:Hide()
	unitFrame.helpText:Hide()
	unitFrame.questValue = nil
	unitFrame.isQuest = false
	
	if not L.config.quest_detection or L.isChallengeMapActive 
		or unitFrame.unitType == "self"
		or unitFrame.isPlayer
		or (unitFrame.unitType == "friendly" and not L.config.quest_friendly) then
		
		return
	end
	
	--print(unitFrame.unitName)
	
	local text, type, perc, numFulfilled, numRequired
	local haveUsableQuest = false
	local haveUsableProgressBar = false
	local unit = unitFrame.displayedUnit or unitFrame.unit
	local toolTipData = {}
	local scenarioName = C_Scenario.GetInfo()
	
	local tooltipData = C_TooltipInfo.GetUnit(unitFrame.unit)

	--print("Unit Faction: ", tooltipData.lines[3].leftText)

	-- nacitaj toolTip do pola
	QuestPlateTooltip:SetOwner(_G.UIParent, 'ANCHOR_NONE')
	QuestPlateTooltip:SetUnit(unit)
	QuestPlateTooltip:Show()
	for i = 3, QuestPlateTooltip:NumLines() do
		local tooltipLine = _G['QuestPlateTooltipTextLeft' .. i]
		toolTipData[i - 2] = tooltipLine and tooltipLine:GetText()
	end
	QuestPlateTooltip:Hide()
	
	
	for toolTipIndex, tooltipLineStr in ipairs(toolTipData) do
		-- ak som v aktivnom scenrio
		if scenarioName and tooltipLineStr == scenarioName then
			local _, _, numCriteria = C_Scenario_GetStepInfo()
			for questLogIndex = 1, numCriteria do
				if haveUsableQuest then break end
				local criteriaString, _, completed, quantity, totalQuantity, _, _, quantityString = C_Scenario_GetCriteriaInfo(questLogIndex)
				if not completed then
					for index = toolTipIndex + 1, #toolTipData do
						if not toolTipData[index] then break end
										
						local k, l = string_gsub(toolTipData[index], "-", " "), string_gsub(criteriaString, "-", " ")
						if string_find(k, l) or toolTipData[index] == criteriaString then
							local isPerc = string_match(quantityString, "(%d+)%%")
							text, type, perc, numFulfilled, numRequired = criteriaString, isPerc and "progressbar" or "default", isPerc and quantity or 0, quantity, totalQuantity
							haveUsableQuest = true
							break
						end
					end
				end
			end
		end
		
		-- ak nebol najdeny v scenario
		if not haveUsableQuest then
			for questLogIndex = 1, C_QuestLog_GetNumQuestLogEntries() do
				if haveUsableQuest then break end
				if tooltipLineStr == C_QuestLog_GetTitleForLogIndex(questLogIndex) then
					local questID = C_QuestLog_GetQuestIDForLogIndex(questLogIndex)
					local objectives = C_QuestLog_GetQuestObjectives(questID)
					--print(C_TooltipInfo.GetQuestPartyProgress(questID))
					if (objectives) and (#objectives > 0) then
						for index = toolTipIndex + 1, #toolTipData do
							if not toolTipData[index] or haveUsableQuest then break end
														
							for _, objectiveInfo in pairs(objectives) do
								if not objectiveInfo.finished then
									local i, j = string_gsub(toolTipData[index], "-", " "), string_gsub(objectiveInfo.text, "-", " ")
									--print(toolTipData[index], objectiveInfo.text)
									if string_find(i, j) or toolTipData[index] == objectiveInfo.text then
										text, type, perc, numFulfilled, numRequired = objectiveInfo.text, objectiveInfo.type, objectiveInfo.type == "progressbar" and GetQuestProgressBarPercent(questID) or 0, objectiveInfo.numFulfilled, objectiveInfo.numRequired
										if objectiveInfo.type ~= "progressbar" then
											haveUsableQuest = true
											break
										else
											haveUsableProgressBar = true
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	
	
	-- ak sa nasiel 
	if haveUsableQuest or haveUsableProgressBar then
		
		unitFrame.isQuest = true
		if L.config.quest_text or (perc == 0 and numFulfilled == 0 and numRequired == 0) then
			local current, goal, progressText
			if perc == 0 then
				-- vyfiltrujem X/Y ak je v premenej text
				current, goal, progressText = string_match(text, "(%d+)/(%d+)(.+)$")
				if (not current and not goal) then
					progressText, current, goal = string_match(text, "(.+) (%d+)/(%d+)")
				end
			end
			unitFrame.helpText:SetText(progressText)
			unitFrame.helpText:Show()
		else
			unitFrame.helpText:Hide()
		end
			
		if L.config.quest_value then
			if type == "progressbar" then
				unitFrame.questValue = "|cffffffff"..perc.."%|r"
			elseif L.config.quest_value_full then
				unitFrame.questValue = "|cffffffff"..numFulfilled.."/"..numRequired.."|r"
			else
				unitFrame.questValue = "|cffffffff"..(numRequired - numFulfilled).."|r"
			end
		else
			unitFrame.questValue = nil
		end
				
		if L.config.quest_icon then
			unitFrame.questIcon:SetPoint("LEFT", unitFrame.nameText, "RIGHT", L.config.quest_icon_x, L.config.quest_icon_y)
			if L.config.quest_icon_extended then
				if L.config.quest_icon_type[type][2] then
					unitFrame.questIcon:SetAtlas(L.config.quest_icon_type[type][1])
					unitFrame.questIcon:Show()
				else
					unitFrame.questIcon:Hide()	
				end
			else
				unitFrame.questIcon:SetAtlas(L.config.quest_icon_type["default"][1])
				unitFrame.questIcon:Show()
			end
		else
			unitFrame.questIcon:Hide()	
		end
			
		if L.config.quest_sound_enable then
			if NPC_TABLE[unitFrame.unitGUID] and not NPC_TABLE[unitFrame.unitGUID].playedsound then
				PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.config.quest_sound), L.config.sound_channel)
				NPC_TABLE[unitFrame.unitGUID].playedsound = true
			end
		end
	end
	
	wipe(toolTipData)
end

local function UpdateCreatureIcon(unitFrame)
	local unit = unitFrame.displayedUnit or unitFrame.unit
	if not unit then return end
	
	unitFrame.creatureIconFrame:Hide()	
	
	if L.config.creature_icon_enable and not unitFrame.isPlayer then
		
		if unitFrame.unitName == UNKNOWN then
			unitFrame.unitName = UnitName(unitFrame.unit) or UNKNOWN
			C_Timer_After(1, function() UpdateCreatureIcon(unitFrame) end)
			return
		end
				
		if not unitFrame.creatureType then
			unitFrame.creatureType = UnitCreatureType(unit)
		end
		
		unitFrame.classification = UnitClassification(unit)
				
		if not unitFrame.creatureType or not unitFrame.classification then
			C_Timer_After(1, function() UpdateCreatureIcon(unitFrame) end)
			return
		end
				
		if (unitFrame.classification == "worldboss" or UnitLevel(unit) == -1) then
			if L.config.creature_boss_enable then
				unitFrame.creatureIconFrame:SetSize(L.config.creature_size["boss"], L.config.creature_size["boss"])
				unitFrame.creatureIconFrame.creatureIcon:SetVertexColor(unpack(L.config.creature_color["boss"]))
				unitFrame.creatureIconFrame:Show()
			end
			
		elseif (unitFrame.classification == "rare" or unitFrame.classification == "rareelite") then
			if L.config.creature_rare_enable then
				unitFrame.creatureIconFrame:SetSize(L.config.creature_size["rare"], L.config.creature_size["rare"])
				unitFrame.creatureIconFrame.creatureIcon:SetVertexColor(unpack(L.config.creature_color["rare"]))
				unitFrame.creatureIconFrame:Show()
			end
			
		elseif unitFrame.classification == "elite" then
			if L.config.creature_elite_enable then
				unitFrame.creatureIconFrame:SetSize(L.config.creature_size["elite"], L.config.creature_size["elite"])
				unitFrame.creatureIconFrame.creatureIcon:SetVertexColor(unpack(L.config.creature_color["elite"]))
				unitFrame.creatureIconFrame:Show()
			end
			
		elseif L.config.creature_other_enable then
			unitFrame.creatureIconFrame:SetSize(L.config.creature_size["other"], L.config.creature_size["other"])
			unitFrame.creatureIconFrame.creatureIcon:SetVertexColor(unpack(L.config.creature_color["other"]))
			unitFrame.creatureIconFrame:Show()
		end
	
		if unitFrame.creatureIconFrame:IsShown() then
			if L.config.creature_new_style then
				unitFrame.creatureIconFrame.creatureIconBG:SetTexture(mediaFolder.."creature\\"..unitFrame.creatureType)
				unitFrame.creatureIconFrame.creatureIcon:SetTexture(mediaFolder.."creature\\"..unitFrame.creatureType)
			else
				unitFrame.creatureIconFrame.creatureIconBG:SetAtlas("auctionhouse-icon-favorite")
				unitFrame.creatureIconFrame.creatureIcon:SetAtlas("auctionhouse-icon-favorite")
			end
			
			unitFrame.creatureIconFrame:ClearAllPoints()
			if unitFrame.healthBar:IsShown() then
				unitFrame.creatureIconFrame:SetPoint(L.config.creature_icon_hb_point , unitFrame.healthBar, L.config.creature_icon_hb_relativePoint, L.config.creature_icon_hb_posun_X, L.config.creature_icon_hb_posun_Y)
			else
				unitFrame.creatureIconFrame:SetPoint(L.config.creature_icon_nohb_point , unitFrame.nameText, L.config.creature_icon_nohb_relativePoint, L.config.creature_icon_nohb_posun_X, L.config.creature_icon_nohb_posun_Y)
			end
		end
	end
end

local function UpdateDiminishBar(unitFrame)
	if L.config.diminish_enable then
		if NPC_TABLE[unitFrame.unitGUID] and NPC_TABLE[unitFrame.unitGUID].count and NPC_TABLE[unitFrame.unitGUID].count > 0 then
			unitFrame.diminishBar.expirationTime = NPC_TABLE[unitFrame.unitGUID].expirationTime
			local r, g, b, a = unpack(L.config.diminish_color[NPC_TABLE[unitFrame.unitGUID].count])
			unitFrame.diminishBar:SetStatusBarColor(r, g, b, a)
			unitFrame.diminishBar.border.bg:SetVertexColor(r / 3, g / 3, b / 3, 1)
			unitFrame.diminishBar:Show()

			-- este podmienku ak uz je po expirationtime
			unitFrame.diminishBar:SetScript("OnUpdate", 
				function(self, elapsed)
					local timeLeft = self.expirationTime - GetTime()
					if timeLeft > 0 then
						PixelUtil.SetStatusBarValue(self, timeLeft)
					else
						self:SetScript("OnUpdate", nil)
						self:Hide()
					end
				end
			)
		end
	else
		unitFrame.diminishBar:Hide()
	end
end
	
function namePlateMixin:UpdateInVehicle(unitFrame)
	local shouldTargetVehicle = UnitHasVehicleUI(unitFrame.unit)
	local unitVehicleToken
	
	if ( shouldTargetVehicle ) then
		local prefix, id, suffix = string_match(unitFrame.unit, "([^%d]+)([%d]*)(.*)")
		unitVehicleToken = prefix.."pet"..id..suffix
		if ( not UnitExists(unitVehicleToken) ) then
			shouldTargetVehicle = false
		end
	end
	
	if ( shouldTargetVehicle ) then
		if ( not unitFrame.hasValidVehicleDisplay ) then
			unitFrame.hasValidVehicleDisplay = true
			unitFrame.displayedUnit = unitVehicleToken
			unitFrame:SetAttribute("unit", unitFrame.displayedUnit)
			self:UpdateNamePlateEvents(unitFrame)
		end
	else
		if ( unitFrame.hasValidVehicleDisplay ) then
			unitFrame.hasValidVehicleDisplay = false
			unitFrame.displayedUnit = unitFrame.unit
			unitFrame:SetAttribute("unit", unitFrame.displayedUnit)
			self:UpdateNamePlateEvents(unitFrame)
		end
	end
end

function namePlateMixin:UpdateVisible(unitFrame)
	if ( UnitExists(unitFrame.unit) or UnitExists(unitFrame.displayedUnit) ) then
		if ( not unitFrame.unitExists ) then
			unitFrame.newUnit = true
		end
		unitFrame.unitExists = true
		unitFrame:Show()
	else
		ClearWidgetSet(unitFrame)
		unitFrame:Hide()
		unitFrame.unitExists = false
	end
end

function namePlateMixin:UpdateMyTarget()
	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		if namePlate.UnitFrame.isPlayerTarget then		--este skusit not UnitIsUnit(namePlate.UnitFrame.unit, "target")
			namePlate.UnitFrame.isPlayerTarget = false
			
			namePlate.UnitFrame.targetOverlapTexture:Hide()
			
			UpdateHealthBarTexture(namePlate.UnitFrame)
			UpdateName(namePlate.UnitFrame, "Terget")
			UpdateHealthBar(namePlate.UnitFrame, false, "UpdateMyTarget")
			
			LCG.PixelGlow_Stop(namePlate.UnitFrame.healthBar)
			
			if namePlate.UnitFrame.healthBar.border.shadow.AnimFlash:IsPlaying() then 
				namePlate.UnitFrame.healthBar.border.shadow.AnimFlash:Stop()
			end
			
			-- Hide infoPanel pre tento target
			if L.config.mythic_NPC_infoPanel then
				npcInfoPanelMixin:HideNPCInfoPanel()
			end

			-- uprava sparc na HB
			if L.config.healthbar_spark[namePlate.UnitFrame.unitType] then
				namePlate.UnitFrame.healthBar.spark:SetSize(16, namePlate.UnitFrame.healthBar:GetHeight() * 2)
			end
			
			if L.config.hp_enable or L.config.hp_target_enable then
				namePlate.UnitFrame.healthText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.hp_font), L.config.hp_fontsize, L.config.hp_font_flag)
				UpdateHealth(namePlate.UnitFrame)
			end
						
			UpdateCastBarSize(namePlate.UnitFrame)
			break
		end				
	end
	
	local targetPlate = C_NamePlate_GetNamePlateForUnit('target', issecure())
	if targetPlate and targetPlate.UnitFrame.unitType ~= "self" and not targetPlate.UnitFrame.isPlayerTarget then
		targetPlate.UnitFrame.isPlayerTarget = true
	
		if L.config.target_overlap_show then
			targetPlate.UnitFrame.targetOverlapTexture:ClearAllPoints()
			PixelUtil.SetPoint(targetPlate.UnitFrame.targetOverlapTexture, "TOPLEFT", targetPlate.UnitFrame.healthBar, "TOPLEFT", - L.config.target_overlap_offset, L.config.target_overlap_offset)
			PixelUtil.SetPoint(targetPlate.UnitFrame.targetOverlapTexture, "BOTTOMRIGHT", targetPlate.UnitFrame.healthBar, "BOTTOMRIGHT", L.config.target_overlap_offset, -L.config.target_overlap_offset)
			targetPlate.UnitFrame.targetOverlapTexture:SetVertexColor(unpack(L.config.target_overlap_color))
			targetPlate.UnitFrame.targetOverlapTexture:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.target_overlap))
			targetPlate.UnitFrame.targetOverlapTexture:SetTexCoord(unpack(L.texture_flip_table[L.config.target_overlap_flip]))
			targetPlate.UnitFrame.targetOverlapTexture:SetBlendMode(L.config.target_overlap_blend)
			targetPlate.UnitFrame.targetOverlapTexture:Show()
		else
			targetPlate.UnitFrame.targetOverlapTexture:Hide()
		end	
		
		UpdateHealthBarTexture(targetPlate.UnitFrame)
		UpdateName(targetPlate.UnitFrame, "Target")
		UpdateHealthBar(targetPlate.UnitFrame, nil, "UpdateMyTarget")
		
		if L.config.target_glow then
			LCG.PixelGlow_Start(targetPlate.UnitFrame.healthBar, L.config.target_glow_color, L.config.target_glow_number, L.config.target_glow_speed, L.config.target_glow_width, L.config.target_glow_height, L.config.target_glow_xOffset, L.config.target_glow_yOffset, L.config.target_glow_border, "", 0)
		end
		
		if L.config.target_shadow and L.config.target_shadow_flash then
			targetPlate.UnitFrame.healthBar.border.shadow.AnimFlash:Play()
		end
		
		-- Show infoPanel pre tento target
		if L.config.mythic_NPC_infoPanel then
			npcInfoPanelMixin:ShowNPCInfoPanel(targetPlate.UnitFrame.npcID, L.mapID)
		end
		
		-- uprava sparc na HB
		if L.config.healthbar_spark[targetPlate.UnitFrame.unitType] then
			targetPlate.UnitFrame.healthBar.spark:SetSize(16, targetPlate.UnitFrame.healthBar:GetHeight() * 2)
		end
		
		if L.config.hp_enable or L.config.hp_target_enable then
			targetPlate.UnitFrame.healthText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.hp_font), L.config.hp_fontsize * 1.4, L.config.hp_font_flag)
			UpdateHealth(targetPlate.UnitFrame)
		end
		
		UpdateCastBarSize(targetPlate.UnitFrame)
	end	
end

-- pre volanie z configu
function namePlateMixin:UpdateFocus()
	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		if namePlate.UnitFrame.isFocus then
			UpdateHealthBarTexture(namePlate.UnitFrame)
			UpdateName(namePlate.UnitFrame)
			UpdateHealthBar(namePlate.UnitFrame, L.config.focus_enable, "UpdateFocus")
			break
		end
	end
end

function namePlateMixin:UpdateMyFocus()
	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		if namePlate.UnitFrame.isFocus then
			namePlate.UnitFrame.isFocus = false
			UpdateHealthBarTexture(namePlate.UnitFrame)
			UpdateName(namePlate.UnitFrame)
			UpdateHealthBar(namePlate.UnitFrame, false, "UpdateMyFocus")
		end
	end
	
	local targetPlate = C_NamePlate_GetNamePlateForUnit('target', issecure())
	if targetPlate and not UnitIsUnit(targetPlate.UnitFrame.unit, "player") then
		targetPlate.UnitFrame.isFocus = UnitIsUnit(targetPlate.UnitFrame.unit, "focus")
		UpdateHealthBarTexture(targetPlate.UnitFrame)
		UpdateName(targetPlate.UnitFrame)
		UpdateHealthBar(targetPlate.UnitFrame, targetPlate.UnitFrame.isFocus, "UpdateMyFocus")
	end	
end

function namePlateMixin:UpdateAllOnNameplate(unitFrame, who)
	self:UpdateInVehicle(unitFrame)
	self:UpdateVisible(unitFrame)
	if unitFrame.unitType == "self" then
		unitFrame.castBar:UnregisterAllEvents()
		return
	end
	if ( UnitExists(unitFrame.displayedUnit) ) then
		UpdateQuest(unitFrame)
		UpdateName(unitFrame, "All")
		UpdateHealth(unitFrame)
		UpdateAbsorb(unitFrame)
		UpdateMaxPower(unitFrame)
		UpdatePower(unitFrame)
		MyCastingBarFrame_OnLoad(unitFrame)
		UpdateAllAuras(unitFrame)
		UpdateRaidTargetUnit(unitFrame)
		UpdateUnitDecription(unitFrame)
		UpdateCreatureIcon(unitFrame)
		UpdateDiminishBar(unitFrame)
		UpdateWidgetsOnlyMode(unitFrame)
		UpdateWidgetSet(unitFrame)
		self:UpdateNamePlateByChallenge(unitFrame)
		UpdateThreat(unitFrame, true)
		
		if unitFrame.isPlayerTarget then
			self:UpdateMyTarget()
		end
	end
end

function namePlateMixin:MyTest()
end

local function NamePlate_OnEvent(self, event, ...)
	local unit, arg2, arg3, arg4 = ...
	
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		namePlateMixin:UpdateAllOnNameplate(self, "PLAYER_ENTERING_WORLD")
		
	elseif ( unit == self.unit or unit == self.displayedUnit ) then
		if ( event == "UNIT_HEALTH" ) then
			UpdateHealth(self)
			UpdateAbsorb(self)
		
		elseif ( event == "UNIT_MAXPOWER" ) then
			UpdateMaxPower(self);
			UpdatePower(self)
		
		elseif ( event == "UNIT_POWER_UPDATE" ) then
			UpdatePower(self)
			
		elseif ( event == "UNIT_AURA" ) then
			local isFullUpdate = arg2;
			local updateAuraInfos = arg3;
			UpdateAllAuras(self, isFullUpdate, updateAuraInfos)
		
		elseif ( event == "UNIT_THREAT_SITUATION_UPDATE" )then
			UpdateThreat(self, false)
			
		elseif ( event == "UNIT_THREAT_LIST_UPDATE" ) then
			UpdateThreat(self, false)
			
		elseif ( event == "UNIT_NAME_UPDATE" ) then
			UpdateName(self, event)
			
		elseif ( event == "UNIT_ENTERED_VEHICLE" or event == "UNIT_EXITED_VEHICLE" or event == "UNIT_PET") then
			namePlateMixin:UpdateAllOnNameplate(self, event)
			
		elseif ( event == "UNIT_ABSORB_AMOUNT_CHANGED" ) or ( event == "UNIT_HEAL_ABSORB_AMOUNT_CHANGED" ) then
			UpdateAbsorb(self)
		
		elseif ( event == "UNIT_CLASSIFICATION_CHANGED" ) then
			UpdateCreatureIcon(self)
		
		elseif ( event == "UNIT_TARGET" and not UnitIsPlayer(unit) ) then
			local namePlate = C_NamePlate_GetNamePlateForUnit(unit, issecure())
			if namePlate then
				UpdateWarningCastToTarget(namePlate.UnitFrame)
			end
		end
	end
end

function namePlateMixin:UpdateNamePlateEvents(unitFrame)
	local unit = unitFrame.unit
	local displayedUnit
	if ( unit ~= unitFrame.displayedUnit ) then
		displayedUnit = unitFrame.displayedUnit
	end
		
	for _, event in pairs({
		"UNIT_HEALTH",
		"UNIT_MAXPOWER",
		"UNIT_POWER_UPDATE",
		"UNIT_AURA",
		"UNIT_THREAT_LIST_UPDATE",
		"UNIT_THREAT_SITUATION_UPDATE",
		"UNIT_ABSORB_AMOUNT_CHANGED",
		"UNIT_HEAL_ABSORB_AMOUNT_CHANGED",
		"UNIT_CLASSIFICATION_CHANGED",
	}) do unitFrame:RegisterUnitEvent(event, unit, displayedUnit) end
end

function namePlateMixin:NamePlate_RegisterEvents(unitFrame)
	for _, event in pairs({
		"UNIT_NAME_UPDATE",
		"PLAYER_ENTERING_WORLD",
		"UNIT_PET",
		"UNIT_ENTERED_VEHICLE",
		"UNIT_EXITED_VEHICLE",
		"UNIT_TARGET",
	}) do unitFrame:RegisterEvent(event) end
	unitFrame:SetScript("OnEvent", NamePlate_OnEvent)
	self:UpdateNamePlateEvents(unitFrame)
end

function namePlateMixin:NamePlate_UnregisterEvents(unitFrame)
	unitFrame:UnregisterAllEvents()
	unitFrame:SetScript("OnEvent", nil)
end

local function GetNamePlateTypeFromUnit(unit)
	if UnitIsUnit("player", unit) then
		return "self"
	elseif UnitIsFriend("player", unit) then
		return "friendly"
	else
		return "enemy"
	end
end

function namePlateMixin:SetUnit(unitFrame, namePlateUnitToken)
	unitFrame.unit = namePlateUnitToken
	unitFrame.displayedUnit = namePlateUnitToken
	unitFrame:SetAttribute("unit", namePlateUnitToken)
	
	unitFrame:SetScale(1)
	unitFrame.newUnit = true
	unitFrame.maxAlpha = false
	unitFrame.isColoredName = false
	unitFrame.isMouseover = false
	unitFrame.isTanking = nil
	unitFrame.threatStatus = nil
	unitFrame.threatPercent = nil
	unitFrame.threatBar:Hide()
	unitFrame.threatText:Hide()
	unitFrame.helpText:Hide()
	unitFrame.descText:Hide()
	unitFrame.rangeText:Hide()
	unitFrame.healthText:Hide()
	unitFrame.isQuest = false
	unitFrame.questValue = nil
	unitFrame.questIcon:Hide()
	unitFrame.targetOverlapTexture:Hide()
	unitFrame.healthBar.border.shadow:Hide()
	unitFrame.RaidTargetFrame.RaidTargetIcon:Hide()
	unitFrame.raidTargetIndex = nil
	unitFrame.challengeModeValue:Hide()
	
	unitFrame.unitType = namePlateUnitToken and GetNamePlateTypeFromUnit(unitFrame.unit) or nil	-- self, friendly, enemy
	unitFrame.faction = namePlateUnitToken and UnitFactionGroup(unitFrame.unit) or nil			-- alliance, horde , nil
	unitFrame.reaction = namePlateUnitToken and UnitReaction('player', unitFrame.unit) or nil		-- Exceptionally hostile,Very Hostile,Hostile,Neutral,Friendly,Very Friendly,Exceptionally friendly,Exalted
	unitFrame.classification = namePlateUnitToken and UnitClassification(unitFrame.unit) or nil 	-- "worldboss", "rareelite", "elite", "rare", "normal", "trivial", or "minus"
	unitFrame.creatureType = namePlateUnitToken and UnitCreatureType(unitFrame.unit) or nil		-- Beast Dragonkin Demon Elemental Giant Undead Humanoid Critter Mechanical Not specified Totem Non-combat Pet Gas Cloud
	unitFrame.isPet = namePlateUnitToken and UnitIsUnit(unitFrame.unit, 'pet') or false
	unitFrame.isPlayerTarget = namePlateUnitToken and UnitIsUnit(unitFrame.unit, "target") or false
	unitFrame.isFocus = namePlateUnitToken and UnitIsUnit(unitFrame.unit, "focus") or false
	unitFrame.isPlayer = namePlateUnitToken and UnitIsPlayer(unitFrame.unit) or false
	unitFrame.isPVPSanctuary = namePlateUnitToken and UnitIsPVPSanctuary(unitFrame.unit) or false
	unitFrame.unitName = namePlateUnitToken and UnitName(unitFrame.unit) or UNKNOWN
	--unitFrame.unitNameWithServer = namePlateUnitToken and GetUnitName(unitFrame.unit, false) or UNKNOWN
	unitFrame.isInCombat = namePlateUnitToken and UnitAffectingCombat(unitFrame.unit) or false
	unitFrame.unitGUID = namePlateUnitToken and UnitGUID(unitFrame.unit) or nil
	unitFrame.widgetsOnly = namePlateUnitToken and UnitNameplateShowsWidgetsOnly(unitFrame.unit) or nil
	unitFrame.widgetSet = namePlateUnitToken and UnitWidgetSet(unitFrame.unit) or false 			--266, 267, 469, 449, 260
		
	if (namePlateUnitToken) then
		if not NPC_TABLE[unitFrame.unitGUID] and not unitFrame.isPlayer then
			NPC_TABLE[unitFrame.unitGUID] = {}
		end
		if not unitFrame.isPlayer then
			local _, _, _, _, _, npcID = strsplit("-", unitFrame.unitGUID)
			unitFrame.npcID = tonumber(npcID)
			unitFrame.mapID = L.MythicNPCData[0][unitFrame.npcID] and 0 or L.mapID
		else
			unitFrame.className, unitFrame.englishClass, unitFrame.classID = UnitClass(unitFrame.unit)
		end
		
		self:NamePlate_RegisterEvents(unitFrame)
	else
		unitFrame.npcID = nil
		unitFrame.mapID = nil
		unitFrame.className, unitFrame.englishClass, unitFrame.classID = nil, nil, nil
		self:NamePlate_UnregisterEvents(unitFrame)
	end
	
	if (namePlateUnitToken and unitFrame.unitType ~= "self") then
		MyCastingBarFrame_SetUnit(unitFrame.castBar, nil, false, true)
	else
		MyCastingBarFrame_SetUnit(unitFrame.castBar, nil, nil, nil)
	end
end

--[[ Driver frame ]]--
function namePlateMixin:SetBaseNamePlateSize()
	C_NamePlate_SetNamePlateSelfSize(L.config.healthbar_width["self"], L.config.healthbar_height["self"])
	C_NamePlate_SetNamePlateFriendlySize(L.config.healthbar_width["friendly"], L.config.healthbar_height["friendly"] + L.config.baseNamePlateHeight)
	C_NamePlate_SetNamePlateEnemySize(L.config.healthbar_width["enemy"], L.config.healthbar_height["enemy"] + L.config.baseNamePlateHeight)
	
	C_NamePlate_SetNamePlateSelfPreferredClickInsets(0, 0, 0, 0)
	C_NamePlate_SetNamePlateFriendlyPreferredClickInsets(0, 0, 0, L.config.name_fontsize_players + 4)
	C_NamePlate.SetNamePlateEnemyPreferredClickInsets(0, 0, 0, L.config.name_fontsize_npc + 4)
end

--function namePlateMixin:NamePlateDriverFrame_AcquireUnitFrame(_,namePlate)
 --   if namePlate and namePlate.UnitFrame:IsForbidden() then
 --       return
 --   end
--end

local function ChangeBlizzardOptions()
	if _G.NamePlateDriverFrame then
		_G.DeathKnightResourceOverlayFrame:UnregisterAllEvents()
		_G.ClassNameplateBarDracthyrFrame:UnregisterAllEvents()
		_G.ClassNameplateBarMageFrame:UnregisterAllEvents()
		_G.ClassNameplateBarWindwalkerMonkFrame:UnregisterAllEvents()
		_G.ClassNameplateBrewmasterBarFrame:UnregisterAllEvents()
		_G.ClassNameplateBarPaladinFrame:UnregisterAllEvents()
		_G.ClassNameplateBarRogueFrame:UnregisterAllEvents()
		_G.ClassNameplateBarDruidFrame:UnregisterAllEvents()
		_G.ClassNameplateBarWarlockFrame:UnregisterAllEvents()
				
		_G.ClassNameplateManaBarFrame:UnregisterAllEvents()
		_G.ClassNameplateManaBarFrame:Hide()
		
		_G.NamePlateDriverFrame:UnregisterAllEvents()
		_G.NamePlateDriverFrame:SetClassNameplateManaBar(nil)
		_G.NamePlateDriverFrame:SetClassNameplateBar(nil)
			
		hooksecurefunc(_G.NamePlateDriverFrame, "UpdateNamePlateOptions", namePlateMixin.SetBaseNamePlateSize)
		hooksecurefunc(_G.NamePlateDriverFrame, 'SetupClassNameplateBars',
			function(frame)
				if not frame or frame:IsForbidden() then
					return
				end
				if frame.classNamePlateMechanicFrame then
					frame.classNamePlateMechanicFrame:Hide()
				end
				if frame.classNamePlatePowerBar then
					frame.classNamePlatePowerBar:Hide()
					frame.classNamePlatePowerBar:UnregisterAllEvents()
				end
			end
		)
		hooksecurefunc(_G.UIWidgetTemplateStatusBarMixin, 'Setup',
			function(widgetFrame)
				if not widgetFrame or widgetFrame:IsForbidden() then
					return
				end
				
				if widgetFrame.Bar then
					if L.config.widget_skin then
						if not widgetFrame.Bar.border then
							widgetFrame.Bar.border = namePlateMixin:CreateMyBackdrop(widgetFrame.Bar, 1, 0, 0, 0, 1, "Interface\\Buttons\\WHITE8x8", 0, 0, 0, .4)
						end
						widgetFrame.Bar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.widget_skin_texture))
						widgetFrame.Bar:SetStatusBarColor(unpack(L.config.widget_skin_color))
						widgetFrame.Bar.Spark:SetVertexColor(unpack(L.config.widget_skin_color))
					end
					if widgetFrame.Bar.BGLeft then
						widgetFrame.Bar.BGLeft:SetAlpha(L.config.widget_skin and 0 or 1)
					end
					if widgetFrame.Bar.BGRight then
						widgetFrame.Bar.BGRight:SetAlpha(L.config.widget_skin and 0 or 1)
					end
					if widgetFrame.Bar.BGCenter then
						widgetFrame.Bar.BGCenter:SetAlpha(L.config.widget_skin and 0 or 1)
					end
					if widgetFrame.Bar.BorderLeft then
						widgetFrame.Bar.BorderLeft:SetAlpha(L.config.widget_skin and 0 or 1)
					end
					if widgetFrame.Bar.BorderRight then
						widgetFrame.Bar.BorderRight:SetAlpha(L.config.widget_skin and 0 or 1)
					end
					if widgetFrame.Bar.BorderCenter then
						widgetFrame.Bar.BorderCenter:SetAlpha(L.config.widget_skin and 0 or 1)
					end
				end
			end
		)
			
	--	if _G.NamePlateDriverFrame.AcquireUnitFrame then
	--		hooksecurefunc(_G.NamePlateDriverFrame,'AcquireUnitFrame',namePlateMixin.NamePlateDriverFrame_AcquireUnitFrame)
	--	end
	end

--[[	local checkBox = InterfaceOptionsNamesPanelUnitNameplatesMakeLarger
	function checkBox.setFunc(value)
		if value == "1" then
			SetCVar("NamePlateHorizontalScale", 1)
			SetCVar("NamePlateVerticalScale", 1)
			SetCVar("NamePlateClassificationScale", 1)
		else
			SetCVar("NamePlateHorizontalScale", 1)
			SetCVar("NamePlateVerticalScale", 1)
			SetCVar("NamePlateClassificationScale", 1)
		end
	--	namePlateMixin:SetBaseNamePlateSize()
	end
]]--
end

local function OnUnitFactionChanged(unit)
	local namePlate = C_NamePlate_GetNamePlateForUnit(unit, issecure())
	if namePlate then
		namePlate.UnitFrame.unitType = GetNamePlateTypeFromUnit(unit)
		UpdateName(namePlate.UnitFrame, "Faction")
		UpdateHealthBar(namePlate.UnitFrame, false, "OnUnitFactionChanged "..namePlate.UnitFrame.unitType)
		namePlateMixin:UpdateNamePlateByChallenge(namePlate.UnitFrame)
	end
end

local function OnRaidTargetUpdate()
	for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
		UpdateRaidTargetUnit(namePlate.UnitFrame)
	end
end

--------------------------------------------
-- SpellCD
local function CreateSpellCDIcon(parent, spellID)
	local aura = CreateFrame("Frame", nil, parent, "FrameFlashTemplate")
		aura:SetSize(L.config.spellCD_width, L.config.spellCD_height)
		aura:SetAlpha(L.config.spellCD_alpha_noCD)
		
		aura.border = namePlateMixin:CreateMyBackdrop(aura, 1, 0, 0, 0, 1, nil, 0, 0, 0, 1, 3, 0, 0, 0, 0.6)
		aura.border.shadow:Show()
		
		aura.icon = aura:CreateTexture(nil, "OVERLAY")
		aura.icon:SetAllPoints()
		aura.icon:SetTexCoord(.08, .92, 0.08, 0.92)
		aura.icon:SetTexture(select(3, GetSpellInfo(spellID)))
		aura.icon:SetDesaturated(false)
		
		aura.cd = CreateFrame("Cooldown", "$parentCooldown", aura, "CooldownFrameTemplate")
		aura.cd:SetAllPoints()
		aura.cd:Hide()
				
		aura.timer = namePlateMixin:CreateMyText(aura, L.config.spellCD_font, L.config.spellCD_fontsize, L.config.spellCD_font_flag, "OVERLAY", "CENTER", "LEFT", false)
		aura.timer:SetPoint("CENTER", aura, "CENTER", 0, 0)
		aura.timer:SetTextColor(unpack(L.config.spellCD_font_color))
		aura.timer:Hide()
		
	return aura
end

function namePlateMixin:UpdateAllSpellCD(unitFrame, update)
	local lastFrame
		-- ak neake existuje Hide all
	if next(unitFrame.spellCD) then
		for spellID in pairs(unitFrame.spellCD) do
			unitFrame.spellCD[spellID]:Hide()
		end
	end
	
	for spellID in pairs(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID]) do
		if tonumber(spellID) and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag and FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].flag, L.instanceFLAG) then
			unitFrame.spellCD[spellID] = unitFrame.spellCD[spellID] or CreateSpellCDIcon(unitFrame.healthBar, spellID)
					
			-- 136243 je icona asi pre vsetky support spelly
			if not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].never and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].trackedtime ~= nil 
				and ((L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].tracked and L.config.spellCD_trackedOnly)
				or (L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].trackedtime >= L.config.spellCD_minTime and not L.config.spellCD_trackedOnly)) then				
				
				if update then
					unitFrame.spellCD[spellID].timer:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.spellCD_font), L.config.spellCD_fontsize, L.config.spellCD_font_flag)
					unitFrame.spellCD[spellID].timer:SetTextColor(unpack(L.config.spellCD_font_color))
					unitFrame.spellCD[spellID]:SetSize(L.config.spellCD_width, L.config.spellCD_height)
				end
				
				-- avoide, resetni vsetko co sa zobrazilo
				if not unitFrame.isInCombat then 
					unitFrame.spellCD[spellID]:SetScript("OnUpdate", nil)
					if unitFrame.spellCD[spellID].AnimFlash:IsPlaying() then
						unitFrame.spellCD[spellID].AnimFlash:Stop()
					end
					unitFrame.spellCD[spellID].cd:SetCooldown(0,0)
					unitFrame.spellCD[spellID]:SetAlpha(L.config.spellCD_alpha_noCD)
					unitFrame.spellCD[spellID].icon:SetDesaturated(false)
					if L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].onCombatTime then
						unitFrame.spellCD[spellID].timer:SetText(namePlateMixin:FormatTime(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID].onCombatTime))
						unitFrame.spellCD[spellID].timer:Show()
					else
						unitFrame.spellCD[spellID].timer:Hide()
					end
				end
				
				unitFrame.spellCD[spellID]:ClearAllPoints()
				if not lastFrame then
					PixelUtil.SetPoint(unitFrame.spellCD[spellID], L.config.spellCD_align_tab[L.config.spellCD_align][1], unitFrame.healthBar, L.config.spellCD_align_tab[L.config.spellCD_align][2], 0, L.config.spellCD_Y)
				else
					PixelUtil.SetPoint(unitFrame.spellCD[spellID], L.config.spellCD_align_tab[L.config.spellCD_align][3], lastFrame, L.config.spellCD_align_tab[L.config.spellCD_align][4], L.config.spellCD_align_tab[L.config.spellCD_align][5], 0)
				end
				lastFrame = unitFrame.spellCD[spellID]
				
				unitFrame.spellCD[spellID]:Show()
			else
				unitFrame.spellCD[spellID]:SetScript("OnUpdate", nil)
				unitFrame.spellCD[spellID]:Hide()
			end
		end
	end

end

function namePlateMixin:UpdateSpellCD(unitFrame, spellID, calledFromCombatEvent)
	local DBSpell = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID][spellID]
	if not unitFrame.spellCD[spellID] or not DBSpell then return end
	
	-- haladaj presnejsie preCombat CD
	if not DBSpell.onCombatTimelock then
		if calledFromCombatEvent and not unitFrame.isInCombat and not unitFrame.spellCD[spellID].onCombatStartTime then
			unitFrame.spellCD[spellID].onCombatStartTime = GetTime()
		elseif unitFrame.spellCD[spellID].onCombatStartTime and unitFrame.spellCD[spellID].onCombatStartTime > 1 then
			local prediction = GetTime() - unitFrame.spellCD[spellID].onCombatStartTime
			unitFrame.spellCD[spellID].onCombatStartTime = 1
			if DBSpell.onCombatTime == nil then
				DBSpell.onCombatTime = round(prediction, 1)
			else
				local rozdiel = math.abs(DBSpell.onCombatTime - prediction)
				if rozdiel > 0.1 then
					if DBSpell.onCombatTime > prediction then
						DBSpell.onCombatTime = round(DBSpell.onCombatTime - 0.1, 1)
					elseif DBSpell.onCombatTime < prediction then
						DBSpell.onCombatTime = round(DBSpell.onCombatTime + 0.1, 1)
					end
				end
			end
		end
	end
	
	-- hladaj spravne spellCD
	if not DBSpell.timelock and not calledFromCombatEvent then
		if not unitFrame.spellCD[spellID].previousTime then
			unitFrame.spellCD[spellID].previousTime = GetTime()
		else
			local prediction = GetTime() - unitFrame.spellCD[spellID].previousTime
			unitFrame.spellCD[spellID].previousTime = GetTime()
						
			if prediction > 2 then
				if DBSpell.trackedtime == nil then
					DBSpell.trackedtime = round(prediction, 1)
				else
					local rozdiel = math.abs(DBSpell.trackedtime - prediction)
					if rozdiel > 0.1 then
						local correction
						DBSpell.castNumber = (DBSpell.castNumber or 0) + 1
						if DBSpell.castNumber > 7 then
							correction = 0.1
						else
							correction = 1 / DBSpell.castNumber
						end
												
						if DBSpell.trackedtime > prediction then
							DBSpell.trackedtime = round(DBSpell.trackedtime - correction, 1)
						elseif DBSpell.trackedtime < prediction then
							DBSpell.trackedtime = round(DBSpell.trackedtime + correction, 1)
						end
					end
				end
				
				if not unitFrame.spellCD[spellID]:IsShown() and DBSpell.trackedtime >= L.config.spellCD_minTime then
					self:UpdateAllSpellCD(unitFrame, false)
				end
			end
		end
	end
					
	if L.config.spellCD and unitFrame.spellCD[spellID]:IsShown() 
		and (not calledFromCombatEvent or (calledFromCombatEvent and DBSpell.onCombatTime and not DBSpell.onCombatDisable)) then 
				
		unitFrame.spellCD[spellID].expirationTime = GetTime() + (calledFromCombatEvent and DBSpell.onCombatTime or DBSpell.trackedtime)
		unitFrame.spellCD[spellID].duration = calledFromCombatEvent and DBSpell.onCombatTime or DBSpell.trackedtime
		unitFrame.spellCD[spellID].CDsound = DBSpell.CDsound
		unitFrame.spellCD[spellID].soundPlayed = {false, false, false, false, false}
		
		unitFrame.spellCD[spellID]:SetScript("OnUpdate", function(self, elapsed)
			self.elapsed = (self.elapsed or 0) + elapsed
			if self.elapsed < .2 then return end
			self.elapsed = 0
			local timeLeft = self.expirationTime - GetTime()
			if timeLeft >= 0 and self.duration and self.duration > 0 then
				local timeInSecString = string_format("%d", timeLeft)
				local timeInSecNumber = tonumber(timeInSecString)
				if L.config.spellCD_iconSize then
					self:SetSize(L.config.spellCD_width / 1.2, L.config.spellCD_height / 1.2)								
				end
				if self.CDsound and timeInSecNumber <= L.config.spellCD_sound_time and not self.soundPlayed[timeInSecNumber] then
					self.soundPlayed[timeInSecNumber] = true
					PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, timeInSecString), L.config.sound_channel)
				end
				if L.config.spellCD_flash_time > 0 and L.config.spellCD_flash_time >= timeInSecNumber then
					self.icon:SetDesaturated(false)
					if not self.AnimFlash:IsPlaying() then
						self.AnimFlash:Play()
					end
				else
					if self.AnimFlash:IsPlaying() then
						self.AnimFlash:Stop()
					end
					self:SetAlpha(L.config.spellCD_alpha_onCD)
				end
				if L.config.spellCD_desaturated and timeInSecNumber > L.config.spellCD_flash_time then
					self.icon:SetDesaturated(true)
				else
					self.icon:SetDesaturated(false)
				end
				if L.config.spellCD_timer then
					self.timer:SetText(namePlateMixin:FormatTime(timeLeft))
					self.timer:Show()
				else
					self.timer:SetText(nil)
					self.timer:Hide()
				end
				if L.config.spellCD_CD then
					self.cd:SetCooldown(self.expirationTime - self.duration, self.duration)
					self.cd:Show()
				else
					self.cd:Hide()
				end
			else
				self:SetSize(L.config.spellCD_width, L.config.spellCD_height)
				
				if self.AnimFlash:IsPlaying() then
					self.AnimFlash:Stop()
				end
				self.icon:SetDesaturated(false)
				self:SetAlpha(L.config.spellCD_alpha_noCD)
				self:SetScript("OnUpdate", nil)
				self.timer:Hide()
				self.cd:Hide()
			end
		end)
	end
end

-- update nameplate ak som v challenge mape
function namePlateMixin:UpdateNamePlateByChallenge(unitFrame)
	if unitFrame.mapID == nil 
		or unitFrame.unitType ~= "enemy" 
		or unitFrame.isPlayer 
		or unitFrame.isPet 
		or not unitFrame.npcID 
		or unitFrame.creatureType == 'Critter' 
		or (unitFrame.mapID and L.MythicNPCData[unitFrame.mapID].stopRecord) then
		
		unitFrame:SetScale(1)
		unitFrame.challengeModeValue:Hide()
		
		if unitFrame.isQuest and L.config.quest_text then
			unitFrame.helpText:Show()
		else
			unitFrame.helpText:Hide()
		end
				
		if next(unitFrame.spellCD) then
			for spellID in pairs(unitFrame.spellCD) do
				unitFrame.spellCD[spellID]:Hide()
				unitFrame.spellCD[spellID]:SetScript("OnUpdate", nil)
				unitFrame.spellCD[spellID] = nil
			end
		end
		return
	end
	
	-- save nove NPC ak nie je v databaze
	if not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] then
		-- ak existuje na inej mape presun ho na 0 a zmaz ho v tej mape
		for savedMap in pairs(L.MythicNPCData) do
			if tonumber(savedMap) and L.MythicNPCData[savedMap][unitFrame.npcID] then
				L.MythicNPCData[0][unitFrame.npcID] = L.MythicNPCData[savedMap][unitFrame.npcID]
				L.MythicNPCData[savedMap][unitFrame.npcID] = nil
				unitFrame.mapID = 0
			end
		end
		
		if not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] then
			L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] = {}
			L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].destName = unitFrame.unitName
		end
						
		if L.config.mythic_NPC_infoPanel and unitFrame.isPlayerTarget then
			npcInfoPanelMixin:ShowNPCInfoPanel(unitFrame.npcID, unitFrame.mapID)
		end
		
		if L.config.mythic_NPC_newspam then
			local instanceName
			if unitFrame.mapID == 0 then
				instanceName = "For all zones"
			else
				instanceName = C_ChallengeMode.GetMapUIInfo(unitFrame.mapID)
				if not instanceName then
					instanceName = GetRealZoneText(unitFrame.mapID)
				end
			end
			
			self:DebugLog("Added new NPC : "..L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].destName.." to map|cff2020ff"..instanceName.."|r")
		end
	end
	
	-- potom presunut o chlp visiie
	if not L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].flag then
		L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].flag = L.instanceFLAG
	elseif not FlagsUtil.IsSet(L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].flag, L.instanceFLAG) then
		L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].flag = L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].flag + L.instanceFLAG
	end
		
	-- ak je spellCD zapnute
	if L.config.spellCD then --and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID] then
		self:UpdateAllSpellCD(unitFrame, true)
	elseif next(unitFrame.spellCD) then
		for spellID in pairs(unitFrame.spellCD) do
			unitFrame.spellCD[spellID]:Hide()
			unitFrame.spellCD[spellID]:SetScript("OnUpdate", nil)
			unitFrame.spellCD[spellID] = nil
		end
	end
	
	if L.config.mythic_plus_enable then
		
		unitFrame:SetScale(L.config.mythic_scale and (L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].scale or 1) or 1)
					
		if L.config.mythic_percent_show and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].value and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].value > 0 and tQuantity then
			unitFrame.challengeModeValue:SetFormattedText('%1.2f', (L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].value / tQuantity) * 100)
			unitFrame.challengeModeValue:Show()
		else
			unitFrame.challengeModeValue:Hide()
		end
	
		if L.config.mythic_desc and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].desc then
			unitFrame.helpText:SetText(ConvertNumToIconsString(unitFrame, L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].desc))
			unitFrame.helpText:Show()
		elseif unitFrame.isQuest and L.config.quest_text then
			unitFrame.helpText:Show()
		else
			unitFrame.helpText:Hide()
		end
	
		if L.config.mythic_sound and L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].sound and NPC_TABLE[unitFrame.unitGUID] and not NPC_TABLE[unitFrame.unitGUID].playedsound then
			PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.MythicNPCData[unitFrame.mapID][unitFrame.npcID].sound), L.config.sound_channel)
			NPC_TABLE[unitFrame.unitGUID].playedsound = true
		end
		
	else
		unitFrame:SetScale(1)
		unitFrame.challengeModeValue:Hide()
		if unitFrame.isQuest and L.config.quest_text then
			unitFrame.helpText:Show()
		else
			unitFrame.helpText:Hide()
		end
	end
end

function namePlateMixin:OnCheckChallengeMode(event)
	--local test = C_MythicPlus.IsMythicPlusActive() -- len test ci uz mozes chodit M+
	L.mapID = nil
	L.isSavedMap = false
	L.isChallengeMapActive = false
	L.instanceFLAG = 0x010		-- noinstance
	
	if L.config.mythic_NPC_infoPanel then
		npcInfoPanelMixin:HideNPCInfoPanel()
	end
		
	if IsInInstance() and L.config.mythic_plus_enable then
		--name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, instanceID, instanceGroupSize, LfgDungeonID = GetInstanceInfo()
		--local name, groupType, isHeroic, isChallengeMode, displayHeroic, displayMythic, toggleDifficultyID = GetDifficultyInfo(difficultyID)
		
		-- som v aktivnej M+ mape ?
		L.mapID = C_ChallengeMode.GetActiveChallengeMapID()
				
		local instanceName, _, difficultyID, _, _, _, _, instanceID = GetInstanceInfo()
		if not L.mapID then	
			local maps = C_ChallengeMode.GetMapTable()
			for i = 1, #maps do
				local name, id, timeLimit = C_ChallengeMode.GetMapUIInfo(maps[i])
				if name == instanceName then
					-- ak sa zhoduje instance name ale nezhoduje instance ID
					if instanceID ~= id and L.MythicNPCData[instanceID] then
						L.MythicNPCData[id] = L.MythicNPCData[instanceID]
						L.MythicNPCData[instanceID] = nil
					end
					L.mapID = id
					break
				end
			end
		end
		
		-- je to aspon ulozena mapa
		if not L.mapID and L.MythicNPCData[instanceID] then
			L.mapID = instanceID
		end
			
		if L.mapID then
			L.isSavedMap = true
			L.isChallengeMapActive = C_ChallengeMode.IsChallengeModeActive()
			
			if difficultyID == 1 then
				L.instanceFLAG = 0x00000001;		-- normal
			elseif difficultyID == 2 then
				L.instanceFLAG = 0x00000002;		-- Heroic
			elseif difficultyID == 23 then
				L.instanceFLAG = 0x00000004;		-- M0
			elseif difficultyID == 8 then
				L.instanceFLAG = 0x00000008;		-- M+
			end
			
			-- ak neexistuje
			L.MythicNPCData[L.mapID] = MythicNPCData[L.mapID] or {}
			MythicNPCData[L.mapID] = L.MythicNPCData[L.mapID]
			
			if not L.MythicNPCData[L.mapID].instanceColor then
				L.MythicNPCData[L.mapID].instanceColor = {1,1,1}
			end
			
			local _, _, _, _, totalQuantity, _, _, _, _, _, _, _, isWeightedProgress = C_Scenario_GetCriteriaInfo(select(3, C_Scenario_GetStepInfo()))
			if isWeightedProgress then
				tQuantity = totalQuantity
			end
		end
	end
end

function namePlateMixin:UpdateNamePlateByOptions(update)
	
	if self:MultiCheck(update, "healer_detection", "hp_enable", "mythic", "show_range", "castbar", "bars", "widget", "nameplate", "update_all") then
		for _ , namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
			if namePlate.UnitFrame.unitType ~= "self" then
				namePlate.UnitFrame.mapID = L.MythicNPCData[0][namePlate.UnitFrame.npcID] and 0 or L.mapID
				
				if update == "healer_detection" or update == "update_all" then
					if not L.config.healer_detection then
						namePlate.UnitFrame.healerIcon:Hide()
					end
				end

				if update == "hp_enable" or update == "update_all" then
					if L.config.hp_enable or (L.config.hp_target_enable and namePlate.UnitFrame.isPlayerTarget) then
						namePlate.UnitFrame.healthText:ClearAllPoints()
						namePlate.UnitFrame.healthText:SetPoint(L.config.hp_point, namePlate.UnitFrame.healthBar, L.config.hp_relativePoint, L.config.hp_posun_X, L.config.hp_posun_Y)
						namePlate.UnitFrame.healthText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.hp_font), L.config.hp_fontsize, L.config.hp_font_flag)
						namePlate.UnitFrame.healthText:Show()
					else
						namePlate.UnitFrame.healthText:Hide()
					end
				end
				
				if update == "show_range" or update == "update_all" then
					if L.config.show_range then
						namePlate.UnitFrame.rangeText:SetTextColor(unpack(L.config.range_font_color))
						namePlate.UnitFrame.rangeText:ClearAllPoints()
						namePlate.UnitFrame.rangeText:SetPoint(L.config.range_point, namePlate.UnitFrame.healthBar, L.config.range_relativePoint, L.config.range_posun_X, L.config.range_posun_Y)
						namePlate.UnitFrame.rangeText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.range_font), L.config.range_fontsize, L.config.range_font_flag)
						namePlate.UnitFrame.rangeText:Show()
					else
						namePlate.UnitFrame.rangeText:Hide()
					end
				end
				
				if update == "mythic" or update == "update_all" then
					namePlate.UnitFrame.helpText:ClearAllPoints()
					namePlate.UnitFrame.helpText:SetPoint(L.config.mythic_help_point, namePlate.UnitFrame.healthBar:IsShown() and namePlate.UnitFrame.healthBar or namePlate.UnitFrame.nameText, L.config.mythic_help_relativePoint, L.config.mythic_help_posun_X, L.config.mythic_help_posun_Y)
					namePlate.UnitFrame.helpText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.mythic_help_font), L.config.mythic_help_fontsize, L.config.mythic_help_font_flag)
					namePlate.UnitFrame.helpText:SetTextColor(unpack(L.config.mythic_help_color))
					namePlate.UnitFrame.challengeModeValue:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.mythic_percent_font), L.config.mythic_percent_fontsize, L.config.mythic_percent_font_flag)
					namePlate.UnitFrame.challengeModeValue:SetTextColor(unpack(L.config.mythic_percent_color))
					namePlate.UnitFrame.descText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.desc_text_font), L.config.desc_text_fontsize, L.config.desc_text_font_flag)
				end
								
				if update == "castbar" or update == "update_all" then
					UpdateCastBar(namePlate.UnitFrame)
				end
								
				if update == "bars" or update == "update_all" then
					self:UpdateEnemyFriendlyNamePlate(namePlate.UnitFrame)
				end
				
				if update == "widget" or update == "update_all" then
					if namePlate.UnitFrame.WidgetContainer and namePlate.UnitFrame.widgetSet then
						namePlate.UnitFrame.WidgetContainer:UpdateWidgetLayout()
					end
				end
				
				self:UpdateAllOnNameplate(namePlate.UnitFrame, update)
				UpdateHealthBar(namePlate.UnitFrame, false, "UpdateNamePlateByOptions "..update)
			end
		end		
	end

	if update == "update_all" then
		self:OnCheckChallengeMode()
		self:UpdateMyTarget()
		self:SetBaseNamePlateSize()
		self:UpdateSelfNamePlate()
		classBarMixin:UpdateClassBar()
		ButtonHP:SetButtonState(L.config.hp_enable and "PUSHED" or "NORMAL", L.config.hp_enable and true or false)
		ButtonValue:SetButtonState(L.config.mythic_percent_show and "PUSHED" or "NORMAL", L.config.mythic_percent_show and true or false)
		ButtonRange:SetButtonState(L.config.show_range and "PUSHED" or "NORMAL", L.config.show_range and true or false)
		ButtonAutoMark:SetButtonState(L.config.auto_mark and "PUSHED" or "NORMAL", L.config.auto_mark and true or false)
		npcInfoPanelMixin:HideNPCInfoPanel()
		
		
		--  vypnutie frizzle sound GCD
		if L.config.fizzle_sound then
			MuteSoundFile(569772)
			MuteSoundFile(569773)
			MuteSoundFile(569774)
			MuteSoundFile(569775)
			MuteSoundFile(569776)
		else
			UnmuteSoundFile(569772)
			UnmuteSoundFile(569773)
			UnmuteSoundFile(569774)
			UnmuteSoundFile(569775)
			UnmuteSoundFile(569776)
		end
		
		--if not InCombatLockdown() then self:SetBaseNamePlateSize() end
	end
		
	
	if (update == "cvars" or update == "update_all") and not InCombatLockdown() then
		SetCVar("nameplateShowSelf", 1)
		SetCVar("nameplateGlobalScale", L.config.nameplateGlobalScale)
		SetCVar("nameplateOccludedAlphaMult", L.config.nameplateOccludedAlphaMult)	
		SetCVar("nameplateSelectedScale", L.config.nameplateSelectedScale)
		SetCVar("nameplatePersonalShowAlways", L.config.nameplatepersonalShowAlways and 1 or 0)
		SetCVar("nameplatePersonalShowInCombat", L.config.nameplatePersonalShowInCombat and 1 or 0)
		SetCVar("nameplatePersonalShowWithTarget", L.config.nameplatePersonalShowWithTarget and 1 or 0)
		SetCVar("nameplateSelfScale", L.config.nameplateSelfScale)
		SetCVar("nameplateSelfAlpha", L.config.nameplateSelfAlpha)
		SetCVar("nameplateSelfTopInset", L.config.nameplateSelfTopInset)
		SetCVar("nameplateSelfBottomInset", L.config.nameplateSelfBottomInset)
		SetCVar("nameplateLargerScale", L.config.nameplateLargerScale)
		SetCVar("nameplateLargeTopInset", L.config.nameplateLargeTopInset)
		SetCVar("nameplateLargeBottomInset", L.config.nameplateLargeBottomInset)
		SetCVar("nameplatePersonalHideDelayAlpha", L.config.nameplatePersonalHideDelayAlpha)
		SetCVar("nameplatePersonalHideDelaySeconds", L.config.nameplatePersonalHideDelaySeconds)
		SetCVar("nameplateOtherTopInset", L.config.nameplateOtherTopInset)
		SetCVar("nameplateOtherBottomInset", L.config.nameplateOtherBottomInset)
		SetCVar("nameplateMaxDistance", L.config.nameplateMaxDistance)
		SetCVar("nameplateMinAlpha", L.config.nameplateMinAlpha)
		SetCVar("nameplateMaxAlpha", L.config.nameplateMaxAlpha)
		SetCVar('nameplateMaxAlphaDistance', L.config.nameplateMaxAlphaDistance)
		SetCVar('nameplateMinAlphaDistance', L.config.nameplateMinAlphaDistance)
		SetCVar("nameplateMotion", L.config.nameplateMotion)
		SetCVar("nameplateOverlapV", L.config.nameplateOverlapV)
		SetCVar("nameplateOverlapH", L.config.nameplateOverlapH)
		SetCVar("nameplateMotionSpeed", L.config.nameplateMotionSpeed)
		SetCVar("nameplateTargetBehindMaxDistance", L.config.nameplateTargetBehindMaxDistance)
		SetCVar("nameplateTargetRadialPosition", L.config.nameplateTargetRadialPosition)
		SetCVar("nameplateOtherAtBase", L.config.nameplateOtherAtBase)	
		SetCVar("namePlateMinScale", L.config.nameplateMinScale)
		SetCVar("namePlateMaxScale", L.config.nameplateMaxScale)
		SetCVar("nameplateMaxScaleDistance", L.config.nameplateMaxScaleDistance)
		SetCVar("nameplateMinScaleDistance", L.config.nameplateMinScaleDistance)
		SetCVar("nameplateShowFriendlyNPCs", L.config.nameplateShowFriendlyNPCs)
		SetCVar("nameplateShowEnemyGuardians", L.config.nameplateShowEnemyGuardians)
		SetCVar("nameplateShowEnemyMinions", L.config.nameplateShowEnemyMinions)
		SetCVar("nameplateShowEnemyMinus", L.config.nameplateShowEnemyMinus)
		SetCVar("nameplateShowEnemyPets", L.config.nameplateShowEnemyPets)
		SetCVar("nameplateShowEnemyTotems", L.config.nameplateShowEnemyTotems)
		SetCVar("nameplateShowFriendlyGuardians", L.config.nameplateShowFriendlyGuardians)
		SetCVar("nameplateShowFriendlyMinions", L.config.nameplateShowFriendlyMinions)
		SetCVar("nameplateShowFriendlyPets", L.config.nameplateShowFriendlyPets)
		SetCVar("nameplateShowFriendlyTotems", L.config.nameplateShowFriendlyTotems)
		SetCVar("nameplateShowOnlyNames", 0)
		SetCVar("ShowClassColorInFriendlyNameplate", 1)
		SetCVar('showQuestTrackingTooltips', 1)
		SetCVar("ShowNamePlateLoseAggroFlash", 0)
		
		C_NamePlate_SetNamePlateSelfClickThrough(L.config.selfClickThrough)		
		C_NamePlate_SetNamePlateFriendlyClickThrough(L.config.friendlyClickThrough)
		C_NamePlate_SetNamePlateEnemyClickThrough(L.config.enemyClickThrough)
	end
end

------------------------------------------
-- GCD	
local function ResetSpellActivityFrame(framePool, frame)
	if frame.AnimOut:IsPlaying() then
		frame.AnimOut:Stop()
		frame:SetAlpha(0)
	end
	if frame.AnimIn:IsPlaying() then
		frame.AnimIn:Stop()
	end
	if frame.AnimRight:IsPlaying() then
		frame.AnimRight:Stop()
	end
	frame:SetAlpha(0)
	frame:Hide()
	local namePlate = C_NamePlate_GetNamePlateForUnit("player", issecure())
	frame:SetParent(namePlate.UnitFrame)
	frame:ClearAllPoints()
	frame:SetPoint("BOTTOMLEFT", namePlate.UnitFrame, "TOPLEFT", 0, 2)
	frame.AnimIn.Alpha:SetDuration(L.config.gcd_anim_speed)
	frame.AnimIn.Scale:SetDuration(L.config.gcd_anim_speed)
	frame.AnimRight.Translation:SetDuration(L.config.gcd_anim_speed)
	frame.createdAt = nil
	frame.guid = nil
	frame.expired = false
end

local function AddSpellActivityFrame(unitFrame, icon, fast)
	local lastFrame = unitFrame.spellActivityFrames.last
	if lastFrame ~= nil and lastFrame.AnimIn:IsPlaying() then
		C_Timer_After(lastFrame.AnimIn:GetDuration(), function()
			if lastFrame ~= nil and lastFrame.guid == unitFrame.guid then
				AddSpellActivityFrame(unitFrame, icon, true)
			end
		end)
		return
	end

	local newFrame = unitFrame.spellActivityFrames:Acquire()
	newFrame:SetSize(L.config.gcd_anim_icon_size, L.config.gcd_anim_icon_size)
	newFrame:SetMouseClickEnabled(false)
	newFrame.Icon:SetTexture(icon)
	newFrame.createdAt = GetTime()
	newFrame.guid = unitFrame.guid
		
	-- AnimeIn
	if fast then
		newFrame.AnimIn.Alpha:SetDuration(L.config.gcd_anim_speed / 2)
		newFrame.AnimIn.Scale:SetDuration(L.config.gcd_anim_speed / 2)
	end
	
	local tmp = 0
	if L.config.player_resource_type > 0 and L.config.player_resource_pine == "player" then
		tmp = (L.config.player_resource_position_height[L.config.player_resource_pine] + L.config.player_resource_position_y[L.config.player_resource_pine]) / 1.4
	end
	
	newFrame:SetPoint("BOTTOMLEFT", unitFrame, "TOPLEFT", 0, 2 + tmp)	
	--newFrame.AnimIn.Scale:SetFromScale(L.config.gcd_anim_icon_scale, L.config.gcd_anim_icon_scale)
	newFrame.AnimIn:Play()
	newFrame.AnimIn:SetScript("OnFinished", function(self)
		self:GetParent():SetAlpha(1)
		--self:GetParent():ClearAllPoints()
	end)
	if newFrame.AnimIn:IsPlaying() then
		newFrame.AnimIn:GetParent():Show()
	end
			
	-- AnimeRight
	if lastFrame ~= nil and lastFrame ~= newFrame and not lastFrame.AnimOut:IsPlaying() then
		if fast then
			lastFrame.AnimRight.Translation:SetDuration(L.config.gcd_anim_speed / 2)
		end
		lastFrame.AnimRight.Translation:SetOffset(L.config.gcd_anim_icon_size + 1, 0)
		lastFrame.AnimRight:Play()
		lastFrame.AnimRight:SetScript("OnFinished", function(self)
			self:GetParent():ClearAllPoints()
			self:GetParent():SetPoint("RIGHT", newFrame, "RIGHT", L.config.gcd_anim_icon_size + 1, 0)
			self:GetParent():SetParent(newFrame)
		end)
	end

	unitFrame.spellActivityFrames.last = newFrame
end

local function OnUpdateMouseoverUnit()
	if L.mapID == 210 and L.config.mythic_plus_enable and L.config.mythic_cos_help then
		
		QuestPlateTooltip:SetOwner(_G.UIParent, 'ANCHOR_NONE')
		QuestPlateTooltip:SetUnit("mouseover")
		local _,unit = QuestPlateTooltip:GetUnit()
		
		if unit then
				
			local _, _, _, _, _, npcID = strsplit("-", UnitGUID(unit))
			local line
		
			if npcID == "105117" then line = "Alchemist, Rogue [kills Gerdo]" --Flask of the Solemn Night
			elseif npcID == "105157" then line = "Engineer, Goblin, Gnome [5 sec stun Constructs]" --Arcane Power Conduit
			elseif npcID == "106110" then line = "Shaman, Skinner, Scribe [35% move speed]" --Waterlogged Scroll
			elseif npcID == "105160" then line = "Demon Hunter, Warlock, Priest, Paladin [10% crit chance]" --Fel Orb
			elseif npcID == "105340" then line = "Druid, Herbalist [10% haste]" --Umbral Bloom
			elseif npcID == "106018" then line = "Rogue, Warrior, Leatherworker [pulls Emissary]" --Bazaar Goods
			elseif npcID == "106112" then line = "Healers, Tailors [pulls Emissary]" --Wounded Nightborne Civilian
			elseif npcID == "106113" then line = "Jewelcrafter, Miner [pulls Emissary]" --Lifesized Nightborne Statue
			elseif npcID == "105831" then line = "Paladin, Priest, Demon Hunter [10% damage reduction]" --Infernal Tome
			elseif npcID == "105249" then line = "Cooking, Pandaren, Herbalist [10% health bonus]" --Nightshade Refreshments
			elseif npcID == "105215" then line = "Hunter, Blacksmith [25% dmg for 30 sec]" --Discarded Junk
			elseif npcID == "106024" then line = "Mage, Blood Elf, Night Elf, Enchanter [10% damage bonus]" --Magical Lantern
			elseif npcID == "106108" then line = "Death Knight, Monk [regen bonus]" -- Starlight Rose Brew
			end
						
			if line then
				local raidIndex = GetRaidTargetIndex(unit)
				if raidIndex == nil then
					for i = 1, 8 do
						if not USED_RAID_MARKS[i] then
							SetRaidTarget(unit, i)
							USED_RAID_MARKS[i] = true
							SendChatMessage("{rt"..i.."} "..GetUnitName(unit)..": "..line, IsInGroup() and namePlateMixin:InstanceOrParty() or "SAY")
							break
						end
					end
				elseif IsShiftKeyDown() then
					SendChatMessage("{rt"..raidIndex.."} "..GetUnitName(unit)..": "..line, IsInGroup() and namePlateMixin:InstanceOrParty() or "SAY")
				end
			end
		end
	end
	
	if L.config.mouseover_enable then 
		if UnitIsUnit("mouseover", "player") then return end
		for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
			local tmp = namePlate.UnitFrame.isMouseover
			if namePlate.UnitFrame.unitType ~= "self" then
				namePlate.UnitFrame.isMouseover = UnitIsUnit("mouseover", namePlate.UnitFrame.unit)
				if namePlate.UnitFrame.isMouseover then
					hasMouseover = true
				end
				if tmp ~= namePlate.UnitFrame.isMouseover then
					UpdateHealthBar(namePlate.UnitFrame, false, "OnUpdateMouseoverUnit")
				end
			end
		end
	end
end

local function OnCombatLogCheck()
	local _, combatEvent, _, sourceGUID, sourceName, sourceFlag, _, destGUID, destName, destFlag, _, spellID, spellName, spellSchool, spellID2, spellName2, arg17, arg18 = CombatLogGetCurrentEventInfo()
	
	-- reflect spell pre warriora
	if combatEvent == "SPELL_DAMAGE" then
		if hasReflect and sourceGUID == destGUID then
			if L.selfClass == 'WARRIOR' and L.config.classSpell_SR_spam_amount then
				if IsInGroup() then
					SendChatMessage("Reflected "..spellID2 , namePlateMixin:InstanceOrParty())					
				else
					--namePlateMixin:DebugLog("Reflected "..spellID2, 3, true, false, false)
					print("Reflected "..spellID2)
				end
			end
			
			hasReflect = false
		end	
		
	elseif combatEvent == "SPELL_MISSED" then 
		if spellID2 == "REFLECT" and destGUID == UnitGUID("player") then
			hasReflect = true
			
			local unitToken = UnitTokenFromGUID(sourceGUID)
			if unitToken then
				local namePlate = C_NamePlate_GetNamePlateForUnit(unitToken, issecure())
				if namePlate
					and namePlate.UnitFrame.mapID 
					and namePlate.UnitFrame.npcID 
					and L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID]
					and L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID][spellID]
					and not FlagsUtil.IsSet(L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID][spellID].flag, 0x400)	then
						if L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID][spellID].flag then
							L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID][spellID].flag = 0x400
						else
							L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID][spellID].flag = L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID][spellID][spellID].flag + 0x400
						end
						namePlateMixin:DebugLog(GetSpellLink(spellID).."|cff00bbff is reflectable and reflect flag is added to M+ Database|r ")
				end
			end
		end
				
	-- zobraz na prebiehajucom castbare kto ho kickol
	elseif combatEvent == "SPELL_INTERRUPT" then
		if namePlateMixin.PARTY_TABLE[sourceGUID] then
			namePlateMixin.PARTY_TABLE[sourceGUID].kickCountSucced = (namePlateMixin.PARTY_TABLE[sourceGUID].kickCountSucced or 0) + 1
		end
		if L.config.cb_show_kickerName and sourceName then
			for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
				if namePlate.UnitFrame.unit and namePlate.UnitFrame.castBar:IsShown() and (destGUID == namePlate.UnitFrame.unitGUID) then
					local shortName = gsub(sourceName, "%-[^|]+", "")
					namePlate.UnitFrame.castBar.Text:SetText(nil)
					namePlate.UnitFrame.castBar.kickerNameText:SetText(namePlateMixin:GetTextColorByGUID(sourceGUID, shortName))
					namePlate.UnitFrame.castBar.kickerNameBGTexture:SetSize(namePlate.UnitFrame.castBar.kickerNameText:GetStringWidth() + 6, L.config.cb_kicker_fontsize + 2)
					namePlate.UnitFrame.castBar.kickerNameBGTexture:Show()
					if L.config.cb_kicker_spam then
						namePlateMixin:DebugLog(namePlateMixin:GetTextColorByGUID(sourceGUID, shortName).." |cff00bbffinterrupt|r "..GetSpellLink(spellID2))
					end
				end
			end
		end
		
	-- kto dispelnul nieco
	elseif (combatEvent == "SPELL_DISPEL" or combatEvent == "SPELL_STOLEN") then
		if L.config.aura_dispel_spam then
			local shortName = string_gsub(sourceName, "%-[^|]+", "")
			namePlateMixin:DebugLog(namePlateMixin:GetTextColorByGUID(sourceGUID, shortName).." |cff00bbffdispeled|r "..GetSpellLink(spellID2))
		end
		
	elseif combatEvent == "SPELL_CAST_SUCCESS" then
		local _, _, _, _, _, npcid = strsplit("-", sourceGUID)
		local npcID = tonumber(npcid)
		if L.MythicNPCData[L.mapID or 0][npcID] and L.MythicNPCData[L.mapID or 0][npcID][spellID] then
			L.MythicNPCData[L.mapID or 0][npcID][spellID].school = spellSchool
		end
		
		-- pre GCD frame
		if L.config.gcd_showSpellActivity then
			if sourceGUID == UnitGUID("player") then
				if L.config.gcd_showSpellActivity_spam then
					local spellName, _, spellTexture = GetSpellInfo(spellID)
					if spellName then
						namePlateMixin:DebugLog("|T" .. spellTexture .. ":20|t"..spellName.." |cFFCCCCCC("..spellID..")|r")												
					end
				end
				local namePlate = C_NamePlate_GetNamePlateForUnit("player", issecure())
				if namePlate then
					local _, spellTextureNoOverride = GetSpellTexture(spellID)
					if not L.BlackListSpellTable[spellID] then
						namePlate.UnitFrame.guid = sourceGUID
						AddSpellActivityFrame(namePlate.UnitFrame, spellTextureNoOverride)
					end
				end   
			end
		end
		
		-- used ToD or Spell Reflect
		if ((L.config.classSpell_ToD and L.selfClass == 'MONK') or (L.config.classSpell_SR and L.selfClass == 'WARRIOR')) 
			and L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.spellID == spellID and sourceGUID == UnitGUID("player") then
			
			if L.selfClass == 'WARRIOR' and L.config.classSpell_SR_spam and L.config.classSpell_SR_text ~= nil and IsInGroup() then
				SendChatMessage(L.config.classSpell_SR_text , namePlateMixin:InstanceOrParty())					
			end
			
			L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.ready = false
			if L.selfClass == 'MONK' then
				namePlateMixin:UpdateNamePlateByOptions("nameplate")
			end
		end
		
		-- used kick ability
		if namePlateMixin.PARTY_TABLE[sourceGUID] and namePlateMixin.PARTY_TABLE[sourceGUID].kickSpell and namePlateMixin.PARTY_TABLE[sourceGUID].kickSpell == spellID then
			namePlateMixin.PARTY_TABLE[sourceGUID].expirationTime = GetTime() + (GetSpellBaseCooldown(spellID) / 1000)
			namePlateMixin.PARTY_TABLE[sourceGUID].kickCount = (namePlateMixin.PARTY_TABLE[sourceGUID].kickCount or 0) + 1
			
			if L.config.player_resource_type == 3 then
				if L.config.party_kick_sort	== "time" then
					namePlateMixin:SortPartyTable(L.config.party_kick_sort)
				else
					classBarMixin:ClassBarUpdateKick(sourceGUID)
				end
			end
						
			if L.config.mythic_plus_enable and L.config.mythic_kicker_prediction then --and L.isSavedMap then	
				if ((L.config.mythic_kicker_mark_groupleader and UnitIsGroupLeader("player")) or not L.config.mythic_kicker_mark_groupleader) then --L.config.mythic_kicker_mark_show and 
					for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
						if namePlate.UnitFrame.unitGUID == destGUID and namePlate.UnitFrame.mapID and namePlate.UnitFrame.npcID and L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID] then
							if tonumber(L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].desc) then
								if L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].autoMark then
									if namePlate.UnitFrame.raidTargetIndex and namePlate.UnitFrame.raidTargetIndex > 0 and namePlate.UnitFrame.raidTargetIndex < 8 then
										USED_RAID_MARKS[namePlate.UnitFrame.raidTargetIndex] = false
										SetRaidTarget(namePlate.UnitFrame.displayedUnit, 0)
									end
									local guid = namePlateMixin:BestKickerFromPartyTable()
									if guid then
										SetRaidTarget(namePlate.UnitFrame.displayedUnit, L.config.mythic_kicker_mark[namePlateMixin.PARTY_TABLE[guid].mark])
										
										if L.config.mythic_kicker_info_show and guid then
											textPanelMixin:ShowText("|c" .. namePlateMixin.PARTY_TABLE[guid].classColor.colorStr .. namePlateMixin.PARTY_TABLE[guid].name .. "|r", 3)
										end
									end
								end
							end
						end
					end
				end
			end
		end

	elseif ( combatEvent == "SPELL_CAST_START" ) then
		local _, _, _, _, _, npcid = strsplit("-", sourceGUID)
		local npcID = tonumber(npcid)
		if L.MythicNPCData[L.mapID or 0][npcID] and L.MythicNPCData[L.mapID or 0][npcID][spellID] then
			L.MythicNPCData[L.mapID or 0][npcID][spellID].school = spellSchool
		end
		
		if L.config.cb_schoolColor then
			local unitToken = UnitTokenFromGUID(sourceGUID)
			if unitToken then
				local namePlate = C_NamePlate_GetNamePlateForUnit(unitToken, issecure())
				if namePlate and L.config.cb_schoolColors[spellSchool] then
					namePlateMixin:SetMyBorderColor(namePlate.UnitFrame.castBar.border, unpack(L.config.cb_schoolColors[spellSchool].color))
				end
			end
			--[[for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
				if sourceGUID == namePlate.UnitFrame.unitGUID and namePlate.UnitFrame.unitType ~= "self" then
					--namePlate.UnitFrame.castBar.border.shadow:SetBackdropBorderColor(unpack(L.config.cb_schoolColors[spellSchool].color))
					namePlateMixin:SetMyBorderColor(namePlate.UnitFrame.castBar.border, unpack(L.config.cb_schoolColors[spellSchool].color))
				end
			end]]--
			
			
		end
		
	elseif ( combatEvent == "SPELL_AURA_APPLIED" and bit.band(destFlag, COMBATLOG_OBJECT_TYPE_NPC) ~= 0 ) then -- NPC
		-- zistujem ci spell bol preruseny inak ako kickom
		local _, _, _, _, _, npcID = strsplit("-", destGUID)
		if L.isSavedMap or L.MythicNPCData[0][tonumber(npcID)] then
			if L.diminishSpellTable["Stun"][spellID] or L.diminishSpellTable["Disorient"][spellID] or L.diminishSpellTable["Incapacitate"][spellID] then
				for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
					if destGUID == namePlate.UnitFrame.unitGUID and namePlate.UnitFrame.castBar:IsShown() and namePlate.UnitFrame.spellCD[namePlate.UnitFrame.castBar.spellID] then --namePlate.UnitFrame.unit
						namePlate.UnitFrame.spellCD[namePlate.UnitFrame.castBar.spellID].previousTime = nil
					end
				end		
			end
		end
		
		-- ak niekto pouzil stun (DR) abilitu
		if L.config.diminish_enable and L.diminishSpellTable[L.config.diminish_type][spellID] then
			if not NPC_TABLE[destGUID] then
				NPC_TABLE[destGUID] = {}
				NPC_TABLE[destGUID].count = 1
				NPC_TABLE[destGUID].expirationTime = GetTime() + 24
			elseif not NPC_TABLE[destGUID].count then
				NPC_TABLE[destGUID].count = 1
				NPC_TABLE[destGUID].expirationTime = GetTime() + 24
			else
				if NPC_TABLE[destGUID].expirationTime < GetTime() then
					NPC_TABLE[destGUID].count = 1
				else
					NPC_TABLE[destGUID].count = (NPC_TABLE[destGUID].count) % 3 + 1
				end	
				NPC_TABLE[destGUID].expirationTime = GetTime() + 24
			end
				
			for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
				if destGUID == namePlate.UnitFrame.unitGUID then
					namePlate.UnitFrame.diminishBar.expirationTime = NPC_TABLE[destGUID].expirationTime
					namePlate.UnitFrame.diminishBar:SetScript("OnUpdate", 
						function(self, elapsed)
							local timeLeft = self.expirationTime - GetTime()
							if timeLeft > 0 then
								PixelUtil.SetStatusBarValue(self, timeLeft)
							else
								self:SetScript("OnUpdate", nil)
								self:Hide()
							end
						end)

					local r, g, b, a = unpack(L.config.diminish_color[NPC_TABLE[destGUID].count])
					namePlate.UnitFrame.diminishBar:SetStatusBarColor(r, g, b, a)
					namePlate.UnitFrame.diminishBar.border.bg:SetVertexColor(r / 3, g / 3, b / 3, 1)
					namePlate.UnitFrame.diminishBar:Show()
				end
			end
			
			if L.config.diminish_spam_enable and sourceName then
				namePlateMixin:DebugLog(namePlateMixin:GetTextColorByGUID(sourceGUID, string_gsub(sourceName, "%-[^|]+", "")).." use "..GetSpellLink(spellID).." on "..destName.." and create "..NPC_TABLE[destGUID].count.." stack.")
			end
		end
		
	elseif ( combatEvent == "UNIT_DIED" ) then
		NPC_TABLE[destGUID] = nil
		
	end
end

-- definica vzhladu nameplatu pri prvom zobrazeni
function namePlateMixin:OnNamePlateCreated(namePlate)
	namePlate.UnitFrame = CreateFrame("Button", "$parent", namePlate, "FrameFlashTemplate")
		namePlate.UnitFrame:SetAllPoints(namePlate)
		namePlate.UnitFrame:SetFrameLevel(namePlate:GetFrameLevel())
		namePlate.UnitFrame.spellCD = {}
		
	namePlate.UnitFrame.WidgetContainer = CreateFrame('Frame', nil, namePlate.UnitFrame, 'UIWidgetContainerTemplate')
		PixelUtil.SetPoint(namePlate.UnitFrame.WidgetContainer, "BOTTOM", namePlate.UnitFrame, "TOP", 0, 0)
		namePlate.UnitFrame.WidgetContainer:Hide()
			
	namePlate.UnitFrame.healthBar = CreateFrame("StatusBar", nil, namePlate.UnitFrame)
		Mixin(namePlate.UnitFrame.healthBar, SmoothStatusBarMixin)
		if L.config.healthbar_smooth then
			namePlate.UnitFrame.healthBar:SetMinMaxSmoothedValue(0, 1)
		else
			namePlate.UnitFrame.healthBar:SetMinMaxValues(0, 1)
		end
		namePlate.UnitFrame.healthBar:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel())
		namePlate.UnitFrame.healthBar.border = self:CreateMyBackdrop(namePlate.UnitFrame.healthBar, 1, 0, 0, 0, 1, LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.healthbar_bg_texture[namePlate.UnitFrame.unitType]), 0, 0, 0, 1, L.config.healthbar_bg_offset, 0, 0, 0, 0.6)
	
	namePlate.UnitFrame.healthBar.spark = namePlate.UnitFrame.healthBar:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.healthBar.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-spark")
		--namePlate.UnitFrame.healthBar.spark:SetTexCoord (0, 0.5, 0, 1)
		namePlate.UnitFrame.healthBar.spark:SetBlendMode("ADD")
	
	namePlate.UnitFrame.totalAbsorb = namePlate.UnitFrame.healthBar:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.totalAbsorb:ClearAllPoints();
		namePlate.UnitFrame.totalAbsorb:SetTexture("Interface\\RaidFrame\\Shield-Fill");
		namePlate.UnitFrame.totalAbsorb:Hide()
	namePlate.UnitFrame.totalAbsorbOverlay = namePlate.UnitFrame.healthBar:CreateTexture(nil, "OVERLAY")	
		namePlate.UnitFrame.totalAbsorbOverlay:SetAllPoints(namePlate.UnitFrame.totalAbsorb)
		namePlate.UnitFrame.totalAbsorbOverlay:SetTexture("Interface\\RaidFrame\\Shield-Overlay", true, true)
		namePlate.UnitFrame.totalAbsorbOverlay.tileSize = 32
		namePlate.UnitFrame.totalAbsorbOverlay:Hide()
	namePlate.UnitFrame.overAbsorbGlow = namePlate.UnitFrame.healthBar:CreateTexture(nil, "OVERLAY")	
		namePlate.UnitFrame.overAbsorbGlow:ClearAllPoints()
		namePlate.UnitFrame.overAbsorbGlow:SetTexture("Interface\\RaidFrame\\Shield-Overshield")
		namePlate.UnitFrame.overAbsorbGlow:SetBlendMode("ADD")
		namePlate.UnitFrame.overAbsorbGlow:SetPoint("BOTTOMLEFT", namePlate.UnitFrame.healthBar, "BOTTOMRIGHT", -4, -1)
		namePlate.UnitFrame.overAbsorbGlow:SetPoint("TOPLEFT", namePlate.UnitFrame.healthBar, "TOPRIGHT", -4, 1)
		namePlate.UnitFrame.overAbsorbGlow:SetWidth(10)
		namePlate.UnitFrame.overAbsorbGlow:Hide()
			
	namePlate.UnitFrame.powerBar = CreateFrame("StatusBar", nil, namePlate.UnitFrame.healthBar)
		Mixin(namePlate.UnitFrame.powerBar, SmoothStatusBarMixin)
		namePlate.UnitFrame.powerBar:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel() + 2)
		namePlate.UnitFrame.powerBar.border = self:CreateMyBackdrop(namePlate.UnitFrame.powerBar, 1, 0, 0, 0, 1, LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.self_powerbar_texture), 0, 0, 0, .6)
	
	namePlate.UnitFrame.diminishBar = CreateFrame("StatusBar", nil, namePlate.UnitFrame.healthBar)
		namePlate.UnitFrame.diminishBar:SetFrameLevel(namePlate.UnitFrame.healthBar:GetFrameLevel() + 2)
		namePlate.UnitFrame.diminishBar:ClearAllPoints()
		PixelUtil.SetPoint(namePlate.UnitFrame.diminishBar, "TOPLEFT", namePlate.UnitFrame.healthBar, "TOPLEFT", 2, L.config.powerbar_height + L.config.powerbar_Y)
		PixelUtil.SetPoint(namePlate.UnitFrame.diminishBar, "BOTTOMRIGHT", namePlate.UnitFrame.healthBar, "TOPLEFT", 18, L.config.powerbar_Y)
		namePlate.UnitFrame.diminishBar:SetMinMaxValues(0, 24)
		namePlate.UnitFrame.diminishBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, "np_target2"))
		namePlate.UnitFrame.diminishBar.border = self:CreateMyBackdrop(namePlate.UnitFrame.diminishBar, 1, 0, 0, 0, 1, LSM:Fetch(LSM.MediaType.STATUSBAR, "np_target2"), 0, 0, 0, 1)
		namePlate.UnitFrame.diminishBar:Hide()
	
	namePlate.UnitFrame.threatBar = CreateFrame("StatusBar", nil, namePlate.UnitFrame.healthBar)
		namePlate.UnitFrame.threatBar:SetFrameLevel(namePlate.UnitFrame.healthBar:GetFrameLevel() + 2)
		namePlate.UnitFrame.threatBar:ClearAllPoints()
		PixelUtil.SetPoint(namePlate.UnitFrame.threatBar, "TOPLEFT", namePlate.UnitFrame.healthBar, "TOPRIGHT", -18, L.config.powerbar_height + L.config.powerbar_Y)
		PixelUtil.SetPoint(namePlate.UnitFrame.threatBar, "BOTTOMRIGHT", namePlate.UnitFrame.healthBar, "TOPRIGHT", -2, L.config.powerbar_Y)
		namePlate.UnitFrame.threatBar:SetMinMaxValues(0, 1)
		PixelUtil.SetStatusBarValue(namePlate.UnitFrame.threatBar, 1)
		namePlate.UnitFrame.threatBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, "np_target2"))
		namePlate.UnitFrame.threatBar.border = self:CreateMyBackdrop(namePlate.UnitFrame.threatBar, 1, 0, 0, 0, 1)
		namePlate.UnitFrame.threatBar:Hide()
	namePlate.UnitFrame.threatText = self:CreateMyText(namePlate.UnitFrame.healthBar, L.config.hp_font, L.config.hp_fontsize, L.config.hp_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.threatText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.hp_font), L.config.hp_fontsize, L.config.hp_font_flag)
		namePlate.UnitFrame.threatText:SetPoint("BOTTOMRIGHT", namePlate.UnitFrame.healthBar, "TOPRIGHT", 0, -4)
		namePlate.UnitFrame.threatText:Hide()
	
	namePlate.UnitFrame.nameText = self:CreateMyText(namePlate.UnitFrame, L.config.name_font_npc, L.config.name_fontsize_npc, L.config.name_font_flag_npc, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.nameText:ClearAllPoints()
		PixelUtil.SetPoint(namePlate.UnitFrame.nameText, "TOP", namePlate.UnitFrame, "TOP", 0, - (L.config.healthbar_height["enemy"] + 1))
	namePlate.UnitFrame.nameTextBGTexture = namePlate.UnitFrame:CreateTexture(nil, "OVERLAY", nil, 6)
		namePlate.UnitFrame.nameTextBGTexture:SetPoint("BOTTOM", namePlate.UnitFrame.nameText, "BOTTOM", 0, -2)
		namePlate.UnitFrame.nameTextBGTexture:Hide()
			
	namePlate.UnitFrame.healthText = self: CreateMyText(namePlate.UnitFrame.healthBar, L.config.hp_font, L.config.hp_fontsize, L.config.hp_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.healthText:ClearAllPoints()
		namePlate.UnitFrame.healthText:Hide()
	
	namePlate.UnitFrame.rangeText = self:CreateMyText(namePlate.UnitFrame.healthBar, L.config.range_font, L.config.range_fontsize, L.config.range_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.rangeText:ClearAllPoints()
		namePlate.UnitFrame.rangeText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.range_font), L.config.range_fontsize, L.config.range_font_flag)
		namePlate.UnitFrame.rangeText:SetPoint(L.config.range_point, namePlate.UnitFrame.healthBar, L.config.range_relativePoint, L.config.range_posun_X, L.config.range_posun_Y)
		namePlate.UnitFrame.rangeText:SetTextColor(unpack(L.config.range_font_color))
		namePlate.UnitFrame.rangeText:Hide()
	
	namePlate.UnitFrame.challengeModeValue = self:CreateMyText(namePlate.UnitFrame, L.config.mythic_percent_font, L.config.mythic_percent_fontsize, L.config.mythic_percent_font_flag, "ARTWORK", "CENTER", "CENTER", false)
		namePlate.UnitFrame.challengeModeValue:SetPoint("LEFT", namePlate.UnitFrame.nameText, "RIGHT", 0, 0)
		namePlate.UnitFrame.challengeModeValue:SetTextColor(unpack(L.config.mythic_percent_color))
		namePlate.UnitFrame.challengeModeValue:Hide()
	
	namePlate.UnitFrame.helpText = self:CreateMyText(namePlate.UnitFrame, L.config.mythic_help_font, L.config.mythic_help_fontsize, L.config.mythic_help_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.helpText:SetTextColor(unpack(L.config.mythic_help_color))
		namePlate.UnitFrame.helpText:SetText(nil)
		namePlate.UnitFrame.helpText:Hide()
	
	namePlate.UnitFrame.descText = self:CreateMyText(namePlate.UnitFrame, L.config.desc_text_font, L.config.desc_text_fontsize, L.config.desc_text_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.descText:SetText(nil)
		namePlate.UnitFrame.descText:Hide()
	
	namePlate.UnitFrame.questIcon = namePlate.UnitFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.questIcon:SetPoint("LEFT", namePlate.UnitFrame.nameText, "RIGHT", L.config.quest_icon_x, L.config.quest_icon_y)
		namePlate.UnitFrame.questIcon:SetSize(16, 16)
		namePlate.UnitFrame.questIcon:Hide()
	
	namePlate.UnitFrame.healerIcon = namePlate.UnitFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.healerIcon:SetTexture(mediaFolder.."heal")
		namePlate.UnitFrame.healerIcon:SetSize(18, 18)
		namePlate.UnitFrame.healerIcon:SetVertexColor(0, 1, 0)
		namePlate.UnitFrame.healerIcon:SetPoint("LEFT", namePlate.UnitFrame.nameText, "RIGHT")
		namePlate.UnitFrame.healerIcon:Hide()

	namePlate.UnitFrame.targetOverlapTexture = namePlate.UnitFrame.healthBar:CreateTexture(nil, "OVERLAY")
		PixelUtil.SetPoint(namePlate.UnitFrame.targetOverlapTexture, "TOPLEFT", namePlate.UnitFrame.healthBar, "TOPLEFT", - L.config.target_overlap_offset, L.config.target_overlap_offset)
		PixelUtil.SetPoint(namePlate.UnitFrame.targetOverlapTexture, "BOTTOMRIGHT", namePlate.UnitFrame.healthBar, "BOTTOMRIGHT", L.config.target_overlap_offset, -L.config.target_overlap_offset)
		namePlate.UnitFrame.targetOverlapTexture:SetVertexColor(unpack(L.config.target_overlap_color))
		namePlate.UnitFrame.targetOverlapTexture:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.target_overlap))
		namePlate.UnitFrame.targetOverlapTexture:SetBlendMode(L.config.target_overlap_blend)
		namePlate.UnitFrame.targetOverlapTexture:Hide()
	
	namePlate.UnitFrame.creatureIconFrame = CreateFrame("Frame", nil, namePlate.UnitFrame)
		namePlate.UnitFrame.creatureIconFrame:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel() + 1)
		namePlate.UnitFrame.creatureIconFrame.creatureIconBG = namePlate.UnitFrame.creatureIconFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.creatureIconFrame.creatureIconBG:SetAllPoints()
		namePlate.UnitFrame.creatureIconFrame.creatureIconBG:SetVertexColor(0, 0, 0, 1)
		
		namePlate.UnitFrame.creatureIconFrame.creatureIcon = namePlate.UnitFrame.creatureIconFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.creatureIconFrame.creatureIcon:ClearAllPoints()
		PixelUtil.SetPoint(namePlate.UnitFrame.creatureIconFrame.creatureIcon, "TOPLEFT", namePlate.UnitFrame.creatureIconFrame, "TOPLEFT", 1, -1)
		PixelUtil.SetPoint(namePlate.UnitFrame.creatureIconFrame.creatureIcon, "BOTTOMRIGHT", namePlate.UnitFrame.creatureIconFrame, "BOTTOMRIGHT", -1, 1)
		--namePlate.UnitFrame.creatureIconFrame.creatureIcon:SetTexture(namePlate.UnitFrame.creatureIconFrame.creatureIconBG:GetTexture())
		namePlate.UnitFrame.creatureIconFrame:Hide()
			
		
	namePlate.UnitFrame.pvpIcon = namePlate.UnitFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.pvpIcon:SetSize(20, 20)
		namePlate.UnitFrame.pvpIcon:SetPoint("RIGHT", namePlate.UnitFrame.nameText, "LEFT")
		namePlate.UnitFrame.pvpIcon:Hide()
		
	namePlate.UnitFrame.RaidTargetFrame = CreateFrame("Frame", nil, namePlate.UnitFrame)
		namePlate.UnitFrame.RaidTargetFrame:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel() + 2)
		namePlate.UnitFrame.RaidTargetFrame:SetSize(20, 20)
		namePlate.UnitFrame.RaidTargetFrame.RaidTargetIcon = namePlate.UnitFrame.RaidTargetFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.RaidTargetFrame.RaidTargetIcon:SetAllPoints()
		namePlate.UnitFrame.RaidTargetFrame.RaidTargetIcon:Hide()

	namePlate.UnitFrame.debuffAuras = CreateFrame("Frame", nil, namePlate.UnitFrame)
		namePlate.UnitFrame.debuffAuras:SetSize(L.config.aura_icon_debuff_width * L.config.aura_icon_debuff_max, L.config.aura_icon_debuff_height)
		namePlate.UnitFrame.debuffAuras:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel() + 2)
		namePlate.UnitFrame.debuffAuras:Hide()
	
	namePlate.UnitFrame.buffAuras = CreateFrame("Frame", nil, namePlate.UnitFrame)
		namePlate.UnitFrame.buffAuras:SetSize(L.config.aura_icon_buff_width * L.config.aura_icon_buff_max, L.config.aura_icon_buff_height)
		namePlate.UnitFrame.buffAuras:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel() + 2)
		namePlate.UnitFrame.buffAuras:Hide()
	
	namePlate.UnitFrame.castBar = CreateFrame("StatusBar", nil, namePlate.UnitFrame)
		namePlate.UnitFrame.castBar:SetFrameStrata("HIGH") -- HIGH
		namePlate.UnitFrame.castBar:SetFrameLevel(namePlate.UnitFrame:GetFrameLevel() + 3)
		namePlate.UnitFrame.castBar.border = self:CreateMyBackdrop(namePlate.UnitFrame.castBar, 1, 0, 0, 0, 1, LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.cb_texture_bg[L.config.cb_type]), 0, 0, 0, 0.7, L.config.cb_shadow_offset, 0, 0, 0, 1)
		namePlate.UnitFrame.castBar.border.shadow:Hide()
		namePlate.UnitFrame.castBar:Hide()
		
	namePlate.UnitFrame.castBar.iconFrame = CreateFrame("Frame", nil, namePlate.UnitFrame.castBar)
		namePlate.UnitFrame.castBar.iconFrame.border = self:CreateMyBackdrop(namePlate.UnitFrame.castBar.iconFrame, 1, 0, 0, 0, 1, "Interface\\Buttons\\WHITE8x8", 0, 0, 0, 1, 4, 0, 0, 0, 1)
		
	namePlate.UnitFrame.castBar.Icon = namePlate.UnitFrame.castBar.iconFrame:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.castBar.Icon:SetAllPoints()
		namePlate.UnitFrame.castBar.Icon:SetTexCoord(.08, .92, 0.08, 0.92)
	
	namePlate.UnitFrame.castBar.Text = self:CreateMyText(namePlate.UnitFrame.castBar, L.config.cb_font, L.config.cb_fontsize, L.config.cb_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.castBar.Text:SetTextColor(1, 1, 1)
		namePlate.UnitFrame.castBar.Text:SetPoint("BOTTOM", namePlate.UnitFrame.castBar, "TOP", 0, 0)
		
	namePlate.UnitFrame.castBar.kickerNameBGTexture = namePlate.UnitFrame.castBar:CreateTexture(nil, "OVERLAY", nil, 6)
		namePlate.UnitFrame.castBar.kickerNameBGTexture:SetPoint("TOP", namePlate.UnitFrame.castBar, "BOTTOM", 0, 3)
		namePlate.UnitFrame.castBar.kickerNameBGTexture:Hide()
		namePlate.UnitFrame.castBar.kickerNameText = self:CreateMyText(namePlate.UnitFrame.castBar, L.config.cb_kicker_font, L.config.cb_kicker_fontsize, L.config.cb_kicker_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.castBar.kickerNameText:SetPoint("BOTTOM", namePlate.UnitFrame.castBar.kickerNameBGTexture, "BOTTOM", 0, 1)
	
	namePlate.UnitFrame.castBar.targetNameBGTexture = namePlate.UnitFrame.castBar:CreateTexture(nil, "OVERLAY", nil, 6)
		namePlate.UnitFrame.castBar.targetNameBGTexture:SetPoint("BOTTOM", namePlate.UnitFrame.castBar, "TOP", 0, -3)
		namePlate.UnitFrame.castBar.targetNameBGTexture:Hide()
		namePlate.UnitFrame.castBar.targetNameText = self:CreateMyText(namePlate.UnitFrame.castBar, L.config.cb_kicker_font, L.config.cb_kicker_fontsize, L.config.cb_kicker_font_flag, "OVERLAY", "CENTER", "CENTER", false)
		namePlate.UnitFrame.castBar.targetNameText:SetPoint("BOTTOM", namePlate.UnitFrame.castBar.targetNameBGTexture, "BOTTOM", 0, 1)
		
	namePlate.UnitFrame.castBar.CDText = self:CreateMyText(namePlate.UnitFrame.castBar.iconFrame, L.config.cb_CD_font, L.config.cb_CD_fontsize, L.config.cb_CD_font_flag, "OVERLAY", "CENTER", "LEFT", false)
		namePlate.UnitFrame.castBar.CDText:SetTextColor(1, 0, 0)
		namePlate.UnitFrame.castBar.CDText:SetPoint("CENTER", namePlate.UnitFrame.castBar.Icon, "CENTER", 0, 0)

	namePlate.UnitFrame.castBar.iconWhenNoninterruptible = false

	namePlate.UnitFrame.castBar.Spark = namePlate.UnitFrame.castBar:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.castBar.Spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-spark")
		namePlate.UnitFrame.castBar.Spark:SetBlendMode("ADD")
		namePlate.UnitFrame.castBar.Spark:SetTexCoord (0, 0.5, 0, 1)
		namePlate.UnitFrame.castBar.Spark.offsetY = 0
			
	namePlate.UnitFrame.castBar.Flash = namePlate.UnitFrame.castBar:CreateTexture(nil, "OVERLAY")
		namePlate.UnitFrame.castBar.Flash:SetAllPoints()
		namePlate.UnitFrame.castBar.Flash:SetBlendMode("ADD")

	namePlate.UnitFrame.castBar:SetScript("OnEvent", MyCastingBarFrame_OnEvent)
	namePlate.UnitFrame.castBar:SetScript("OnUpdate", MyCastingBarFrame_OnUpdate)
	namePlate.UnitFrame.castBar:SetScript("OnShow", MyCastingBarFrame_OnShow)
	
	namePlate.UnitFrame:EnableMouse(false)
end

function namePlateMixin:UpdateSelfNamePlate()
	local namePlatePlayer = C_NamePlate_GetNamePlateForUnit("player", issecure())
	if namePlatePlayer then
		local classColor = RAID_CLASS_COLORS[namePlatePlayer.UnitFrame.englishClass]
		local powerType, powerToken =  UnitPowerType('player')
		local powerColor = PowerBarColor[powerToken]
		
		namePlatePlayer.UnitFrame:SetAlpha(L.config.nameplateSelfAlpha)
		
		--health bar
		namePlatePlayer.UnitFrame.healthBar:ClearAllPoints()
		if namePlatePlayer.UnitFrame.self_unitframe_warning then
			namePlatePlayer.UnitFrame.healthBar:SetSize(L.config.healthbar_width["self"] * (L.config.self_unitframe_scale), L.config.healthbar_height["self"] * L.config.self_unitframe_scale)
		else
			namePlatePlayer.UnitFrame.healthBar:SetSize(L.config.healthbar_width["self"], L.config.healthbar_height["self"])
		end
		
		PixelUtil.SetPoint(namePlatePlayer.UnitFrame.healthBar, "TOP", namePlatePlayer.UnitFrame, "TOP", 0, 0)
		namePlatePlayer.UnitFrame.healthBar.color = {classColor.r, classColor.g, classColor.b, 1}
		namePlatePlayer.UnitFrame.healthBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.healthbar_texture["self"]))
		namePlatePlayer.UnitFrame.healthBar:SetStatusBarColor(unpack(namePlatePlayer.UnitFrame.healthBar.color))
		namePlatePlayer.UnitFrame.healthBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.healthbar_bg_texture["self"]))
		namePlatePlayer.UnitFrame.healthBar.border.bg:SetVertexColor(unpack(L.config.self_healthbar_bg_color))
		
		if L.config.healthbar_shadow["self"] then
			namePlatePlayer.UnitFrame.healthBar.border.shadow:SetPoint("TOPLEFT", namePlatePlayer.UnitFrame.healthBar.border, "TOPLEFT", -3, 3)
			namePlatePlayer.UnitFrame.healthBar.border.shadow:SetPoint("BOTTOMRIGHT", namePlatePlayer.UnitFrame.healthBar.border, "BOTTOMRIGHT", 3, -3)
			namePlatePlayer.UnitFrame.healthBar.border.shadow:SetBackdrop({bgFile = nil, edgeFile = mediaFolder.."glowTex", edgeSize = 3, tile = false, tileSize = 0, insets = 1})
			namePlatePlayer.UnitFrame.healthBar.border.shadow:SetBackdropBorderColor(unpack(L.config.healthbar_shadow_color["self"]))
			namePlatePlayer.UnitFrame.healthBar.border.shadow:Show()
		else
			namePlatePlayer.UnitFrame.healthBar.border.shadow:Hide()
		end
		namePlatePlayer.UnitFrame.healthBar:Show()
		
		--power bar
		namePlatePlayer.UnitFrame.powerBar:ClearAllPoints()
		if namePlatePlayer.UnitFrame.self_unitframe_warning then
			namePlatePlayer.UnitFrame.powerBar:SetSize(L.config.self_powerbar_width * (L.config.self_unitframe_scale), L.config.self_powerbar_height * L.config.self_unitframe_scale)
		else
			namePlatePlayer.UnitFrame.powerBar:SetSize(L.config.self_powerbar_width, L.config.self_powerbar_height)
		end
		
		namePlatePlayer.UnitFrame.powerBar:SetPoint(L.config.self_powerbar_point, namePlatePlayer.UnitFrame.healthBar, L.config.self_powerbar_relativePoint, L.config.self_powerbar_posun_X, L.config.self_powerbar_posun_Y)
		namePlatePlayer.UnitFrame.powerBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.self_powerbar_texture))
		namePlatePlayer.UnitFrame.powerBar:SetStatusBarColor(powerColor.r, powerColor.g, powerColor.b, 1)
		namePlatePlayer.UnitFrame.powerBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.self_powerbar_texture))
		namePlatePlayer.UnitFrame.powerBar.border.bg:SetVertexColor(powerColor.r / 3, powerColor.g / 3, powerColor.b / 3, 1)
		namePlatePlayer.UnitFrame.powerBar.border:Show()
		namePlatePlayer.UnitFrame.powerBar:Show()
		
		self:SetMyBorderColor(namePlatePlayer.UnitFrame.healthBar.border, 0, 0, 0, 1)
		
		--update
		UpdateName(namePlatePlayer.UnitFrame, "Selfname")
		UpdateHealth(namePlatePlayer.UnitFrame)
		--UpdateAbsorb(namePlatePlayer.UnitFrame)
		UpdateMaxPower(namePlatePlayer.UnitFrame)
		UpdatePower(namePlatePlayer.UnitFrame)
		UpdateAllAuras(namePlatePlayer.UnitFrame)
		
		if L.config.gcd_showSpellActivity then
			if not namePlatePlayer.UnitFrame.spellActivityFrames then
				namePlatePlayer.UnitFrame.spellActivityFrames = CreateFramePool("Button", namePlatePlayer.UnitFrame, "SpellActivityFrameTemplate", ResetSpellActivityFrame)
				namePlatePlayer.UnitFrame.spellActivityFrames.last = nil
			end
			namePlatePlayer.UnitFrame:SetScript("OnUpdate", function(self, elapsed)
				local sortedFrames = {}
				
				for frame in self.spellActivityFrames:EnumerateActive() do
					table_insert(sortedFrames, frame)
				end
				
				table_sort(sortedFrames, function(a, b) return a.createdAt < b.createdAt end)
				
				for _, frame in ipairs(sortedFrames) do
					if GetTime() >= (frame.createdAt + L.config.gcd_anim_duration) and not (frame.AnimOut:IsPlaying() or frame.expired) then
						frame.AnimOut:Play()
						frame.AnimOut:SetScript("OnFinished", function(self)
							self:GetParent().expired = true
							self:GetParent():SetAlpha(0)
						end)
					end
					if self.spellActivityFrames:GetNumActive() > L.config.gcd_anim_max or frame.expired or frame.guid ~= self.guid then
						self.spellActivityFrames:Release(frame)
					end
				end
				wipe(sortedFrames)
			end)
		elseif namePlatePlayer.UnitFrame.spellActivityFrames then
			namePlatePlayer.UnitFrame.spellActivityFrames:ReleaseAll()
			namePlatePlayer.UnitFrame.spellActivityFrames.last = nil
			namePlatePlayer.UnitFrame:SetScript("OnUpdate", nil)
		end
	end
end

function namePlateMixin:UpdateEnemyFriendlyNamePlate(unitFrame)
	
	if unitFrame.isPlayer and L.config.healthbar_class_color[unitFrame.unitType] then
		local classColor = RAID_CLASS_COLORS[unitFrame.englishClass]
		unitFrame.healthBar.color = {classColor.r, classColor.g, classColor.b, 1}
	else
		unitFrame.healthBar.color = L.config.threat_color_noaggro
	end	
	
	unitFrame.healthBar:ClearAllPoints()
	PixelUtil.SetPoint(unitFrame.healthBar, "TOP", unitFrame, "TOP", 0, 0)
	UpdateHealthBarTexture(unitFrame)
	
	unitFrame.healthBar:SetStatusBarColor(unpack(unitFrame.healthBar.color))
	unitFrame.healthBar:Hide()
	
	unitFrame.powerBar:ClearAllPoints()	
	PixelUtil.SetPoint(unitFrame.powerBar, "TOPLEFT", unitFrame.healthBar, "TOPLEFT", 20, L.config.powerbar_height + L.config.powerbar_Y)
	PixelUtil.SetPoint(unitFrame.powerBar, "BOTTOMRIGHT", unitFrame.healthBar, "TOPRIGHT", -20, L.config.powerbar_Y)
	unitFrame.powerBar:SetStatusBarTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.powerbar_texture))
	unitFrame.powerBar:SetStatusBarColor(0, 1, 1, 1)
	unitFrame.powerBar.border.bg:SetVertexColor(0, .5, .5, 1)
	unitFrame.powerBar.border.bg:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.powerbar_bg_texture))
	unitFrame.powerBar:Hide()
	
	PixelUtil.SetPoint(unitFrame.diminishBar, "TOPLEFT", unitFrame.healthBar, "TOPLEFT", 2, L.config.powerbar_height + L.config.powerbar_Y)
	PixelUtil.SetPoint(unitFrame.diminishBar, "BOTTOMRIGHT", unitFrame.healthBar, "TOPLEFT", 18, L.config.powerbar_Y)
	PixelUtil.SetPoint(unitFrame.threatBar, "TOPLEFT", unitFrame.healthBar, "TOPRIGHT", -18, L.config.powerbar_height + L.config.powerbar_Y)
	PixelUtil.SetPoint(unitFrame.threatBar, "BOTTOMRIGHT", unitFrame.healthBar, "TOPRIGHT", -2, L.config.powerbar_Y)
	
	unitFrame.healthBar.border.shadow:ClearAllPoints()
	unitFrame.healthBar.border.shadow:SetPoint("TOPLEFT", unitFrame.healthBar.border, "TOPLEFT", -L.config.healthbar_bg_offset, L.config.healthbar_bg_offset)
	unitFrame.healthBar.border.shadow:SetPoint("BOTTOMRIGHT", unitFrame.healthBar.border, "BOTTOMRIGHT", L.config.healthbar_bg_offset, -L.config.healthbar_bg_offset)
	unitFrame.healthBar.border.shadow:SetBackdrop({bgFile = nil, edgeFile = mediaFolder.."glowTex", edgeSize = L.config.healthbar_bg_offset, tile = false, tileSize = 0, insets = 1})
	unitFrame.healthBar.border.shadow:SetBackdropBorderColor(unpack(L.config.target_shadow_color))
	
	unitFrame.healthText:ClearAllPoints()
	unitFrame.healthText:SetPoint(L.config.hp_point, unitFrame.healthBar, L.config.hp_relativePoint, L.config.hp_posun_X, L.config.hp_posun_Y)
	unitFrame.healthText:SetFont(LSM:Fetch(LSM.MediaType.FONT, L.config.hp_font), L.config.hp_fontsize, L.config.hp_font_flag)
		
	unitFrame.nameTextBGTexture:SetTexture(LSM:Fetch(LSM.MediaType.STATUSBAR, L.config.name_bg_texture))
	unitFrame.nameTextBGTexture:SetVertexColor(unpack(L.config.name_bg_color))
	unitFrame.descText:SetPoint("TOP", unitFrame.nameText, "BOTTOM", 0, 2)
	unitFrame.helpText:SetPoint("BOTTOM", unitFrame.nameText, "TOP", 0, 0)
	--unitFrame.helpText:SetPoint(L.config.mythic_help_point, unitFrame.nameText, L.config.mythic_help_relativePoint, L.config.mythic_help_posun_X, L.config.mythic_help_posun_Y)		
	
	-- u noveho vzdy nastav na zaciatku na nameText
	UpdateHealthBar(unitFrame, nil, "UpdateEnemyFriendlyNamePlate")
	UpdateCastBar(unitFrame)
end

function namePlateMixin:OnNamePlateAdded(namePlateUnitToken)
	local namePlate = C_NamePlate_GetNamePlateForUnit(namePlateUnitToken, issecure())
	self:SetUnit(namePlate.UnitFrame, namePlateUnitToken)
	
	if namePlate.UnitFrame.unitType == "self" then
		namePlate.UnitFrame.healthBar.currentScale = 1
		namePlate.UnitFrame.healthBar.scale = CreateAnimationGroup(namePlate.UnitFrame.healthBar)
		namePlate.UnitFrame.healthBar.scale.width = namePlate.UnitFrame.healthBar.scale:CreateAnimation("Width")
		namePlate.UnitFrame.healthBar.scale.width:SetDuration(.5)
		namePlate.UnitFrame.healthBar.scale.height = namePlate.UnitFrame.healthBar.scale:CreateAnimation("Height")
		namePlate.UnitFrame.healthBar.scale.height:SetDuration(.5)
		
		namePlate.UnitFrame.powerBar.currentScale = 1
		namePlate.UnitFrame.powerBar.scale = CreateAnimationGroup(namePlate.UnitFrame.powerBar)
		namePlate.UnitFrame.powerBar.scale.width = namePlate.UnitFrame.powerBar.scale:CreateAnimation("Width")
		namePlate.UnitFrame.powerBar.scale.width:SetDuration(.5)
		namePlate.UnitFrame.powerBar.scale.height = namePlate.UnitFrame.powerBar.scale:CreateAnimation("Height")
		namePlate.UnitFrame.powerBar.scale.height:SetDuration(.5)
				
		self:UpdateSelfNamePlate()
	else
		self:UpdateEnemyFriendlyNamePlate(namePlate.UnitFrame)
		if namePlate.UnitFrame.mapID 
			and L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID] 
			and L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].sound
			and NPC_TABLE[namePlate.UnitFrame.unitGUID]
			and not NPC_TABLE[namePlate.UnitFrame.unitGUID].playedsound then
			
			PlaySoundFile(LSM:Fetch(LSM.MediaType.SOUND, L.MythicNPCData[namePlate.UnitFrame.mapID][namePlate.UnitFrame.npcID].sound), L.config.sound_channel)
			NPC_TABLE[namePlate.UnitFrame.unitGUID].playedsound = true
		end
				
		if L.config.healer_detection and not L.isSavedMap then
			if HEALERS_TABLE[namePlate.UnitFrame.unitName] then
				namePlate.UnitFrame.healerIcon:Show()
			else
				namePlate.UnitFrame.healerIcon:Hide()
			end
		end

		self:UpdateAllOnNameplate(namePlate.UnitFrame, "OnNamePlateAdded")
	end

end

function namePlateMixin:OnNamePlateRemoved(namePlateUnitToken)
	local namePlate = C_NamePlate_GetNamePlateForUnit(namePlateUnitToken, issecure())

	if L.config.diminish_enable and NPC_TABLE[namePlate.UnitFrame.unitGUID] then
		namePlate.UnitFrame.diminishBar:Hide()
		namePlate.UnitFrame.diminishBar:SetScript("OnUpdate", nil)
	end

	if L.config.gcd_showSpellActivity and namePlate.UnitFrame.unitType == "self" then
		namePlate.UnitFrame.spellActivityFrames:ReleaseAll()
		namePlate.UnitFrame.spellActivityFrames.last = nil
		namePlate.UnitFrame:SetScript("OnUpdate", nil)
	end									
	
	if L.config.spellCD and next(namePlate.UnitFrame.spellCD) then
		for spellID in pairs(namePlate.UnitFrame.spellCD) do
			namePlate.UnitFrame.spellCD[spellID]:Hide()
			namePlate.UnitFrame.spellCD[spellID]:SetScript("OnUpdate", nil)
			namePlate.UnitFrame.spellCD[spellID] = nil
		end
	end
	
	LCG.AutoCastGlow_Stop(namePlate.UnitFrame.healthBar.border)
	LCG.AutoCastGlow_Stop(namePlate.UnitFrame.healthBar)
	
	if namePlate.UnitFrame.AnimFlash:IsPlaying() then
		namePlate.UnitFrame.AnimFlash:Stop()	
	end
	
	if namePlate.UnitFrame.isPlayerTarget then
		namePlate.UnitFrame.isPlayerTarget = false
		namePlate.UnitFrame.targetOverlapTexture:Hide()
		LCG.PixelGlow_Stop(namePlate.UnitFrame.healthBar)
			
		if namePlate.UnitFrame.healthBar.border.shadow.AnimFlash:IsPlaying() then 
			namePlate.UnitFrame.healthBar.border.shadow.AnimFlash:Stop()
		end
			
		if L.config.mythic_NPC_infoPanel then
			npcInfoPanelMixin:HideNPCInfoPanel()
		end
	end	
		
	ClearWidgetSet(namePlate.UnitFrame)
		
	self:SetUnit(namePlate.UnitFrame, nil)
end

function namePlateMixin:RefreshOptions(event, database, newProfileKey)
	L.config = database.profile
	L.selfClass = select(2, UnitClass('player'))
	L.selfSpec = GetSpecialization()

	if L.selfSpec == 5 then L.selfSpec = 1 end
	L.isSelfTank = self:IsUnitTank("player")
	self:UpdateNamePlateByOptions("update_all")
end

function namePlateMixin:OnAddonLoaded(...)
	local name = ...
	if name == _ then
		
		self.db = LibStub("AceDB-3.0"):New("ConfigDB", L.defaults, true)
		self.db.RegisterCallback(self, "OnProfileChanged", "RefreshOptions")
		self.db.RegisterCallback(self, "OnProfileCopied", "RefreshOptions")
		self.db.RegisterCallback(self, "OnProfileReset", "RefreshOptions")
		L.config = self.db.profile
		L.dbchar = self.db.char
		L.config.debug = false
		
		L.AurasTable = AurasTable or {}
		AurasTable = L.AurasTable
		
		L.AurasSelfPlayerList = AurasSelfPlayerList or {}
		AurasSelfPlayerList = L.AurasSelfPlayerList
		
		L.AurasList = AurasList and AurasList or L.Default_AurasList
		AurasList = L.AurasList
		L.Default_AurasList = nil
		
		L.HealersSpellsList = HealersSpellsList and HealersSpellsList or L.Default_HealersSpellsList
		HealersSpellsList = L.HealersSpellsList
		L.Default_HealersSpellsList = nil
					
		L.BlackListSpellTable = BlackListSpellTable and BlackListSpellTable or L.Default_BlackListSpellTable
		BlackListSpellTable = L.BlackListSpellTable
		L.Default_BlackListSpellTable = nil
			
		L.MythicNPCData = MythicNPCData and MythicNPCData or L.Default_MythicNPCData
		MythicNPCData = L.MythicNPCData
		L.Default_MythicNPCData = nil
		
		L.MythicNPCData[0] = MythicNPCData[0] or {}
		MythicNPCData[0] = L.MythicNPCData[0]
		--L.MythicNPCData[0].instanceColor = {1, 1, 1}
		
		L.MythicNPCData["BlackList"] = MythicNPCData["BlackList"] or {}
		MythicNPCData["BlackList"] = L.MythicNPCData["BlackList"]
		
		L.UpdateNPCDatabase()
		
		-- zaregistruj options table (config menu)
		L.options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db, L.defaults)
		LibStub('AceConfigRegistry-3.0'):RegisterOptionsTable(_, L.options)
		LibStub('AceConfigDialog-3.0'):SetDefaultSize("Nameplates", 915, 600)
				
		-- retardovana oprava az po nacitani configu
		L.options.args.health_power_setup.args.enemy.args.healthbar_dps_colors_setup.args.dps_value_color_2.min = L.config.dps_value_color_1
		L.options.args.health_power_setup.args.enemy.args.healthbar_dps_colors_setup.args.dps_value_color_1.max = L.config.dps_value_color_2

		LGI.RegisterCallback(self, "GroupInSpecT_Update", "AddToPartyTable")
		LGI.RegisterCallback(self, "GroupInSpecT_Remove", "RemoveFromPartyTable")

		LSM:Register("font", "np_font_1", mediaFolder.."fonts\\Alte.ttf")
		LSM:Register("font", "np_font_2", mediaFolder.."fonts\\rotund.ttf")
		LSM:Register("font", "dajova", mediaFolder.."fonts\\Dajova.ttf")
		LSM:Register("sound", "np_healer_sound", mediaFolder.."sounds\\Mercy_Medic.ogg")
		LSM:Register("sound", "np_resource_sound", mediaFolder.."sounds\\finish_him.ogg")
		LSM:Register("sound", "np_sound_1", mediaFolder.."sounds\\tutu.ogg")
		LSM:Register("sound", "np_sound_2", mediaFolder.."sounds\\shockwave.ogg")
		LSM:Register("sound", "np_sound_3", mediaFolder.."sounds\\Attack_the_objective.ogg")
		LSM:Register("sound", "np_charge", mediaFolder.."sounds\\np_charge.ogg")
		LSM:Register("sound", "np_sound_quest", mediaFolder.."sounds\\voicechaton.ogg")
		LSM:Register("sound", "youaretarget", mediaFolder.."sounds\\youaretarget.ogg")
		LSM:Register("sound", "kickfocus", mediaFolder.."sounds\\kickfocus.ogg")
		LSM:Register("sound", "1", mediaFolder.."sounds\\1.ogg")
		LSM:Register("sound", "2", mediaFolder.."sounds\\2.ogg")
		LSM:Register("sound", "3", mediaFolder.."sounds\\3.ogg")
		LSM:Register("sound", "4", mediaFolder.."sounds\\4.ogg")
		LSM:Register("sound", "5", mediaFolder.."sounds\\5.ogg")
		LSM:Register("sound", "Warning", mediaFolder.."sounds\\warning.ogg")
		LSM:Register("sound", "DBM: Defensive", mediaFolder.."sounds\\defensive.ogg")
		LSM:Register("sound", "Reflect", mediaFolder.."sounds\\reflect.ogg")
		LSM:Register("statusbar", "np_cb_texture", mediaFolder.."CBTexture")
		LSM:Register("statusbar", "np_om_texture", mediaFolder.."OMTexture")
		LSM:Register("statusbar", "np_hb_texture_1", mediaFolder.."HBTexture")
		LSM:Register("statusbar", "np_hb_texture_2", mediaFolder.."HBTexture2")
		LSM:Register("statusbar", "np_pb_texture", mediaFolder.."PBTexture")
		LSM:Register("statusbar", "np_out_line", mediaFolder.."outline")
		LSM:Register("statusbar", "np_out_line2", mediaFolder.."outline2")
		LSM:Register("statusbar", "np_target", mediaFolder.."target")
		LSM:Register("statusbar", "np_target2", mediaFolder.."target2")
		LSM:Register("statusbar", "np_out_line_top", mediaFolder.."outlineT")
		LSM:Register("statusbar", "np_out_line_bottom", mediaFolder.."outlineB")
		LSM:Register("statusbar", "np_cb_out_line", mediaFolder.."CBOutline")
		LSM:Register("statusbar", "np_cb_out_line2", mediaFolder.."CBOutline2")
		LSM:Register("statusbar", "mMedia2c", mediaFolder.."mMedia2c")
		LSM:Register("statusbar", "mMedia2f", mediaFolder.."mMedia2f")
		LSM:Register("statusbar", "mMedia2g", mediaFolder.."mMedia2g")
		LSM:Register("statusbar", "np_target3", mediaFolder.."border")
		
		-- zaregistruj prefix pre chat
		C_ChatInfo.RegisterAddonMessagePrefix("NPM")
		
		-- Slash handler /np
		SLASH_NP1 = "/np"
		SlashCmdList["NP"] = function(msg)
			if ( msg == "mark" and not IsModifierKeyDown() ) then
				namePlateMixin:DebugLog("|cff00bbffMarking predefined nameplates.|r")
				self:SetAllRaidMarks()
			elseif ( msg == "mark" and IsModifierKeyDown() ) then
				namePlateMixin:DebugLog("|cff00bbffUnmarking predefined nameplates.|r")
				namePlateMixin:ClearAllRaidMarks()
			elseif msg == "d" then
				L.config.debug = true
				LibStub('AceConfigDialog-3.0'):SelectGroup("Nameplates", "basic_page")
				LibStub('AceConfigDialog-3.0'):Open("Nameplates")
			else
				LibStub('AceConfigDialog-3.0'):Open("Nameplates")
			end
		end
	
		SLASH_RELOADUI1 = "/rl"
		SlashCmdList["RELOADUI"] = ReloadUI

		SLASH_FRAMESTACK1 = "/fs"
		SlashCmdList["FRAMESTACK"] = function()
			LoadAddOn("Blizzard_DebugTools")
			FrameStackTooltip_Toggle()
		end

		CreateFlashFrame()
		
		-- show od hide menu panel
		if L.config.menupanel then
			menuPanel:Show()
		else
			namePlateMixin:DebugLog("|cff00bbffaddon is loaded (/np for setup).|r")
			menuPanel:Hide()
		end
						
		-- odstranenie video sequencii v hre
		local PlayMovie_hook = MovieFrame_PlayMovie
		MovieFrame_PlayMovie = function(...)
			if not L.config.video_scene then
				PlayMovie_hook(...)
			else
				namePlateMixin:DebugLog("|cff00bbffVideo scene has been canceled.|r")
				GameMovieFinished()
			end
		end
				
		if IsAddOnLoaded(_) then
			self:UnregisterEvent('ADDON_LOADED')
			self.ADDON_LOADED = nil
		end
	end
end

function namePlateMixin:OnEvent(event, ...)
	local arg1 = ...
	if ( event == "ADDON_LOADED" ) then
		ChangeBlizzardOptions()
		self:OnAddonLoaded(...)
		
	elseif ( event == "PLAYER_LOGIN" ) then
		self:OnCheckChallengeMode(event)
		self:UpdateNamePlateByOptions("update_all")
		
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		L.config.playersInfo.isInCombat = false
				
	elseif ( event == "PLAYER_REGEN_DISABLED" ) then
		if L.config.auto_mark and L.isSavedMap and ((L.config.auto_mark_groupleader and UnitIsGroupLeader("player")) or not L.config.auto_mark_groupleader) then
			namePlateMixin:DebugLog("|cff00bbffAutomarking predefined nameplates.|r")
			self:SetAllRaidMarks(true)
		end	
		L.config.playersInfo.isInCombat = true
		
	elseif ( event == "PLAYER_TALENT_UPDATE" ) then
		-- pauza 2 sec lebo blizzard
		C_Timer_After(2, function()
			L.selfClass = select(2, UnitClass('player'))
			L.selfSpec = GetSpecialization()
			L.isSelfTank = self:IsUnitTank("player")
						
			if L.selfSpec == 5 then
				L.selfSpec = 1
			end
						
			self:UpdateNamePlateByOptions("nameplate")
			self:UpdateSelfNamePlate()
			classBarMixin:UpdateClassBar()
		end)
		
	elseif ( event == "UNIT_MAXPOWER" ) then
		if arg1 == "player" then
			classBarMixin:UpdateClassBar()
		end
		
	elseif ( event == "VARIABLES_LOADED" ) then
		self:UpdateNamePlateByOptions("cvars")
		
	elseif ( event == "NAME_PLATE_CREATED" ) then
		local namePlateFrameBase = ...;
		self:OnNamePlateCreated(namePlateFrameBase)

	elseif ( event == "NAME_PLATE_UNIT_ADDED" ) then
		local namePlateUnitToken = ...;
		self:OnNamePlateAdded(namePlateUnitToken)

	elseif ( event == "NAME_PLATE_UNIT_REMOVED" ) then
		local namePlateUnitToken = ...;
		self:OnNamePlateRemoved(namePlateUnitToken)
		
	elseif ( event == "RAID_TARGET_UPDATE" ) then
		OnRaidTargetUpdate()
	
	elseif ( event == "DISPLAY_SIZE_CHANGED" ) then
		if not InCombatLockdown() then
			self:SetBaseNamePlateSize()
		end

	elseif ( event == "UNIT_FACTION" ) then
		OnUnitFactionChanged(...)

	elseif ( event == "QUEST_ACCEPTED" or event == "QUEST_REMOVED" or ( event == "UNIT_QUEST_LOG_CHANGED" and arg1 == "player" )) then
		if L.config.quest_detection and not L.isChallengeMapActive then
			C_Timer_After(1, function()
				for _ , namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
					if namePlate.UnitFrame.unitType ~= "self" then
						UpdateQuest(namePlate.UnitFrame)
						UpdateName(namePlate.UnitFrame, "Scenario")
					end
				end
			end)
		end
	
	elseif (event == "SCENARIO_CRITERIA_UPDATE") then 
		if L.config.quest_detection and not L.isChallengeMapActive  then
			local _, _, numCriteria = C_Scenario_GetStepInfo()
			if numCriteria > 0 then
				for _ , namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
					if namePlate.UnitFrame.unitType ~= "self" then
						UpdateQuest(namePlate.UnitFrame)
						UpdateName(namePlate.UnitFrame, "Scenario")
					end
				end
			end
		end

	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		OnCombatLogCheck()
	
	elseif ( event == "CHALLENGE_MODE_START" ) then	
		for guid in pairs(namePlateMixin.PARTY_TABLE) do
			namePlateMixin.PARTY_TABLE[guid].kickCount = 0
			namePlateMixin.PARTY_TABLE[guid].kickCountSucced = 0
			if L.config.player_resource_type == 3 then
				classBarMixin:ClassBarUpdateKick(guid)
			end
		end
		
	elseif ( event == "ZONE_CHANGED_NEW_AREA" ) then
		self:OnCheckChallengeMode(event)
		self:UpdateNamePlateByOptions("nameplate")
	
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if IsInGroup() then
			LGI:Rescan()
		end
		
	elseif ( event == "PLAYER_LEAVING_WORLD" ) then
		L.mapID = nil
		L.isSavedMap = false
		L.isChallengeMapActive = false
		L.instanceFLAG = 0x010
		wipe(NPC_TABLE)
	
	elseif ( event == "CHALLENGE_MODE_COMPLETED" or event == "WORLD_STATE_TIMER_START" or event == "WORLD_STATE_TIMER_STOP") then
		self:OnCheckChallengeMode(event)
		self:UpdateNamePlateByOptions("nameplate")
				
	elseif ( event == "UPDATE_MOUSEOVER_UNIT" ) then
		OnUpdateMouseoverUnit()
				
	elseif ( event == "PLAYER_TARGET_CHANGED" ) then
		UpdateWidgetsOnlyMode(self)
		UpdateWidgetSet(self)
		self:UpdateMyTarget()
				
	elseif ( event == "PLAYER_FOCUS_CHANGED" ) then
		self:UpdateMyFocus()
		
	elseif ( event == "CINEMATIC_START" ) then
		if L.config.cut_scene and not C_QuestLog_IsOnQuest(52042) then
			namePlateMixin:DebugLog("|cff00bbffCinematic scene has been cancelled.|r")
			CinematicFrame_CancelCinematic()
		end
			
	elseif ( event == "CHALLENGE_MODE_KEYSTONE_SLOTTED" ) then
		local mapChallengeModeID, _, keystoneLevel = C_ChallengeMode.GetSlottedKeystoneInfo()
		local _, _, timeLimit = C_ChallengeMode.GetMapUIInfo(mapChallengeModeID)
		local damageMod = C_ChallengeMode.GetPowerLevelDamageHealthMod(keystoneLevel)
		local hexColor = C_ChallengeMode.GetKeystoneLevelRarityColor(keystoneLevel):GenerateHexColor()
		namePlateMixin:DebugLog("|cff00bbffSlotted keystone|r |c"..hexColor..keystoneLevel.."|r ("..damageMod.."%). |cff00bbffTime limit|r |cff20FF20"..namePlateMixin:FormatTime(timeLimit).."|r |cff00bbff.|r", 6, false, false)
			
	elseif ( event == "CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN" ) then
		local f = CreateFrame("Button", "ChallengesKeystoneCD", _G["ChallengesKeystoneFrame"], "MagicButtonTemplate")
		local LMB, RMB = CreateAtlasMarkup("NPE_LeftClick", 18, 18), CreateAtlasMarkup("NPE_RightClick", 18,18)
		f:SetPoint("TOPLEFT", _G["ChallengesKeystoneFrame"].StartButton, "TOPRIGHT");
		f:SetText(LMB.." CD 10")
				
		if IsAddOnLoaded("ElvUI") and ElvUI then
			ElvUI[1]:GetModule('Skins'):HandleButton(f)
			f:ClearAllPoints()
			f:SetPoint("TOPLEFT", _G["ChallengesKeystoneFrame"].StartButton, "TOPRIGHT", 2, 0)
		end
		
		f:SetScript("OnClick", function(self, button)
			if IsInGroup() then
				if button ==  "LeftButton" then
					self:SetText(RMB.." STOP")
					C_PartyInfo.DoCountdown(10)
				elseif  button == "RightButton"then
					self:SetText(LMB.." CD 10")
					C_PartyInfo.DoCountdown(0)
				end
			else
				namePlateMixin:DebugLog("|cff00bbffYou are not in group.|r")
			end
		end)
				
		f:SetMotionScriptsWhileDisabled(true) -- OnEnter a OnLeave, aj keď je zakázané
		f:Hide()
	
		if L.config.mythic_push_key then
			for bagID = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
				local numSlots = GetContainerNumSlots(bagID)
				for slot = 1, numSlots do
					local slotLinkInfo = GetContainerItemInfo(bagID, slot)
					if slotLinkInfo and slotLinkInfo.hyperlink and slotLinkInfo.hyperlink:match("|Hkeystone:") then
						PickupContainerItem(bagID, slot)
						if CursorHasItem() then
							C_ChallengeMode.SlotKeystone()
							if C_ChallengeMode.HasSlottedKeystone() then
								local mapChallengeModeID, _, keystoneLevel = C_ChallengeMode.GetSlottedKeystoneInfo()
								local _, _, timeLimit = C_ChallengeMode.GetMapUIInfo(mapChallengeModeID)
								local damageMod = C_ChallengeMode.GetPowerLevelDamageHealthMod(keystoneLevel)
								SendChatMessage("Slotted keystone "..keystoneLevel.." ("..damageMod.."%). Time limit "..namePlateMixin:FormatTime(timeLimit).."." , IsInGroup() and namePlateMixin:InstanceOrParty() or "SAY")
								ChallengesKeystoneCD:Show()
							end
						end
					end
				end
			end
		end
	
	elseif ( event == "CHAT_MSG_ADDON" ) then
		local prefix, str = ...
		local myName = UnitName("player")
		if self:MultiCheck(myName, "Æn", "Aene", "Asaen", "Asen", "Ðæ", "Ðæn", "Pampallini", "Taet", "Twax", "Väa", "Wæn", "Wæne", "Wanæ", "Xae", "Xea", "Xiq", "Awæn") then
			if prefix == "NPM" and not string_find(str, myName) then
				textPanelMixin:ShowText(str, 10)
			end
		end
		
	elseif ( event == "GROUP_JOINED" ) then
		local chatType = self:InstanceOrParty()
		if chatType ~= false then
			C_ChatInfo.SendAddonMessage("NPM", UnitName("player").." - ".._G.GetAddOnMetadata("Nameplates", "Version"), chatType)
		end		
	end
end


function namePlateMixin:OnUpdate(elapsed)
	if L.config.mouseover_enable then
		if hasMouseover and not UnitExists("mouseover") then
			hasMouseover = false
			for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
				if namePlate.UnitFrame.isMouseover then 
					namePlate.UnitFrame.isMouseover = false
					UpdateHealthBar(namePlate.UnitFrame, false, "OnUpdate")
				end
			end
		end
	end
	
	self.elapsed = (self.elapsed or 0) + elapsed
	if self.elapsed < .5 then return end
	self.elapsed = 0

	-- zvysok vykonaj max 2 krat za sec
	if L.config.show_range then
		for _, namePlate in pairs(C_NamePlate_GetNamePlates(issecure())) do
			if namePlate then
				if ((L.config.range_only_on_target and namePlate.UnitFrame.isPlayerTarget) or not L.config.range_only_on_target) and not namePlate.UnitFrame.unitType ~= "self" then
					local minRange, maxRange = RCH:GetRange(namePlate.UnitFrame.unit)
					if L.config.range_format == 0 then
						namePlate.UnitFrame.rangeText:SetText(minRange)
					elseif L.config.range_format == 1 then
						namePlate.UnitFrame.rangeText:SetText(maxRange)
					elseif L.config.range_format == 2 then
						namePlate.UnitFrame.rangeText:SetText(minRange .. "-" .. maxRange)
					end
					namePlate.UnitFrame.rangeText:Show()
				else
					namePlate.UnitFrame.rangeText:Hide()
				end
			end
		end
	end
	
	-- Touch of Death or Spell Reflect
	if (L.config.classSpell_ToD and L.selfClass == 'MONK') or (L.config.classSpell_SR and L.selfClass == 'WARRIOR') then
		local test = self:IsSpellReady(L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.spellID)
		if L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.ready ~= test then
			L.config.playersInfo[L.selfClass][L.selfSpec].classSpell.ready = test
			if L.selfClass == 'MONK' then
				self:UpdateNamePlateByOptions("nameplate")
			end
		end
	end
end

function namePlateMixin:OnLoad()
	for _, event in pairs({
		"ADDON_LOADED",
		"PLAYER_LOGIN",
		"VARIABLES_LOADED",
		"PLAYER_REGEN_ENABLED",
		"PLAYER_REGEN_DISABLED",
		"PLAYER_TALENT_UPDATE",
		"NAME_PLATE_CREATED",
		"NAME_PLATE_UNIT_ADDED",
		"NAME_PLATE_UNIT_REMOVED",
		"RAID_TARGET_UPDATE",
		"DISPLAY_SIZE_CHANGED",
		"UNIT_MAXPOWER",
		"UNIT_FACTION",
		--"QUEST_ACCEPTED",
		--"QUEST_REMOVED",
		"UNIT_QUEST_LOG_CHANGED",
		"SCENARIO_CRITERIA_UPDATE",
		"COMBAT_LOG_EVENT_UNFILTERED",
		"ZONE_CHANGED_NEW_AREA",
		"PLAYER_LEAVING_WORLD",
		"PLAYER_ENTERING_WORLD",
		"CHALLENGE_MODE_START", -- az ked je chalenge mapa ?
		"CHALLENGE_MODE_COMPLETED",
		"WORLD_STATE_TIMER_START",
		"WORLD_STATE_TIMER_STOP",
		"CHALLENGE_MODE_KEYSTONE_SLOTTED",
		"CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN",
		"UPDATE_MOUSEOVER_UNIT",
		"PLAYER_TARGET_CHANGED",
		"PLAYER_FOCUS_CHANGED",
		"CINEMATIC_START",
		"CHAT_MSG_ADDON",
		"GROUP_JOINED",
	}) do self:RegisterEvent(event) end
end